--	SMH - Simply Magical Healer
--	Written by scott@mithrandir.com
--	Scott's attempt to do something initially based on DruidPartyHeal and Healomatic
--	but with inspiration and code derived from many.
--	Official website:  http://www.mithrandir.com/WorldOfWarcraft/WoW.html

--	An assumption is that the localization.lua (and/or its localized versions) will
--	be loaded prior to this file so the localizable strings will be defined.

SMH_File_Version = 09921;
if not SMH or SMH.addonVersionNumber < SMH_File_Version then
	SMH_CLASS_ENGLISH_DRUID	  = 'DRUID';
	SMH_CLASS_ENGLISH_PALADIN = 'PALADIN';
	SMH_CLASS_ENGLISH_PRIEST  = 'PRIEST';
	SMH_CLASS_ENGLISH_SHAMAN  = 'SHAMAN';
	SMH_Configuration = {};
SMH = {
	addonMacroCommand = "/smh",
	addonName = "SMH",
	addonVersion = "0.9.9.2.1",
	addonVersionNumber = SMH_File_Version,

	algorithmAddingSpell,			-- used to keep track of spell being added to algorithm
	allClasses = { SMH_CLASS_DRUID, SMH_CLASS_HUNTER, SMH_CLASS_MAGE, SMH_CLASS_PALADIN, SMH_CLASS_PRIEST, SMH_CLASS_ROGUE, SMH_CLASS_SHAMAN, SMH_CLASS_WARLOCK, SMH_CLASS_WARRIOR },
	buffCancels = {		-- if the recipient has a (de)buff in the value list, the buff in the key will not be cast on them
		[SMH_SPELL_MARK_OF_THE_WILD] = { SMH_SPELL_GIFT_OF_THE_WILD },
		[SMH_SPELL_POWER_WORD_SHIELD] = { SMH_SPELL_WEAKENED_SOUL },
		},
	buffCasterHealingEffects = {
		[SMH_BUFF_POWER_INFUSION] = 20,
		},
	buffCasterPlusHealingEffects = {
		[SMH_BUFF_PRAYER_BEADS_BLESSING] = 190,
		[SMH_BUFF_EPHEMERAL_POWER] = 175,
		[SMH_BUFF_HEALING_OF_THE_AGES] = 350,
		[SMH_BUFF_ESSENCE_OF_SAPPHIRON] = 130,
		[SMH_BUFF_THE_EYE_OF_THE_DEAD] = 450,
		[SMH_BUFF_ASCENDANCE] = 75,
		[SMH_BUFF_CRUSADERS_WRATH] = 95,
		[SMH_BUFF_CHROMATIC_INFUSION] = 190,
		[SMH_BUFF_THE_FURIOUS_STORM] = 95,
		[SMH_BUFF_TOASTED_SMORC] = 44,
		[SMH_BUFF_SWEET_SURPRISE] = 44,
		[SMH_BUFF_POWER_OF_THE_GUARDIAN] = 62,
		},
	buffsCancellingCasting = { [SMH_BUFF_BAT_COSTUME] = true, [SMH_BUFF_SNOWMAN] = true, },
	buffsOfInterest = { },
	buffTargetHealingEffects = {
		[SMH_BUFF_CURSE_OF_THE_DEADWOOD] = -50,
		[SMH_BUFF_MORTAL_WOUND] = -10,
		[SMH_BUFF_VEIL_OF_SHADOW] = -75,
		[SMH_BUFF_BLOOD_FURY] = -50,
		[SMH_BUFF_BROOD_AFFLICATION_GREEN] = -50,
		[SMH_BUFF_MORTAL_STRIKE] = -50,
		[SMH_BUFF_MORTAL_CLEAVE] = -50,
		[SMH_BUFF_GEHENNAS_CURSE] = -75,
		[SMH_BUFF_HEX_OF_WEAKNESS] = -20,
		[SMH_BUFF_NECROTIC_POISON] = -90,
		},
	cachedSpellBookData = { },
	cachedSpellTargetLevels = {
		[SMH_SPELL_HEALING_TOUCH] = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
		[SMH_SPELL_REGROWTH] = { 12, 18, 24, 30, 36, 42, 48, 54, 60 },
		[SMH_SPELL_REJUVENATION] = { 4, 10, 16, 22, 28, 34, 40, 46, 52, 58, 60 },
		[SMH_SPELL_HOLY_LIGHT] = { 1, 1, 1, 1, 1, 1, 1, 1, 1 },
		[SMH_SPELL_FLASH_OF_LIGHT] = { 1, 1, 1, 1, 1, 1 },
		[SMH_SPELL_LESSER_HEAL] = { 1, 1, 1 },
		[SMH_FAKE_SPELL_COMBINED_HEAL] = { 1, 1, 1, 1, 1, 1, 1, 1, 1 },
		[SMH_SPELL_RENEW] = { 8, 14, 20, 26, 32, 38, 44, 50, 56, 60 },
		[SMH_SPELL_FLASH_HEAL] = { 1, 1, 1, 1, 1, 1, 1 },
		[SMH_SPELL_DESPERATE_PRAYER] = { 1, 1, 1, 1, 1, 1, 1 },
		[SMH_SPELL_POWER_WORD_SHIELD] = { 6, 12, 18, 24, 30, 36, 42, 48, 54, 60 },
		[SMH_SPELL_HEALING_WAVE] = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
		[SMH_SPELL_LESSER_HEALING_WAVE] = { 1, 1, 1, 1, 1, 1 },

		[SMH_SPELL_MARK_OF_THE_WILD] = { 1, 10, 20, 30, 40, 50, 60 },
		[SMH_SPELL_THORNS] = { 6, 14, 24, 34, 44, 54 },
		[SMH_SPELL_POWER_WORD_FORTITUDE] = { 1, 12, 24, 36, 48, 60 },
		[SMH_SPELL_DIVINE_SPIRIT] = { 30, 40, 50, 60 },
		[SMH_SPELL_SHADOW_PROTECTION] = { 30, 42, 56 },
		[SMH_SPELL_BLESSING_OF_MIGHT] = { 4, 12, 22, 32, 42, 52, 60 },
		[SMH_SPELL_BLESSING_OF_PROTECTION] = { 10, 24, 38 },
		[SMH_SPELL_BLESSING_OF_WISDOM] = { 14, 24, 34, 44, 54, 60 },
		[SMH_SPELL_BLESSING_OF_LIGHT] = { 40, 50, 60 },
		[SMH_SPELL_BLESSING_OF_SACRIFICE] = { 46, 54 },
		},
	canHaveDesperatePrayer = false,		-- used to determine whether the character can possibly have Desperate Prayer
	castingTimeReadProperly = false,	-- used to indicate whether the casting time being read from tooltips has been modified by a buff to make casts instant
	class = "None",				-- class of the player.  used to determine whether we should enable the addon.
	classAttacksOfInterest = {
		[SMH_CLASS_ENGLISH_DRUID] = { SMH_SPELL_MOONFIRE },
		[SMH_CLASS_ENGLISH_PALADIN] = { },
		[SMH_CLASS_ENGLISH_PRIEST] = { },
		[SMH_CLASS_ENGLISH_SHAMAN] = { },
		},
	classBuffsOfInterest = {
		[SMH_CLASS_ENGLISH_DRUID] = { SMH_SPELL_MARK_OF_THE_WILD, SMH_SPELL_THORNS },
		[SMH_CLASS_ENGLISH_PALADIN] = { SMH_SPELL_BLESSING_OF_MIGHT, SMH_SPELL_BLESSING_OF_PROTECTION, SMH_SPELL_BLESSING_OF_WISDOM, SMH_SPELL_BLESSING_OF_LIGHT, SMH_SPELL_BLESSING_OF_SACRIFICE },
		[SMH_CLASS_ENGLISH_PRIEST] = { SMH_SPELL_POWER_WORD_SHIELD, SMH_SPELL_POWER_WORD_FORTITUDE, SMH_SPELL_DIVINE_SPIRIT, SMH_SPELL_SHADOW_PROTECTION },
		[SMH_CLASS_ENGLISH_SHAMAN] = { }, -- shamans do not do buffs in which we have interest
		},
	classSpellsOfInterest = {
		[SMH_CLASS_ENGLISH_DRUID] = { SMH_SPELL_HEALING_TOUCH, SMH_SPELL_REGROWTH, SMH_SPELL_REJUVENATION },
		[SMH_CLASS_ENGLISH_PALADIN] = { SMH_SPELL_FLASH_OF_LIGHT, SMH_SPELL_HOLY_LIGHT },
		[SMH_CLASS_ENGLISH_PRIEST] = { SMH_SPELL_FLASH_HEAL, SMH_FAKE_SPELL_COMBINED_HEAL, SMH_SPELL_LESSER_HEAL, SMH_SPELL_RENEW },
		[SMH_CLASS_ENGLISH_SHAMAN] = { SMH_SPELL_HEALING_WAVE, SMH_SPELL_LESSER_HEALING_WAVE },
		},
	classesPermittedToUseAddon = {
		[SMH_CLASS_ENGLISH_DRUID] = true,
		[SMH_CLASS_ENGLISH_PALADIN] = true,
		[SMH_CLASS_ENGLISH_PRIEST] = true,
		[SMH_CLASS_ENGLISH_SHAMAN] = true,
		},
	colorBlue = "|cFF0000FF",
	colorGreen = "|cFF00FF00",
	colorOrange = "|cFFFF7F00",
	colorRed = "|cFFFF0000",
	colorStop = "|r",
	colorYellow = "|cFFFFFF00",
	commandBuffs = { },
	commandFunctions = { },
	commandHeals = { },
	commandParameters = { },
	--	Two variables are used.  The first is the set of defaults that are always present in the system.
	--	These are the values that are used when the user resets the options to default status.  This is
	--	also used to ensure the user's stored variables have the proper keys in them.  The second variable
	--	are the actual option values that the user sets.  These are persistent between runs of the program
	--	and work across versions of this addon because we check to ensure old keys are removed and new
	--	keys are added after the stored variable is loaded.
	configurationDefaults = {
		["targetPriority"] = true,		-- indicates whether the "target" has priority over all else
		["healPercentage"] = 50,		-- indicates the percentage of the possible heal range to use to compare to the target's health
		["healingPets"] = true,			-- indicates whether party pets are considered in the healing list
		["checkingNaturesSwiftness"] = true,	-- indicates whether we think about casting Nature's Swiftness automatically as part of heal process
		["threshold"] = 100,			-- indicates percentage of health target must be below to be considered for healing
		["petThreshold"] = 100,			-- indicates percentage of health pets must be below to be considered for healing
		["selfThreshold"] = 40,			-- indicates percentage of health self must be below to be forced to head of healing list
		["healingRaid"] = true,			-- indicates whether raid members are to be healed
		["healingRaidPets"] = true,		-- indicates whether raid pets are to be healed
		["partyOverRaid"] = true,		-- indicates whether the party has priority over the raid for healing
		["healsParty"] = true,			-- indicates whether parts members other than self are healed
		["minimapButtonAngle"] = 356,		-- indicates the angle around the minimap for the location of the button that toggles options UI
		["priorityRaidGroup1"] = false,		-- indicates members of raid group 1 are given priority
		["priorityRaidGroup2"] = false,		-- indicates members of raid group 2 are given priority
		["priorityRaidGroup3"] = false,		-- indicates members of raid group 3 are given priority
		["priorityRaidGroup4"] = false,		-- indicates members of raid group 4 are given priority
		["priorityRaidGroup5"] = false,		-- indicates members of raid group 5 are given priority
		["priorityRaidGroup6"] = false,		-- indicates members of raid group 6 are given priority
		["priorityRaidGroup7"] = false,		-- indicates members of raid group 7 are given priority
		["priorityRaidGroup8"] = false,		-- indicates members of raid group 8 are given priority
		["priorityRaidPets"] = false,		-- indicates that pets of groups that have priority get the same priority
		["classPriorities"] = {
			[SMH_CLASS_DRUID] = 2,
			[SMH_CLASS_HUNTER] = 2,
			[SMH_CLASS_MAGE] = 2,
			[SMH_CLASS_PALADIN] = 2,
			[SMH_CLASS_PRIEST] = 2,
			[SMH_CLASS_ROGUE] = 2,
			[SMH_CLASS_SHAMAN] = 2,
			[SMH_CLASS_WARLOCK] = 2,
			[SMH_CLASS_WARRIOR] = 2,
			},				-- indicates the priority that classes have
		["classPriorityOverParty"] = false,	-- indicates high priority classes have higher priority than party members
		["charactersPriorityHigh"] = { },	-- indicates characters that have the highest priority
		["charactersPriorityLow"] = { },	-- indicates characters that have low priority
		["charactersPriorityIgnored"] = { },	-- indicates characters that will not be healed
		["shouldDisplayProfile"] = false,	-- indicates whether the profile will be displayed in the mini profile window
		["outOfGroup"] = true,			-- indicates whether high priority characters are healed even if party and/or raid are not
		["healsTargetsTarget"] = false,		-- indicates whether the target's target is healed
		["buffsTarget"] = true,			-- indicates whether buffs will be cast on the target
		["buffsParty"] = true,			-- indicates whether buffs will be cast on party members
		["buffsPets"] = false,			-- indicates whether buffs will be cast on party pets
		["buffsRaid"] = false,			-- indicates whether buffs will be cast on raid members
		["buffsRaidPets"] = false,		-- indicates whether buffs will be cast on raid pets
		["buffFailOnLowMana"] = true,		-- indicates that a buff will only be cast at highest rank (and fail if not enough mana to cast it)
		["targetRecipient"] = false,		-- controls whether the spell recipient becomes the new target
		["doNotHealBelowLevel"] = 1,		-- indicates the level below which characters will not be healed
		["classHealPercents"] = {
			[SMH_CLASS_DRUID] = 100,
			[SMH_CLASS_HUNTER] = 100,
			[SMH_CLASS_MAGE] = 100,
			[SMH_CLASS_PALADIN] = 100,
			[SMH_CLASS_PRIEST] = 100,
			[SMH_CLASS_ROGUE] = 100,
			[SMH_CLASS_SHAMAN] = 100,
			[SMH_CLASS_WARLOCK] = 100,
			[SMH_CLASS_WARRIOR] = 100,
			},				-- indicates the healing percentages that classes have (for underheal and overheal)
		["otherHealerConfidence"] = 100,	-- indicates how confident one is in the amount being healed by other SMH users...as a percentage
		["usesCTRARaidChannel"] = false,	-- for the raid channel, this indicates whether the CTRA raid channel should be used
		["algorithmFallthrough"] = false,	-- indicates whether the algorithm will fall through to the next choice if current not allowed
		["messagePlaces"] = {
			["CAST"] = 4,
			["INFO"] = 1,
			["ERROR"] = 1,
			["TIER"] = 0,
			["DEBUG"] = 0,
			["CASTNOPARTY"] = 1,
			},				-- indicates the default placement of message types
		},
	currentOtherHeals = { },		-- heals by other users of this addon that are not yet complete
	currentOtherHealsByCharacter = { },	-- above heals sorted by character name
	currentTab = 0,				-- indicates current tab for use for refresh when profile changes
	debuffsCancellingCasting = { [SMH_BUFF_BROOD_POWER_BRONZE] = true, [SMH_BUFF_CALL_OF_THE_FOREST] = true, [SMH_BUFF_CORRUPTED_FEAR] = true, [SMH_BUFF_FEAR] = true,
					[SMH_BUFF_FELL_CURSE_EFFECT] = true, [SMH_BUFF_PESTER_EFFECT] = true, [SMH_BUFF_SMOTHER] = true, [SMH_BUFF_STONE_SLUMBER] = true, },
	defaultCastTimes = {
		[SMH_SPELL_HEALING_TOUCH] = { 1.5, 2, 2.5, 3, 3.5, 3.5, 3.5, 3.5, 3.5, 3.5, 3.5 },
		[SMH_SPELL_REGROWTH] = { 2, 2, 2, 2, 2, 2, 2, 2, 2 },
		[SMH_SPELL_REJUVENATION] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
		[SMH_SPELL_HOLY_LIGHT] = { 2.5, 2.5, 2.5, 2.5, 2.5, 2.5, 2.5, 2.5, 2.5 },
		[SMH_SPELL_FLASH_OF_LIGHT] = { 1.5, 1.5, 1.5, 1.5, 1.5, 1.5 },
		[SMH_SPELL_LESSER_HEAL] = { 1.5, 2, 2.5 },
		[SMH_FAKE_SPELL_COMBINED_HEAL] = { 3, 3, 3, 3, 3, 3, 3, 3, 3 },
		[SMH_SPELL_HEAL] = { 3, 3, 3, 3 },
		[SMH_SPELL_GREATER_HEAL] = { 3, 3, 3, 3, 3 },
		[SMH_SPELL_RENEW] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
		[SMH_SPELL_FLASH_HEAL] = { 1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 1.5 },
		[SMH_SPELL_DESPERATE_PRAYER] = { 0, 0, 0, 0, 0, 0, 0 },
		[SMH_SPELL_POWER_WORD_SHIELD] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
		[SMH_SPELL_HEALING_WAVE] = { 1.5, 2, 2.5, 3, 3, 3, 3, 3, 3, 3 },
		[SMH_SPELL_LESSER_HEALING_WAVE] = { 1.5, 1.5, 1.5, 1.5, 1.5, 1.5 },
		--	These values are not important
		[SMH_SPELL_MARK_OF_THE_WILD] = { 0, 0, 0, 0, 0, 0, 0 },
		[SMH_SPELL_THORNS] = { 0, 0, 0, 0, 0, 0 },
		[SMH_SPELL_POWER_WORD_FORTITUDE] = { 0, 0, 0, 0, 0, 0 },
		[SMH_SPELL_DIVINE_SPIRIT] = { 0, 0, 0, 0 },
		[SMH_SPELL_SHADOW_PROTECTION] = { 0, 0, 0 },
		[SMH_SPELL_BLESSING_OF_MIGHT] = { 0, 0, 0, 0, 0, 0, 0 },
		[SMH_SPELL_BLESSING_OF_PROTECTION] = { 0, 0, 0 },
		[SMH_SPELL_BLESSING_OF_WISDOM] = { 0, 0, 0, 0, 0, 0 },
		[SMH_SPELL_BLESSING_OF_LIGHT] = { 0, 0, 0 },
		[SMH_SPELL_BLESSING_OF_SACRIFICE] = { 0, 0 },
		[SMH_SPELL_MOONFIRE] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
		},
	defaultSpellIcons = {
		[SMH_SPELL_REGROWTH] = "Interface\\Icons\\Spell_Nature_ResistNature",
		[SMH_SPELL_REJUVENATION] = "Interface\\Icons\\Spell_Nature_Rejuvenation",
		[SMH_SPELL_HEALING_TOUCH] = "Interface\\Icons\\Spell_Nature_HealingTouch",
		[SMH_SPELL_HOLY_LIGHT] = "Interface\\Icons\\Spell_Holy_HolyBolt",
		[SMH_SPELL_FLASH_OF_LIGHT] = "Interface\\Icons\\Spell_Holy_FlashHeal",
		[SMH_SPELL_LESSER_HEAL] = "Interface\\Icons\\Spell_Holy_LesserHeal",
		[SMH_FAKE_SPELL_COMBINED_HEAL] = "Interface\\Icons\\Spell_Holy_GreaterHeal",
		[SMH_SPELL_RENEW] = "Interface\\Icons\\Spell_Holy_Renew",
		[SMH_SPELL_FLASH_HEAL] = "Interface\\Icons\\Spell_Holy_FlashHeal",
		[SMH_SPELL_POWER_WORD_SHIELD] = "Interface\\Icons\\Spell_Holy_PowerWordShield",
		[SMH_SPELL_DESPERATE_PRAYER] = "Interface\\Icons\\Spell_Holy_Restoration",
		[SMH_SPELL_HEALING_WAVE] = "Interface\\Icons\\Spell_Nature_HealingWaveGreater",
		[SMH_SPELL_LESSER_HEALING_WAVE] = "Interface\\Icons\\Spell_Nature_HealingWaveLesser",
		},
	eventDispatch = {			-- table of functions whose keys are the events
		['ACTIONBAR_SLOT_CHANGED'] = function(self, arg1)
			--	arg1 tells us the slot that has changed
			if (self.slotHealing == nil or self.slotHealing == arg1
				or self.slotBuff == nil or self.slotBuff == arg1
				or (self.slotSwiftNature == nil and (self.class == SMH_CLASS_ENGLISH_DRUID or self.class == SMH_CLASS_ENGLISH_SHAMAN)) or self.slotSwiftNature == arg1
				or (self.slotPowerWordShield == nil and self.class == SMH_CLASS_ENGLISH_PRIEST) or self.slotPowerWordShield == arg1
				or (self.slotDesperatePrayer == nil and self.class == SMH_CLASS_PRIEST_ENGLIGH and self.canHaveDesperatePrayer) or self.slotDesperatePrayer == arg1
				) then
				self:FindHealingSlot()
			end
		end,
		['CHARACTER_POINTS_CHANGED'] = function(self, arg1)
			--	arg1 tells us the delta in talent points
			if (arg1 == -1) then
				self:CacheSpellBookData()	-- because spell tooltips are modified based on talents
				if self.class == SMH_CLASS_ENGLISH_PRIEST then
					self:ProcessTalents()
				end
			end
			if arg1 == 1 then	-- a level is gained
				if self.spritualGuidanceTalentRank > 0 then
					self:UpdateSpiritualGuidanceData()
				end
			end
		end,
		['CHAT_MSG_ADDON'] = function(self, arg1, arg2, arg3, arg4)
			if arg1 == "SMH" then
				self:ChannelMessageProcess(arg2, arg4)
			end
		end,
		['LEARNED_SPELL_IN_TAB'] = function(self)
			self:CacheSpellBookData()
		end,
		['PLAYER_ENTERING_WORLD'] = function(self)
			if self.class == SMH_CLASS_ENGLISH_PRIEST then
				self:ProcessTalents()
				if self.spritualGuidanceTalentRank > 0 then
					self:UpdateSpiritualGuidanceData()
				end
			end
			self:CacheSpellBookData()
			self:FindHealingSlot()
			self:CacheEquipmentData()
			self:UpdateTotalPlusHealingText()
			this:RegisterEvent("ACTIONBAR_SLOT_CHANGED")
			this:RegisterEvent("UNIT_INVENTORY_CHANGED")
			this:RegisterEvent("CHARACTER_POINTS_CHANGED")
			this:RegisterEvent("LEARNED_SPELL_IN_TAB")
			this:RegisterEvent("UNIT_AURA")
			this:RegisterEvent("SPELLCAST_FAILED")
			this:RegisterEvent("SPELLCAST_INTERRUPTED")
			this:RegisterEvent("SPELLCAST_STOP")
			this:RegisterEvent("CHAT_MSG_ADDON")
			--	Now we set up the OnUpdate handling which we use to attempt to detect movement
			--	and we clear it in case we are in an instance, thereby attempting to make this
			--	addon really quick in an instance, because detecting movement does not work in
			--	an instance.
			if IsInInstance() then
				this:SetScript("OnUpdate", nil)
				self.isMoving = false
			else
				this:SetScript("OnUpdate", function() self:MainFrame_OnUpdate() end)
			end
		end,
		['PLAYER_LEAVING_WORLD'] = function(self)
			this:UnregisterEvent("ACTIONBAR_SLOT_CHANGED")
			this:UnregisterEvent("UNIT_INVENTORY_CHANGED")
			this:UnregisterEvent("CHARACTER_POINTS_CHANGED")
			this:UnregisterEvent("LEARNED_SPELL_IN_TAB")
			this:UnregisterEvent("UNIT_AURA")
		end,
		['SPELLCAST_FAILED'] = function(self, arg1)
			if self.initiatedCast then
				self:OutputChannelMessageStop(nil, "FAIL")
				self.initiatedCast = false
			end
		end,
		['SPELLCAST_INTERRUPTED'] = function(self, arg1)
			if self.initiatedCast then
				self:OutputChannelMessageStop(nil, "INTERRUPT")
				self.initiatedCast = false
			end
		end,
		['SPELLCAST_STOP'] = function(self, arg1)
			if self.initiatedCast then
				self:OutputChannelMessageStop(nil, "STOP")
				self.initiatedCast = false
			end
		end,
		['UNIT_AURA'] = function(self, arg1)
			if (arg1 == 'player') then
				if self.spritualGuidanceTalentRank > 0 then
					self:UpdateSpiritualGuidanceData()
				end
				if not self.castingTimeReadProperly then
					self:CacheSpellBookData()
				end
			end
		end,
		['UNIT_INVENTORY_CHANGED'] = function(self, arg1)
			--	arg1 tells us what unit had the inventory change
			if (arg1 == 'player') then
				self:CacheEquipmentData()
				self:UpdateTotalPlusHealingText()
				if self.spritualGuidanceTalentRank > 0 then
					self:UpdateSpiritualGuidanceData()
				end
			end
		end,
		['VARIABLES_LOADED'] = function(self)
			self:Init()
		end,
		},
	equipmentSlots = { "Head", "Neck", "Shoulder", "Back", "Chest", "Shirt", "Tabard", "Wrist", "Hands", "Waist", "Legs", "Feet", "Finger0", "Finger1", "Trinket0", "Trinket1", "MainHand", "SecondaryHand", "Ranged" },
	extraHealingAmount = 0,			-- amount of extra healing that is done by equipment
	extraHealingAmountPossible = 0,		-- amount of extra healing that is done by equipment if all were not broken
	gettingRegrowthSoon = { },		-- used to record who is getting a Regrowth so Druids do not attempt to cast it on them
	hasBenefitDreamwalker = false,		-- used to indicate whether the Dreamwalker set bonus for healing is present
	hasBenefitStormrage = false,		-- used to indicate whether the Stormrage set bonus for healing is present
	hasBenefitTranscendance = false,	-- used to indicate whether the Transcendance set bonus for healing is present
	hasBrokenPlusHealingItems = false,	-- indicates whether there are +healing items that are broken and therefore not included in the total
	hasItemIdolOfRejuvenation = 0,		-- used to indicate the number of +healing points for Rejuvenation the item gives
	hasItemLibramOfDivinity = 0,		-- used to indicate the number of +healing points for Flash of Light the item gives
	hasItemLibramOfLight = 0,		-- used to indicate the number of +healing points for Flash of Light the item gives
	hasItemTotemOfLife = 0,			-- used to indicate the number of +healing points for Lesser Healing Wave the item gives
	hasItemTotemOfSustaining = 0,		-- used to indicate the number of +healing points for Lesser Healing Wave the item gives
	--	The desired spell names are not localized since they are only used in debug messages.
	--	Don't change the order of this table since references require the same order.
	healingModeConfiguration = {
		{ ["nuke"] = { SMH_SPELL_REGROWTH, SMH_SPELL_REJUVENATION }, ["desire"] = "Healing Touch" },
		{ ["nuke"] = { SMH_SPELL_HEALING_TOUCH, SMH_SPELL_REJUVENATION }, ["desire"] = "Regrowth" },
		{ ["nuke"] = { SMH_SPELL_HEALING_TOUCH, SMH_SPELL_REGROWTH }, ["desire"] = "Rejuvenation" },
		{ ["nuke"] = { SMH_SPELL_FLASH_OF_LIGHT }, ["desire"] = "Holy Light" },
		{ ["nuke"] = { SMH_SPELL_HOLY_LIGHT }, ["desire"] = "Flash of Light" },
		{ ["nuke"] = { SMH_FAKE_SPELL_COMBINED_HEAL, SMH_SPELL_RENEW, SMH_SPELL_FLASH_HEAL, SMH_SPELL_POWER_WORD_SHIELD, SMH_SPELL_DESPERATE_PRAYER }, ["desire"] = "Lesser Heal" },
		{ ["nuke"] = { SMH_SPELL_LESSER_HEAL, SMH_SPELL_RENEW, SMH_SPELL_FLASH_HEAL, SMH_SPELL_POWER_WORD_SHIELD, SMH_SPELL_DESPERATE_PRAYER }, ["desire"] = "(Greater) Heal" },
		{ ["nuke"] = { SMH_SPELL_LESSER_HEAL, SMH_FAKE_SPELL_COMBINED_HEAL, SMH_SPELL_RENEW, SMH_SPELL_FLASH_HEAL, SMH_SPELL_POWER_WORD_SHIELD }, ["desire"] = "Desperate Prayer" },
		{ ["nuke"] = { SMH_SPELL_LESSER_HEAL, SMH_FAKE_SPELL_COMBINED_HEAL, SMH_SPELL_FLASH_HEAL, SMH_SPELL_POWER_WORD_SHIELD, SMH_SPELL_DESPERATE_PRAYER }, ["desire"] = "Renew" },
		{ ["nuke"] = { SMH_SPELL_LESSER_HEAL, SMH_FAKE_SPELL_COMBINED_HEAL, SMH_SPELL_RENEW, SMH_SPELL_POWER_WORD_SHIELD, SMH_SPELL_DESPERATE_PRAYER }, ["desire"] = "Flash Heal" },
		{ ["nuke"] = { SMH_SPELL_LESSER_HEALING_WAVE }, ["desire"] = "Healing Wave" },
		{ ["nuke"] = { SMH_SPELL_HEALING_WAVE }, ["desire"] = "Lesser Healing Wave" },
		{ ["nuke"] = { SMH_SPELL_LESSER_HEAL, SMH_FAKE_SPELL_COMBINED_HEAL, SMH_SPELL_RENEW, SMH_SPELL_FLASH_HEAL, SMH_SPELL_DESPERATE_PRAYER }, ["desire"] = "Power Word: Shield" },
		},
	healingEfficiency = 100,		-- used to indicate how efficient a heal will be.  mostly target debuffs lower this.
	initiatedCast = false,			-- used to indicate we are casting using the addon
	isMoving = false,			-- determined using above two variables
	lastX = 0,				-- where we last were in X
	lastY = 0,				-- where we last were in Y
	levelLearned = {
		[SMH_SPELL_HEALING_TOUCH] = { 1, 8, 14, 20, 26, 32, 38, 44, 50, 56, 60 },
		[SMH_SPELL_REGROWTH] = { 12, 18, 24, 30, 36, 42, 48, 54, 60 },
		[SMH_SPELL_REJUVENATION] = { 4, 10, 16, 22, 28, 34, 40, 46, 52, 58, 60 },
		[SMH_SPELL_HOLY_LIGHT] = { 1, 6, 14, 22, 30, 38, 46, 54, 60 },
		[SMH_SPELL_FLASH_OF_LIGHT] = { 20, 26, 34, 42, 50, 58 },
		[SMH_SPELL_LESSER_HEAL] = { 1, 4, 10 },
		[SMH_FAKE_SPELL_COMBINED_HEAL] = { 16, 22, 28, 34, 40, 46, 52, 58, 60 },
		[SMH_SPELL_RENEW] = { 8, 14, 20, 26, 32, 38, 44, 50, 56, 60 },
		[SMH_SPELL_FLASH_HEAL] = { 20, 26, 32, 38, 44, 50, 56 },
		[SMH_SPELL_DESPERATE_PRAYER] = { 10, 18, 26, 34, 42, 50, 58 },
		[SMH_SPELL_POWER_WORD_SHIELD] = { 6, 12, 18, 24, 30, 36, 42, 48, 54, 60 },
		[SMH_SPELL_HEALING_WAVE] = { 1, 6, 12, 18, 24, 32, 40, 48, 56, 60 },
		[SMH_SPELL_LESSER_HEALING_WAVE] = { 20, 28, 36, 44, 52, 60 },

		[SMH_SPELL_MARK_OF_THE_WILD] = { 1, 10, 20, 30, 40, 50, 60 },
		[SMH_SPELL_THORNS] = { 6, 14, 24, 34, 44, 54 },
		[SMH_SPELL_POWER_WORD_FORTITUDE] = { 1, 12, 24, 36, 48, 60 },
		[SMH_SPELL_DIVINE_SPIRIT] = { 30, 40, 50, 60 },
		[SMH_SPELL_SHADOW_PROTECTION] = { 30, 42, 56 },
		[SMH_SPELL_BLESSING_OF_MIGHT] = { 4, 12, 22, 32, 42, 52, 60 },
		[SMH_SPELL_BLESSING_OF_PROTECTION] = { 10, 24, 38 },
		[SMH_SPELL_BLESSING_OF_WISDOM] = { 14, 24, 34, 44, 54, 60 },
		[SMH_SPELL_BLESSING_OF_LIGHT] = { 40, 50, 60 },
		[SMH_SPELL_BLESSING_OF_SACRIFICE] = { 46, 54 },
		},
	maxClassHealth = { [SMH_CLASS_DRUID] = 3000, [SMH_CLASS_HUNTER] = 3000, [SMH_CLASS_MAGE] = 2000, [SMH_CLASS_PALADIN] = 4000, [SMH_CLASS_PRIEST] = 2000, [SMH_CLASS_ROGUE] = 3000, [SMH_CLASS_SHAMAN] = 3000, [SMH_CLASS_WARLOCK] = 2000, [SMH_CLASS_WARRIOR] = 4000 },
	maximumPercentageHealthAllowed = 300,
	maxNumberInAlgColumn = 10,		-- maximum number of spells in the algorithm column
	maxNumberInColumn = 10,			-- maximum number of character names in each priority column
	maxNumberInProColumn = 10,		-- maximum number of profiles in the profile column
	messageLabels = { },
	messageTitles = { SMH_MESSAGE_TYPE_CAST, SMH_MESSAGE_TYPE_INFO, SMH_MESSAGE_TYPE_ERROR, SMH_MESSAGE_TYPE_TIER, SMH_MESSAGE_TYPE_DEBUG, SMH_MESSAGE_TYPE_CAST_NO_PARTY, },
	messageTypes = { "CAST", "INFO", "ERROR", "TIER", "DEBUG", "CASTNOPARTY", },
	name = "None",				-- name of the player.  only use in determining raid group.
	oneUpNumber = 0,			-- used to identify casts
	outputBooleanMappings = { [false] = SMH_OUTPUT_OPTION_OFF, [true] = SMH_OUTPUT_OPTION_ON },
	outputSettingMessages = {
		["checkingNaturesSwiftness"] = SMH_OUTPUT_MESSAGE_NATURESSWIFTNESS,
		},
	petIds = { pet = 0, partypet1 = 1, partypet2 = 2, partypet3 = 3, partypet4 = 4 },
	playerIds = { party1 = 1, party2 = 2, party3 = 3, party4 = 4 },
	--	This table provides the allowed percentage of +healing gear based on the default casting
	--	time of the spell, its healing duration for HOT spells, and the level learned.
	--	The penalties that have been precomputed include the following:
	--	For each level under 20 at which the spell is learned the penalty is 3.5%
	--	For a pure HOT spell, the allowed percentage is its duration / 15 seconds.
	--	For Regrowth, only 50% of the penalty for cast time is considered because of split HOT healing.
	--	For a non-pure HOT spell, the allowed percentage is the standard cast time compared against 3.5
	--	seconds.  Spells under 1.5 seconds (like instants) are considered 1.5 seconds.
	plusHealingAllowedPecentages = {
		[SMH_SPELL_HEALING_TOUCH] = { 0, .1214, .4893, .8571, 1, 1, 1, 1, 1, 1, 1 },
		[SMH_SPELL_REGROWTH] = { .4857, .7107, .7857, .7857, .7857, .7857, .7857, .7857, .7857 },
		[SMH_SPELL_REJUVENATION] = { .2, .425, .65, .8, .8, .8, .8, .8, .8, .8, .8 },
		[SMH_SPELL_HOLY_LIGHT] = { .0018, .1893, .4893, .7143, .7143, .7143, .7143, .7143, .7143 },
		[SMH_SPELL_FLASH_OF_LIGHT] = { .4286, .4286, .4286, .4286, .4286, .4286 },
		[SMH_SPELL_LESSER_HEAL] = { 0, 0, .3393 },
		[SMH_FAKE_SPELL_COMBINED_HEAL] = { .7171, .8571, .8571, .8571, .8571, .8571, .8571, .8571, .8571 },
		[SMH_SPELL_RENEW] = { .58, .79, 1, 1, 1, 1, 1, 1, 1, 1 },
		[SMH_SPELL_FLASH_HEAL] = { .4286, .4286, .4286, .4286, .4286, .4286, .4286 },
		[SMH_SPELL_DESPERATE_PRAYER] = { .0786, .3586, .4286, .4286, .4286, .4286, .4286 },
		[SMH_SPELL_POWER_WORD_SHIELD] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
		[SMH_SPELL_HEALING_WAVE] = { 0, .0464, .4143, .7821, .8571, .8571, .8571, .8571, .8571, .8571 },
		[SMH_SPELL_LESSER_HEALING_WAVE] = { .4286, .4286, .4286, .4286, .4286, .4286 },
		},
	priorityLabels = { },
	raceEnglishDwarf = 'Dwarf',
	raceEnglishHuman = 'Human',
	setNamePattern = "^(.*) %(%d/%d%)$",	-- TODO: should really determine if this needs to be localized
	shapeshiftBuffs = { [SMH_BUFF_DIRE_BEAR_FORM] = true, [SMH_BUFF_BEAR_FORM] = true, [SMH_BUFF_CAT_FORM] = true, [SMH_BUFF_AQUATIC_FORM] = true, [SMH_BUFF_MOONKIN_FORM] = true, [SMH_BUFF_TRAVEL_FORM] = true, },
	slotBuff,				-- indicates the slot in action bar that has one of the buffs in which we have interest -- for range detection
	slotDesperatePrayer,			-- indicates the slot in action bar that has Desperate Prayer -- so we can check for cooldown
	slotHealing,				-- indicates the slot in action bar that has one of the healing spells in which we have interest -- for range detection
	slotSwiftNature,			-- indicates the slot in action bar that has Nature's Swiftness -- so we can check for cooldown for automatic casting
	slotPowerWordShield,			-- indicates the slot in action bar that has Power Word: Shield -- so we can check for cooldown
	spellsOfInterest = { },
	spellParsersMaxHeal = { },
	spellParsersMinHeal = { },
	spiritualGuidanceModification = 0,	-- used by Priests with Spiritual Guidance to keep track of healing modification
	spritualGuidanceTalentRank = 0, 	-- used to determine whether spells need to be reparsed when Spirit changes based on buff/equipment changes
	totems = {
		[SMH_TOTEM_ANCIENT_MANA_SPRING] = 1, [SMH_TOTEM_ATALAI] = 1, [SMH_TOTEM_BRAIN_WASH] = 10, [SMH_TOTEM_CORRUPTED] = 1, [SMH_TOTEM_DIRE_MAUL_CRYSTAL] = 1,
		[SMH_TOTEM_DISEASE_CLEANSING] = 1, [SMH_TOTEM_EARTHBIND] = 1, [SMH_TOTEM_EARTHGRAB] = 1, [SMH_TOTEM_ELEMENTAL_PROTECTION] = 1, [SMH_TOTEM_FIRE_NOVA] = 1,
		[SMH_TOTEM_FIRE_RESISTANCE] = 1, [SMH_TOTEM_FLAME_BUFFET] = 1, [SMH_TOTEM_FLAMETONGUE] = 1, [SMH_TOTEM_FROST_RESISTANCE] = 1, [SMH_TOTEM_GRACE_OF_AIR] = 1,
		[SMH_TOTEM_GROUNDING] = 1, [SMH_TOTEM_HEALING_STREAM] = 1, [SMH_TOTEM_HEALING] = 1, [SMH_TOTEM_ICE] = 1, [SMH_TOTEM_LAVA_SPOUT] = 1, [SMH_TOTEM_MAGMA] = 1,
		[SMH_TOTEM_MANA_SPRING] = 1, [SMH_TOTEM_MANA_TIDE] = 1, [SMH_TOTEM_MOONFLARE] = 1, [SMH_TOTEM_NATURE_RESISTANCE] = 1, [SMH_TOTEM_POISON_CLEANSING] = 1,
		[SMH_TOTEM_POWERFUL_HEALING] = 10, [SMH_TOTEM_SCORCHING] = 1, [SMH_TOTEM_SEARING] = 1, [SMH_TOTEM_SENTRY] = 5, [SMH_TOTEM_SPIRIT] = 1, [SMH_TOTEM_STONECLAW] = 5,
		[SMH_TOTEM_STONESKIN] = 1, [SMH_TOTEM_STRENGTH_OF_EARTH] = 1, [SMH_TOTEM_SUPERIOR_HEALING] = 1, [SMH_TOTEM_TRANQUIL_AIR] = 1, [SMH_TOTEM_TREMOR] = 1,
		[SMH_TOTEM_WINDFURY] = 1, [SMH_TOTEM_WINDWALL] = 1,
		},
	uiElements = { },

	ActionNotInCooldown = function(self, actionSlot)
		local retval = false
		if actionSlot then
			local start, duration, enable = GetActionCooldown(actionSlot)
			if start == 0 and duration == 0 then
				retval = true
			end
		end
		return retval
	end,

	Algorithm_Add = function(self)
		local percentageValue = com_mithrandir_smhAlgorithmAcceptField:GetText()

		if tonumber(percentageValue) >= 0 and tonumber(percentageValue) <= 99 then
			SMH_Configuration.profiles[SMH_Configuration.currentProfile].algorithm[percentageValue] = self.algorithmAddingSpell
			self:AlgorithmButtons_Show()
		end
	end,

	Algorithm_Control = function(self)
		if self:RealTableSize(SMH_Configuration.profiles[SMH_Configuration.currentProfile].algorithm) < self.maxNumberInAlgColumn then
			self.algorithmAddingSpell = this.tooltiptext
			com_mithrandir_smhAlgorithmAcceptInfo:SetText(string.format(SMH_ALGORITHM_INSTRUCTIONS, self.algorithmAddingSpell))
			com_mithrandir_smhAlgorithmAccept:Show()
		end
	end,

	Algorithm_Remove = function(self)
		local buttonTitle = this:GetText()
		local match, _, amount = string.find(buttonTitle, "^(%d+)%%.*")
		if (match ~= nil) then
			SMH_Configuration.profiles[SMH_Configuration.currentProfile].algorithm[amount] = nil
			self:AlgorithmButtons_Show()
		end
	end,

	AlgorithmButtons_Hide = function(self)
		for i = 1, self.maxNumberInAlgColumn, 1 do
			getglobal("com_mithrandir_smhAlgorithm"..i):Hide()
		end
	end,

	AlgorithmButtons_Show = function(self)
		local temp = { }
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]

		for n in pairs(currentProfile.algorithm) do table.insert(temp, n) end
		table.sort(temp, function(a, b) return SMH:CompareGreaterNumeric(a, b) end)
		for i, n in ipairs(temp) do
			getglobal("com_mithrandir_smhAlgorithm"..i):SetText(string.format("%s%% %s", n, currentProfile.algorithm[n]))
			getglobal("com_mithrandir_smhAlgorithm"..i):Show()
		end
		for i = table.getn(temp) + 1, self.maxNumberInAlgColumn, 1 do
			getglobal("com_mithrandir_smhAlgorithm"..i):Hide()
		end
	end,

	--	The purpose of this function is to look through all the equipped items
	--	and determine how much extra healing is provided by them.
	CacheEquipmentData = function(self)
		self.extraHealingAmount = 0
		self.extraHealingAmountPossible = 0
		self.hasItemIdolOfRejuvenation = 0
		self.hasItemTotemOfLife = 0
		self.hasItemTotemOfSustaining = 0
		self.hasItemLibramOfDivinity = 0
		self.hasItemLibramOfLight = 0
		self.hasBenefitStormrage = false
		self.hasBenefitDreamwalker = false
		self.hasBenefitTranscendance = false
		self.hasBrokenPlusHealingItems = false
		local _SMH_setNames = { }
		local canLookForSetPatterns, itemIsBroken
		local slot

		for i, slot in self.equipmentSlots do
			local id, _ = GetInventorySlotInfo(slot.."Slot")
			local item, _, _ = smhTooltip:SetInventoryItem('player', id)
			if item then
				canLookForSetPatterns = false
				itemIsBroken = false
				itemPlusHealingValue = 0
				local lineCount = smhTooltip:NumLines()
				for j = 1, lineCount, 1 do
					local text = getglobal("smhTooltipTextLeft"..j)
					if text then
						local line = text:GetText()

						--	First we look for specific items of interest
						if j == 1 then
							if line == SMH_ITEM_IDOL_OF_REJUVENATION then
								self.hasItemIdolOfRejuvenation = self:NumberFromTooltipLine(lineCount); break
							elseif line == SMH_ITEM_TOTEM_OF_LIFE then
								self.hasItemTotemOfLife = self:NumberFromTooltipLine(lineCount); break
							elseif line == SMH_ITEM_TOTEM_OF_SUSTAINING then
								self.hasItemTotemOfSustaining = self:NumberFromTooltipLine(lineCount); break
							elseif line == SMH_ITEM_LIBRAM_OF_DIVINITY then
								self.hasItemLibramOfDivinity = self:NumberFromTooltipLine(lineCount); break
							elseif line == SMH_ITEM_LIBRAM_OF_LIGHT then
								self.hasItemLibramOfLight = self:NumberFromTooltipLine(lineCount); break
							end
						end

						local match, _, setName = string.find(line, self.setNamePattern)
						if match ~= nil then
							if not _SMH_setNames[setName] then
								canLookForSetPatterns = true
								_SMH_setNames[setName] = true
							end
						end

						local match, where, current, total = string.find(line, _smh_DurabilityPattern)
						if match ~= nil then
							if tonumber(total) > 0 and tonumber(current) == 0 then itemIsBroken = true end
						end

						for k, pattern in _smh_healingPatterns do
							local match, _, amount = string.find(line, pattern)
							if (match ~= nil) then
								self:OutputMessage("DEBUG", "On "..slot.." found "..tonumber(amount).." healing.")
								itemPlusHealingValue = itemPlusHealingValue + tonumber(amount)
								break
							end
						end
						if canLookForSetPatterns then
							local possibleMatch
							possibleMatch, _ = string.find(line, _smh_setPatternStormrage)
							if possibleMatch ~= nil then
								self.hasBenefitStormrage = true
								self:OutputMessage("DEBUG", "Found Stormrage benefit.")
							else
								possibleMatch, _ = string.find(line, _smh_setPatternDreamwalker)
								if possibleMatch ~= nil then
									self.hasBenefitDreamwalker = true
									self:OutputMessage("DEBUG", "Found Dreamwalker benefit.")
								else
									possibleMatch, _ = string.find(line, _smh_setPatternTranscendance)
									if possibleMatch ~= nil then
										self.hasBenefitTranscendance = true
										self:OutputMessage("DEBUG", "Found Transcendance benefit")
									else
										for k, pattern in _smh_setHealingPatterns do
											local match, _, amount = string.find(line, pattern)
											if match ~= nil then
												self:OutputMessage("DEBUG", "On "..slot.." found "..tonumber(amount).." healing as part of set.")
												itemPlusHealingValue = itemPlusHealingValue + tonumber(amount)
												break
											end
										end
									end
								end
							end

						end
					end
				end
				if itemPlusHealingValue > 0 then
					if itemIsBroken then
						self.hasBrokenPlusHealingItems = true
						self:OutputMessage("DEBUG", "Item in " .. slot .. " slot is broken, but should have provided " .. itemPlusHealingValue .. " +healing.")
						self.extraHealingAmountPossible = self.extraHealingAmountPossible + itemPlusHealingValue
					else
						self.extraHealingAmount = self.extraHealingAmount + itemPlusHealingValue
						self.extraHealingAmountPossible = self.extraHealingAmountPossible + itemPlusHealingValue
					end
				end
			end
		end

		self:OutputMessage("DEBUG", "Total extra healing found on equipment: ".. self.extraHealingAmount)

		return self.extraHealingAmount, self.extraHealingAmountPossible

	end,

	--	This function walks through the spell book looking for spells in which we have interest.
	--	It then caches the entries into the spell book into tables so we can easily determine
	--	which spell to cast based on the name of the spell and the desired casting rank.
	CacheSpellBookData = function(self)
		self:OutputMessage("DEBUG", "Caching spell book data.")
		-- clear the cache
		self.cachedSpellBookData = { }
		local localSpellsOfInterest = { }

		for i = 1, table.getn(self.classSpellsOfInterest[SMH.class]), 1 do
			self.cachedSpellBookData[self.classSpellsOfInterest[self.class][i]] = { }
			if self.classSpellsOfInterest[self.class][i] == SMH_FAKE_SPELL_COMBINED_HEAL then
				localSpellsOfInterest[SMH_SPELL_HEAL] = true
				localSpellsOfInterest[SMH_SPELL_GREATER_HEAL] = true
			else
				localSpellsOfInterest[self.classSpellsOfInterest[self.class][i]] = true
			end
		end
		for i = 1, table.getn(self.classBuffsOfInterest[self.class]), 1 do
			self.cachedSpellBookData[self.classBuffsOfInterest[self.class][i]] = { }
			localSpellsOfInterest[self.classBuffsOfInterest[self.class][i]] = true
		end
		for i = 1, table.getn(self.classAttacksOfInterest[self.class]), 1 do
			self.cachedSpellBookData[self.classAttacksOfInterest[SMH.class][i]] = { }
			localSpellsOfInterest[self.classAttacksOfInterest[self.class][i]] = true
		end

		local playerBuffs = self:UnitBuffs('player')
		local casterHasNaturesSwiftness = (playerBuffs[SMH_SPELL_NATURESSWIFTNESS] ~= nil)
		local casterHasFocus = (playerBuffs[SMH_BUFF_FOCUS] ~= nil)

		if casterHasNaturesSwiftness or casterHasFocus then self.castingTimeReadProperly = false else self.castingTimeReadProperly = true end

		local index = 1

		while (true) do
			local spellName, spellRankName = GetSpellName(index, SpellBookFrame.bookType)
			local maxHealAmount, minHealAmount

			-- If there is no spellName then we have run out of spells in the spell book
			if (not spellName) then
				do break end
			end

			-- If the spellName is in our table we have interest in processing it
			if (localSpellsOfInterest[spellName]) then
				local _, _, spellRank = string.find(spellRankName, SMH_SPELLBOOK_RANK_FORMAT)
				local rankIndex = tonumber(spellRank)
				--	Now we look at the tooltips for each of the spells to pull out the mana cost
				--	and the amount of healing that can be done.  These values have been adjusted
				--	for the talents already.
				smhTooltip:SetSpell(index, SpellBookFrame.bookType)
				local manaLine = smhTooltipTextLeft2:GetText()
				local manaCost
				if manaLine then
					_,_,manaCost = string.find(manaLine, SMH_SPELLBOOK_MANA_FORMAT)
					if manaCost == nil then manaCost = 0 end
				else
					manaCost = 0
				end
				local healLine = smhTooltipTextLeft4:GetText()
				if spellName == SMH_SPELL_DESPERATE_PRAYER then
					--	We use the last line because the line number changes based on whether
					--	the spell is in cooldown.
					local text = getglobal("smhTooltipTextLeft"..smhTooltip:NumLines())
					if text then
						healLine = text:GetText()
					else
						healLine = nil
						self:OutputMessage("INFO", "Problem parsing Desperate Prayer because we are told there are " .. smhTooltip:NumLines() .. " but we cannot get that line.")
					end
				end
				if healLine == nil then healLine = "" end
				if self.spellParsersMaxHeal[self.class][spellName] then
					maxHealAmount = self.spellParsersMaxHeal[self.class][spellName](healLine)
					if maxHealAmount == nil then
						self:OutputMessage("INFO", spellName.." (Rank "..spellRank..") cannot get max heal from: "..healLine)
						maxHealAmount = 0
					end
				else
					maxHealAmount = 0
				end
				if self.spellParsersMinHeal[self.class][spellName] then
					minHealAmount = self.spellParsersMinHeal[self.class][spellName](healLine)
					if minHealAmount == nil then
						self:OutputMessage("INFO", spellName.." (Rank "..spellRank..") cannot get min heal from: "..healLine)
						minHealAmount = 0
					end
				else
					minHealAmount = 0
				end

				local castingTime = 0
				if casterHasNaturesSwiftness or casterHasFocus then
					castingTime = self.defaultCastTimes[spellName][rankIndex]
				else
					if self.defaultCastTimes[spellName][rankIndex] ~= 0 then
						local castLine = smhTooltipTextLeft3:GetText()
						if castLine then
							_, _, castingTime = string.find(castLine, "^%s*([%d.]+)")
							--	It seems we actually get the event that causes us to attempt to parse
							--	the cast times but unfortunately the tooltip does not yet show the true
							--	values as they are still "Instant cast" and therefore, we need to still
							--	keep the data as invalid until we can once again reparse.
							if castingTime == nil then
								self.castingTimeReadProperly = false
								castingTime = self.defaultCastTimes[spellName][rankIndex]
								self:OutputMessage("DEBUG", "Could not find casting time for " .. spellName .. " (Rank " .. rankIndex .. ") from line: " .. castLine)
							end
						else
							castingTime = 0
						end
					else
						castingTime = 0
					end
				end

				local entry = { id = index, mana = tonumber(manaCost), maxHeal = maxHealAmount, minHeal = minHealAmount, castTime = tonumber(castingTime) }

				--	This little section of code takes the Priest spells Heal and Greater Heal
				--	and combines them into a fake spell that basically starts at Heal and then
				--	becomes Greater Heal when past the four Heals.  Basically this is done
				--	because Heal and Greater Heal seem to be the same spell in behavior and the
				--	amount they heal (and mana cost) goes up from the last Heal to the first
				--	Greater Heal.
				if spellName == SMH_SPELL_HEAL then
					spellName = SMH_FAKE_SPELL_COMBINED_HEAL
				elseif spellName == SMH_SPELL_GREATER_HEAL then
					spellName = SMH_FAKE_SPELL_COMBINED_HEAL
					rankIndex = rankIndex + 4
				end

				self.cachedSpellBookData[spellName][rankIndex] = entry
			end

			-- Next spell please
			index = index + 1
		end
	end,

	CastBuff = function(self, spellName, selfHealing)
		local spellAttempted = false
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]

		if IsAltKeyDown() == 1 or selfHealing then spellAttempted = self:TryBuffCast(spellName, 'player') end
		if selfHealing then spellAttempted = true end	-- just to break us out

		if spellAttempted == false and currentProfile.buffsTarget then
			if self:UnitIsHealable('target') then spellAttempted = self:TryBuffCast(spellName, 'target') end
		end

		if spellAttempted == false and currentProfile.buffsParty then
			for i in self.playerIds do
				if spellAttempted == false and self:UnitIsHealable(i) then spellAttempted = self:TryBuffCast(spellName, i) end
			end
		end		

		if spellAttempted == false and currentProfile.buffsPets then
			for i in self.petIds do
				if spellAttempted == false and self:UnitIsHealable(i) then spellAttempted = self:TryBuffCast(spellName, i) end
			end
		end

		if spellAttempted == false and currentProfile.buffsRaid then
			local numberInRaid = GetNumRaidMembers()
			if (numberInRaid > 0) then
				local unitName
				for i = 1, numberInRaid do
					unitName = "raid"..i
					if self:UnitIsHealable(unitName) then spellAttempted = self:TryBuffCast(spellName, unitName) end
					if spellAttempted == true then break end
				end
			end
		end

		if spellAttempted == false and currentProfile.buffsRaidPets then
			local numberInRaid = GetNumRaidMembers()
			if (numberInRaid > 0) then
				local unitName
				for i = 1, numberInRaid do
					unitName = "raidpet"..i
					if self:UnitIsHealable(unitName) then spellAttempted = self:TryBuffCast(spellName, unitName) end
					if spellAttempted == true then break end
				end
			end
		end
	end,

	CastHeal = function(self, healingMode, healingSelf)
		local didCast = false
		local abortReason = nil
		if self.initiatedCast then
			self:OutputMessage("ERROR", SMH_ERROR_MESSAGE_BUSY)
			return false
		end
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
		if self.slotSwiftNature ~= nil and currentProfile.checkingNaturesSwiftness and not self:HasBuff('player', SMH_SPELL_NATURESSWIFTNESS, false) and self:ActionNotInCooldown(self.slotSwiftNature) then
			self:OutputMessage("INFO", SMH_INFORMATIVE_MESSAGE_CAST_NS)
			UseAction(self.slotSwiftNature)
			return true
		end
		local groupStatus = self:OrderedHealableUnits(healingSelf)
		if (table.getn(groupStatus) == 0) then
			self:OutputMessage("INFO", SMH_INFORMATIVE_MESSAGE_NO_ONE)
			return false
		else
			if SpellIsTargeting() then SpellStopTargeting() end
			for key, value in groupStatus do
				didCast, abortReason = self:CastHealOnUnitInfo(value, healingMode)
				if didCast or abortReason then break end
			end
		end
		return didCast
	end,

	CastHealNormal = function(self)
		return self:CastHeal(0, false)
	end,

	CastHealOnUnit = function(self, unitId, mode)
		local healingMode = mode or 0
		local groupStatus = { }
		local didCast = false
		local abortReason = nil
		self:DealWithUnsureRecipient(groupStatus, unitId)
		if table.getn(groupStatus) > 0 then
			for key, value in groupStatus do
				didCast, abortReason = self:CastHealOnUnitInfo(value, healingMode)
				if didCast or abortReason then break end
			end
		end
		return didCast
	end,

	--	unitInfo is a table with four values in it:
	--	"id" is the unitId, "max" is the unit's maximum health, "current" is the unit's current health, and "percent" is current/max
	CastHealOnUnitInfo = function(self, unitInfo, healingMode)
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
		local spellName, spellRank, abortReason, estimatedHealAmount, playerBuffs = self:DetermineSpellAndRankForUnit(unitInfo, healingMode)
		local casterHasNaturesSwiftness = false
		local casterHasFocus = false
		if playerBuffs then
			casterHasNaturesSwiftness = (playerBuffs[SMH_SPELL_NATURESSWIFTNESS] ~= nil)
			casterHasFocus = (playerBuffs[SMH_BUFF_FOCUS] ~= nil)
		end
		local shouldBreak = false
		if abortReason then
			self:OutputMessage("ERROR", self.colorRed .. SMH_CANNOT_CAST .. abortReason .. self.colorStop)
			return false, abortReason
		end
		if (spellName) then
			local spellId = self.cachedSpellBookData[spellName][spellRank].id
			if (spellId ~= nil) then
				local spellCastTime = self.cachedSpellBookData[spellName][spellRank].castTime
				if spellCastTime == nil then spellCastTime = 0 end

				--	To be able to output the proper name and rank for players we have
				--	to modify the name if we are doing the fake Priest spell
				if spellName == SMH_FAKE_SPELL_COMBINED_HEAL then
					if spellRank < 5 then
						spellName = SMH_SPELL_HEAL
					else
						spellName = SMH_SPELL_GREATER_HEAL
						spellRank = spellRank - 4
					end
				end

				if (UnitIsVisible(unitInfo.id)) then
					if unitInfo.id == 'player' then	-- self casting can ignore tons of stuff we do
						local targetName = nil

						if UnitExists('target') then
							if UnitIsFriend('target', 'player') then targetName = UnitName('target') end
						end
						self:OutputMessage("CAST", string.format(SMH_INFORMATIVE_MESSAGE_HEALINGFORMAT, spellName, spellRank, UnitName(unitInfo.id)))
						if targetName ~= nil then TargetUnit('player') end
						self.initiatedCast = true
						if spellCastTime > 0 and not casterHasNaturesSwiftness and not casterHasFocus then
							self:OutputChannelMessage(nil, spellName, spellRank, self.name, estimatedHealAmount, spellCastTime)
						end
						CastSpell(spellId, SpellBookFrame.bookType)
						SpellTargetUnit('player')
						if not currentProfile.targetRecipient and targetName ~= nil then TargetByName(targetName) end
						return true, nil
					else
						local possibleStealthAllowed = true
						local targetBuffs = self:UnitBuffs(unitInfo.id)
						if not self:UnitInParty(unitInfo.id) then
							if targetBuffs[SMH_SPELL_PROWL] ~= nil or targetBuffs[SMH_SPELL_STEALTH] ~= nil or targetBuffs[SMH_SPELL_SHADOWMELD] ~= nil then
								possibleStealthAllowed = false
							end
						end
						if possibleStealthAllowed and targetBuffs[SMH_SPELL_DIVINE_INTERVENTION] == nil and targetBuffs[SMH_SPELL_PETRIFICATION] == nil and targetBuffs[SMH_SPELL_SPIRIT_OF_REDEMPTION] == nil and targetBuffs[SMH_SPELL_PHASE_SHIFT] == nil then
							-- Since we want to find the range we will set the target to the
							-- one we want to heal.  Therefore, we need to know whether we
							-- already had a target.
							local hadTarget = false
							local targetName = nil
							if (UnitExists('target')) then
								hadTarget = true
								if (UnitIsFriend('target', 'player')) then targetName = UnitName('target') end
							end
							TargetUnit(unitInfo.id)

							if (UnitIsUnit('target', unitInfo.id)) then
								if (self.slotHealing == nil or IsActionInRange(self.slotHealing) == 1) then
									self:OutputMessage("CAST", string.format(SMH_INFORMATIVE_MESSAGE_HEALINGFORMAT, spellName, spellRank, UnitName(unitInfo.id)))
									self.initiatedCast = true
									if spellCastTime > 0 and not casterHasNaturesSwiftness and not casterHasFocus then
										self:OutputChannelMessage(nil, spellName, spellRank, UnitName(unitInfo.id), estimatedHealAmount, spellCastTime)
									end
									CastSpell(spellId, SpellBookFrame.bookType)
									shouldBreak = true
								else
									self:OutputMessage("INFO", string.format(SMH_INFORMATIVE_MESSAGE_OORFORMAT, UnitName(unitInfo.id)))
								end
							else
								self:OutputMessage("INFO", string.format(SMH_INFORMATIVE_MESSAGE_CANNOT_TARGETFORMAT, UnitName(unitInfo.id)))
							end

							-- Since we actually set the target to the one we wanted to heal
							-- to be able to determine whether they are in range of our spell
							-- we have to reset the target to what it was before.  Note that
							-- the following line does not work.
							-- if (hadTarget) then TargetLastTarget() else ClearTarget() end
							if not currentProfile.targetRecipient then
								if (hadTarget) then
									if (targetName ~= nil) then TargetByName(targetName) else TargetLastEnemy() end
								else
									ClearTarget()
								end
							end
							if shouldBreak then return true, nil end
						else
							self:OutputMessage("INFO", string.format(SMH_INFORMATIVE_MESSAGE_STEALTHFORMAT, UnitName(unitInfo.id)))
						end
					end
				else
					self:OutputMessage("INFO", string.format(SMH_INFORMATIVE_MESSAGE_INVISIBLEFORMAT, UnitName(unitInfo.id)))
				end
			else
				self:OutputMessage("INFO", string.format(SMH_INFORMATIVE_MESSAGE_SPELL_LOSTFORMAT, spellName, spellRank, UnitName(unitInfo.id)))
			end
			if SpellIsTargeting() then SpellStopTargeting() end
		else
			self:OutputMessage("INFO", string.format(SMH_INFORMATIVE_MESSAGE_NO_SPELLFORMAT, UnitName(unitInfo.id)))
		end
		return false, nil
	end,

	CastHealSelf = function(self)
		return self:CastHeal(0, true)
	end,

	--	This routine casts Moonfire at the highest level that
	--	mana permits unless the target is a totem and then it
	--	casts Moonfire at the minimum level needed to destroy
	--	the totem.
	CastMoonfire = function(self)
		local casterHasClearcasting = SMH:HasBuff('player', SMH_SPELL_CLEARCASTING, false)
		local rankIndex = 1
		local trulyDesiredRank
		local myMana = UnitMana('player')
		if (nil == myMana) then myMana = 0 end

		while (true) do
			local spellInfo = self.cachedSpellBookData[SMH_SPELL_MOONFIRE][rankIndex]
			if spellInfo then
				rankIndex = rankIndex + 1
			else
				rankIndex = rankIndex - 1
				break
			end
		end
		self:OutputMessage("DEBUG", "Highest rank Moonfire known is "..rankIndex)

		-- Then limit rankIndex if our target is a totem
		local targetName = UnitName('target')
		if targetName == nil then targetName = "NO TARGET NAME" end
		local totemRank = self.totems[targetName]
		if totemRank ~= nil then
			if totemRank > rankIndex then
				self:OutputMessage("DEBUG", "Moonfire wants to be set to rank "..totemRank.." because target is "..targetName.." but that is not known.")
			else
				rankIndex = totemRank
				self:OutputMessage("DEBUG", "Moonfire rank set to "..rankIndex.." because target is "..targetName)
			end
		end

		-- Now ensure we have the mana to cast it
		trulyDesiredRank = rankIndex
		if not casterHasClearcasting then
			while (rankIndex > 0) do
				if myMana >= self.cachedSpellBookData[SMH_SPELL_MOONFIRE][rankIndex].mana then break end
				rankIndex = rankIndex - 1
			end
			if trulyDesiredRank ~= rankIndex then
				self:OutputMessage("DEBUG", "Wanted Moonfire rank "..trulyDesiredRank.." but mana limits us to rank "..rankIndex)
			end
		else
			--	We have Clearcasting so can raise the rank to the highest we have
			while (self.cachedSpellBookData[SMH_SPELL_MOONFIRE][rankIndex]) do
				rankIndex = rankIndex + 1
			end
			rankIndex = rankIndex - 1
			if trulyDesiredRank ~= rankIndex then
				self:OutputMessage("DEBUG", "Wanted Moonfire rank "..trulyDesiredRank.." but Clearcasting allows us to rank "..rankIndex)
			end
		end

		if rankIndex > 0 then
			local spellId = self.cachedSpellBookData[SMH_SPELL_MOONFIRE][rankIndex].id
			if spellId then
				self:OutputMessage("DEBUG", "Casting Moonfire rank "..rankIndex)
				CastSpell(spellId, SpellBookFrame.bookType)
			end
		end

	end,

	--	returns the name of the buff that is problematic
	CastStoppingBuff = function(self, buffs)
		local retval = nil
		local playerBuffs = buffs or self:UnitBuffs('player')
		for n in pairs(playerBuffs) do if playerBuffs[n]["castStopping"] then retval = n; break end end
		return retval
	end,

	ChannelMessageProcess = function(self, message, fromWhom)
		self:OutputMessage("DEBUG", "We have channel message from " .. fromWhom .. " that says: " .. message)
		if fromWhom ~= self.name then
			local match, _, spellNumber = string.find(message, "^SMH%:(%d+)%:Done$")
			if match ~= nil then
				--	We remove the entry in the table matching the spell
				self.currentOtherHeals[fromWhom .. "-" .. spellNumber] = nil
			else
				local match, _, spellNumber, theSpellName, theSpellRank, theRecipient, amount, theCastTime = string.find(message, "^SMH%:(%d+)%:([%w ]+)%:(%d+)%:(%w+)%:(%d+)%:([%d.]+)$")
				if match ~= nil then
					--	We add a new entry in the table for this spell
					self.currentOtherHeals[fromWhom .. "-" .. spellNumber] = { spellName = theSpellName, spellRank = theSpellRank, recipient = theRecipient, potentialHeal = amount, castTime = theCastTime, registered = GetTime() }
				end
			end
		end
	end,

	CharacterPriority_Add = function(self)
		if self:UnitIsHealable('target') then
			local targetName = UnitName('target')
			local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
			if currentProfile.charactersPriorityHigh[targetName] then currentProfile.charactersPriorityHigh[targetName] = nil end
			if currentProfile.charactersPriorityLow[targetName] then currentProfile.charactersPriorityLow[targetName] = nil end
			if currentProfile.charactersPriorityIgnored[targetName] then currentProfile.charactersPriorityIgnored[targetName] = nil end
			local id = this:GetID()
			if id == 0 then
				if self:RealTableSize(currentProfile.charactersPriorityIgnored) < self.maxNumberInColumn then
					currentProfile.charactersPriorityIgnored[targetName] = true
				end
			elseif id == 1 then
				if self:RealTableSize(currentProfile.charactersPriorityLow) < self.maxNumberInColumn then
					currentProfile.charactersPriorityLow[targetName] = true
				end
			elseif id == 2 then
				if self:RealTableSize(currentProfile.charactersPriorityHigh) < self.maxNumberInColumn then
					currentProfile.charactersPriorityHigh[targetName] = true
				end
			end
			self:CharacterPriorityButtons_Show()
		end
	end,

	CharacterPriority_Remove = function(self)
		local id = this:GetID()
		local characterName = this:GetText()
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]

		if id < 100 then
			currentProfile.charactersPriorityIgnored[characterName] = nil
		elseif id < 200 then
			currentProfile.charactersPriorityLow[characterName] = nil
		else
			currentProfile.charactersPriorityHigh[characterName] = nil
		end
		self:CharacterPriorityButtons_Show()
	end,

	CharacterPriorityButtons_Hide = function(self)
		for i = 1, self.maxNumberInColumn, 1 do
			getglobal("com_mithrandir_smhCharPriIgnored"..i):Hide()
			getglobal("com_mithrandir_smhCharPriLow"..i):Hide()
			getglobal("com_mithrandir_smhCharPriHigh"..i):Hide()
		end
	end,

	CharacterPriorityButtons_Show = function(self)
		local temp = { }
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]

		for n in pairs(currentProfile.charactersPriorityIgnored) do table.insert(temp, n) end
		table.sort(temp, function(a, b) return SMH:CompareLesser(a, b) end)
		for i, n in ipairs(temp) do
			getglobal("com_mithrandir_smhCharPriIgnored"..i):SetText(n)
			getglobal("com_mithrandir_smhCharPriIgnored"..i):Show()
		end
		for i = table.getn(temp) + 1, self.maxNumberInColumn, 1 do
			getglobal("com_mithrandir_smhCharPriIgnored"..i):Hide()
		end

		temp = { }
		for n in pairs(currentProfile.charactersPriorityLow) do table.insert(temp, n) end
		table.sort(temp, function(a, b) return SMH:CompareLesser(a, b) end)
		for i, n in ipairs(temp) do
			getglobal("com_mithrandir_smhCharPriLow"..i):SetText(n)
			getglobal("com_mithrandir_smhCharPriLow"..i):Show()
		end
		for i = table.getn(temp) + 1, self.maxNumberInColumn, 1 do
			getglobal("com_mithrandir_smhCharPriLow"..i):Hide()
		end

		temp = { }
		for n in pairs(currentProfile.charactersPriorityHigh) do table.insert(temp, n) end
		table.sort(temp, function(a, b) return SMH:CompareLesser(a, b) end)
		for i, n in ipairs(temp) do
			getglobal("com_mithrandir_smhCharPriHigh"..i):SetText(n)
			getglobal("com_mithrandir_smhCharPriHigh"..i):Show()
		end
		for i = table.getn(temp) + 1, self.maxNumberInColumn, 1 do
			getglobal("com_mithrandir_smhCharPriHigh"..i):Hide()
		end
	end,

	CheckButton_OnClick = function(self)
		local key = _smh_checkButtonTitles[this:GetID()][1]
		SMH_Configuration.profiles[SMH_Configuration.currentProfile][key] = (this:GetChecked() == 1)
	end,

	CheckButton_OnLoad = function(self)
		getglobal(this:GetName().."Text"):SetText(_smh_checkButtonTitles[this:GetID()][2])
	end,

	CheckButton_OnShow = function(self)
		if SMH_Configuration.profiles[SMH_Configuration.currentProfile][_smh_checkButtonTitles[this:GetID()][1]] then
			this:SetChecked(1)
		else
			this:SetChecked(0)
		end
	end,

	CompareGreater = function(self, one, two)
		return one > two
	end,

	CompareGreaterNumeric = function(self, one, two)
		return tonumber(one) > tonumber(two)
	end,

	CompareHealth = function(self, unit1, unit2)
		return unit1.percent < unit2.percent
	end,

	CompareLesser = function(self, one, two)
		return one < two
	end,

	ConfirmationDialog_Template = function(self, frameName, parent, acceptFunction, acceptText, cancelText, title, info, needsEditBox)
		local frame = CreateFrame("Frame", frameName, parent)
		frame:SetWidth(400); frame:SetHeight(150); frame:SetFrameStrata("DIALOG"); frame:SetToplevel(1); frame:EnableMouse(1); frame:SetMovable(1); frame:Hide()
		frame:SetPoint("CENTER", "UIParent")
		frame:SetBackdrop({ bgFile = "Interface/DialogFrame/UI-DialogBox-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border", tile = true, edgeSize = 32, tileSize = 32, insets = { left = 11, right = 12, top = 12, bottom = 11 } })
		local texture = frame:CreateTexture(frameName .. "HeaderTexture", "ARTWORK")
		texture:SetTexture("Interface/DialogFrame/UI-DialogBox-Header")
		texture:SetWidth(256); texture:SetHeight(64)
		texture:SetPoint("TOP", 0, 12)
		local titleString = frame:CreateFontString(frameName .. "Title", "ARTWORK", "GameFontNormal")
		titleString:SetPoint("TOP", texture, "TOP", 0, -14)
		titleString:SetText(title)
		local infoString = frame:CreateFontString(frameName .. "Info", "ARTWORK", "GameFontNormal")
		infoString:SetWidth(350); infoString:SetHeight(32); infoString:SetJustifyV("TOP")
		infoString:SetPoint("TOP", 0, -30)
		infoString:SetText(info)
		if needsEditBox then
			local editBox = CreateFrame("EditBox", frameName .. "Field", frame, "InputBoxTemplate")
			editBox:SetWidth(60); editBox:SetHeight(17); editBox:SetAutoFocus(1)
			editBox:SetPoint("CENTER", infoString, "CENTER", 0, -30)
		end
		local addButton = CreateFrame("Button", frameName .. "AddButton", frame, "GameMenuButtonTemplate")
		addButton:SetWidth(80); addButton:SetHeight(21)
		addButton:SetPoint("BOTTOM", frame, "BOTTOM", -60, 12)
		addButton:SetText(acceptText)
		addButton:SetScript("OnClick", function() acceptFunction(); frame:Hide() end)
		local cancelButton = CreateFrame("Button", frameName .. "CancelButton", frame, "GameMenuButtonTemplate")
		cancelButton:SetWidth(80); cancelButton:SetHeight(21)
		cancelButton:SetPoint("BOTTOM", frame, "BOTTOM", 60, 12)
		cancelButton:SetText(cancelText)
		cancelButton:SetScript("OnClick", function() frame:Hide() end)
		return frame
	end,

	--	Copies the contents of a table into a new table
	CopyTable = function(self, someTable)
		local retval = { }
		for n in pairs(someTable) do
			if type(someTable[n]) == 'table' then
				retval[n] = self:CopyTable(someTable[n])
			else
				retval[n] = someTable[n]
			end
		end
		return retval
	end,

	DealWithUnsureRecipient = function(self, where, who)
		if self:UnitInGroup(who) then
			self:TryToInsertUnitForHealing(where, who, "threshold", nil)
		else
			local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
			local characterName = UnitName(who)
			self:ProcessOtherHeals()
			local possibleHealingForUnit = self.currentOtherHealsByCharacter[characterName]
			if possibleHealingForUnit == nil then possibleHealingForUnit = 0 end
			-- for a target not in the party, UnitHealth returns the percentage of maximum health
			-- so we must make a guess at how much is gone based on the target's class and level
			local slope = (self.maxClassHealth[UnitClass(who)] - 30) / 59
			local targetMaxHealth = UnitLevel(who) * slope + 30
			local targetCurrentHealth = targetMaxHealth * (UnitHealth(who) / 100) + possibleHealingForUnit * (currentProfile.otherHealerConfidence / 100)
			local targetPercentHealth = targetCurrentHealth / targetMaxHealth
			if targetPercentHealth < (currentProfile.threshold / 100.0) then
				table.insert(where, 1, { id = who, percent = targetPercentHealth, current = targetCurrentHealth, max = targetMaxHealth })
				self:OutputMessage("DEBUG", "The "..who.." "..UnitName(who).." put into heal list")
				self:OutputMessage("TIER", "The "..who.." "..UnitName(who).." put into heal list")
			end
		end
	end,

	--	If forcing it means we overwrite whatever was stored
	Defaults_Update = function(self, forcing)
		if forcing then
			for key in pairs(self.configurationDefaults) do
				SMH_Configuration.profiles[SMH_Configuration.currentProfile][key] = self.configurationDefaults[key]
			end
		else
			-- Ensure each profile has the proper keys present
			for profile in pairs(SMH_Configuration.profiles) do
				-- Make sure each default key is present in the profile
				for key in pairs(self.configurationDefaults) do
					if (nil == SMH_Configuration.profiles[profile][key]) then
						SMH_Configuration.profiles[profile][key] = self.configurationDefaults[key]
					end
				end
				-- Remove any key from the profile that does not exist in the defaults
				for key in pairs(SMH_Configuration.profiles[profile]) do
					if (nil == self.configurationDefaults[key]) then
						SMH_Configuration.profiles[profile][key] = nil
					end
				end
			end
		end
	end,

	--	This returns nil if there is no spell to cast.
	--	The unit passed in is a table.
	--	It will check all three types of spell we can cast
	--	and rule out ones that cannot be cast based on what
	--	the target already has on it, and what the caster
	--	is doing/has on it.  It then decides on the spell
	--	to cast based on the current algorithm.
	DetermineSpellAndRankForUnit = function(self, groupInfo, healingMode)
		local abortReason = nil
		if UnitOnTaxi('player') == 1 then return nil, nil, SMH_ABORT_MESSAGE_ON_TAXI, nil, nil end
		if UnitIsDead('player') then return nil, nil, SMH_ABORT_MESSAGE_DEAD, nil, nil end
		local playerBuffs = self:UnitBuffs('player')
		if self.class == SMH_CLASS_ENGLISH_DRUID and self:IsShapeshifted(playerBuffs) then return nil, nil, SMH_ABORT_MESSAGE_SHAPESHIFTED, nil, nil end
		if self.class == SMH_CLASS_ENGLISH_PRIEST and self:IsShadowform(playerBuffs) then return nil, nil, SMH_ABORT_MESSAGE_SHAPESHIFTED, nil, nil end
		if self.class == SMH_CLASS_ENGLISH_SHAMAN and self:IsGhostWolf(playerBuffs) then return nil, nil, SMH_ABORT_MESSAGE_SHAPESHIFTED, nil, nil end
		if self:IsMounted(playerBuffs) then return nil, nil, SMH_ABORT_MESSAGE_MOUNTED, nil, nil end
		local aCastStoppingBuff = self:CastStoppingBuff(playerBuffs)
		if aCastStoppingBuff then return nil, nil, string.format(SMH_ABORT_MESSAGE_BAD_BUFF, aCastStoppingBuff), nil, nil end
		local casterHasNaturesSwiftness = (playerBuffs[SMH_SPELL_NATURESSWIFTNESS] ~= nil)
		local casterHasFocus = (playerBuffs[SMH_BUFF_FOCUS] ~= nil)
		local casterHasClearcasting = (playerBuffs[SMH_SPELL_CLEARCASTING] ~= nil)
		local targetBuffs
		if (groupInfo.id == 'player') then targetBuffs = playerBuffs else targetBuffs = self:UnitBuffs(groupInfo.id) end
		local rankIndex = { }
		for i = 1, table.getn(self.classSpellsOfInterest[self.class]), 1 do
			rankIndex[self.classSpellsOfInterest[self.class][i]] = 1
		end
		local spellsToCheck = self.classSpellsOfInterest[self.class]
		local healAmount
		local spellInfo
		local trulyDesiredRank
		local myMana = UnitMana('player')
		local spellName
		local targetLevel = UnitLevel(groupInfo.id)
		local spellToUse = nil
		local spellRank = nil
		local estimatedHealAmount = nil
		local percentageHealing = 100	-- this is used to handle buffs that change how effective healing is
		local temporaryExtraHealingAmount = 0	-- used for trinkets
		local currentConfiguration = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
		local temporaryPlusHealingBySpell = { }
		local plusHealAmountToUse
		local temp
		local rankToUse
		local switches = {
			["needsToCheckMana"] = true,
			["canRaiseToMax"] = true,
			["amountToAttemptToRaise"] = 0,
			["temporaryTotal"] = 0,
			["directGreaterHealAdd"] = 0,
			["modifiedDirectGreaterHealAdd"] = false,
			["recipientClass"] = UnitClass(groupInfo.id),
			["temp"] = { },
			}
		local comparisonHealingPercentage = currentConfiguration.classHealPercents[switches.recipientClass]

		-- Initialize our temporary array to 0 for each spell of interest
		for i = 1, table.getn(spellsToCheck), 1 do
			temporaryPlusHealingBySpell[spellsToCheck[i]] = 0
		end

		self:OutputMessage("DEBUG", "Determining spell to use for "..UnitName(groupInfo.id))
		if (nil == myMana) then myMana = 0 end

		--	Determine what buffs on the recipient and what on the caster influence the
		--	ability to heal.  Basically we modify the percentage of healing that can be
		--	done, starting with 100% and modify from there.
		switches.temp = { }
		for n in pairs(self.buffTargetHealingEffects) do table.insert(switches.temp, n) end
		for i, n in ipairs(switches.temp) do
			if targetBuffs[n] ~= nil then percentageHealing = percentageHealing + (self.buffTargetHealingEffects[n] * targetBuffs[n]["count"]) end
		end
		switches.temp = { }
		for n in pairs(self.buffCasterHealingEffects) do table.insert(switches.temp, n) end
		for i, n in ipairs(switches.temp) do
			if playerBuffs[n] ~= nil then percentageHealing = percentageHealing + (self.buffCasterHealingEffects[n] * playerBuffs[n]["count"]) end
		end

		--	If we do not have any percentage left for healing abandon ship.
		if percentageHealing <= 0 then
			self:OutputMessage("INFO", string.format(SMH_INFORMATIVE_MESSAGE_NO_PERCENTAGEFORMAT, UnitName(value.id)))
			return nil, nil, nil, nil, nil
		elseif percentageHealing < 100 then
			self:OutputMessage("INFO", string.format("%s%s%d%%%s", self.colorOrange, SMH_INFORMATIVE_MESSAGE_EFFICIENCY, percentageHealing, self.colorStop))
		elseif percentageHealing > 100 then
			self:OutputMessage("INFO", string.format("%s%s%d%%%s", self.colorBlue, SMH_INFORMATIVE_MESSAGE_EFFICIENCY, percentageHealing, self.colorStop))
		end

		--	Determine the spell specific +healing modifications and put them into the
		--	table.
		local possibleBuff
		if self.class == SMH_CLASS_ENGLISH_DRUID then
			temporaryPlusHealingBySpell[SMH_SPELL_REJUVENATION] = temporaryPlusHealingBySpell[SMH_SPELL_REJUVENATION] + self.hasItemIdolOfRejuvenation
			if self.hasBenefitDreamwalker then
				temporaryPlusHealingBySpell[SMH_SPELL_REGROWTH] = temporaryPlusHealingBySpell[SMH_SPELL_REGROWTH] + 350	-- hopefully this is truly the proper value
			end
		end
		if self.class == SMH_CLASS_ENGLISH_PALADIN then
			possibleBuff= targetBuffs[SMH_SPELL_GREATER_BLESSING_OF_LIGHT]
			if possibleBuff == nil then possibleBuff = targetBuffs[SMH_SPELL_BLESSING_OF_LIGHT] end
			if possibleBuff ~= nil then
				temporaryPlusHealingBySpell[SMH_SPELL_HOLY_LIGHT] = temporaryPlusHealingBySpell[SMH_SPELL_HOLY_LIGHT] + possibleBuff[SMH_SPELL_HOLY_LIGHT]
				temporaryPlusHealingBySpell[SMH_SPELL_FLASH_OF_LIGHT] = temporaryPlusHealingBySpell[SMH_SPELL_FLASH_OF_LIGHT] + possibleBuff[SMH_SPELL_FLASH_OF_LIGHT]
			end
			temporaryPlusHealingBySpell[SMH_SPELL_FLASH_OF_LIGHT] = temporaryPlusHealingBySpell[SMH_SPELL_FLASH_OF_LIGHT] + self.hasItemLibramOfDivinity
			temporaryPlusHealingBySpell[SMH_SPELL_FLASH_OF_LIGHT] = temporaryPlusHealingBySpell[SMH_SPELL_FLASH_OF_LIGHT] + self.hasItemLibramOfLight
		end
		if self.class == SMH_CLASS_ENGLISH_SHAMAN then
			temporaryPlusHealingBySpell[SMH_SPELL_LESSER_HEALING_WAVE] = temporaryPlusHealingBySpell[SMH_SPELL_LESSER_HEALING_WAVE] + self.hasItemTotemOfLife
			temporaryPlusHealingBySpell[SMH_SPELL_LESSER_HEALING_WAVE] = temporaryPlusHealingBySpell[SMH_SPELL_LESSER_HEALING_WAVE] + self.hasItemTotemOfSustaining
		end

		--	The Stormrage set can change the duration of Rejuvenation so we change the time penalty for it
		if self.class == SMH_CLASS_ENGLISH_DRUID then
			if self.hasBenefitStormrage then
				self.plusHealingAllowedPecentages[SMH_SPELL_REJUVENATION] = { .4, .625, .85, 1, 1, 1, 1, 1, 1, 1, 1 }
			else
				self.plusHealingAllowedPecentages[SMH_SPELL_REJUVENATION] = { .2, .425, .65, .8, .8, .8, .8, .8, .8, .8, .8 }
			end
		end

		--	The Transcendence set can add healing value for the Greater Heal
		if self.class == SMH_CLASS_ENGLISH_PRIEST then
			if self.hasBenefitTranscendance then
				if self.cachedSpellBookData[SMH_SPELL_RENEW] then spellInfo = self.cachedSpellBookData[SMH_SPELL_RENEW][5] else spellInfo = nil end
				if spellInfo then
					switches.directGreaterHealAdd = spellInfo.minHeal + ((spellInfo.maxHeal - spellInfo.minHeal) * currentConfiguration.healPercentage / 100)
				end
			end
		end

		local cachedPlusHealingBySpellTime = { }
		switches.modifiedDirectGreaterHealAdd = false
		for i = 1, table.getn(spellsToCheck), 1 do		-- loop through each of spellsToCheck
			spellName = spellsToCheck[i]

			-- first determine the level of spell needed based on healing required
			while (true) do
				spellInfo = self.cachedSpellBookData[spellName][rankIndex[spellName]]
				if (spellInfo) then

					--	Determine the base heal amount garnered from the
					--	tooltip for each spell.  This includes modifications
					--	from talents, but not from equipment.  It uses the
					--	technique the user wants for healing to determine
					--	where in the range of healing the target should be.
					healAmount = (spellInfo.minHeal + ((spellInfo.maxHeal - spellInfo.minHeal) * currentConfiguration.healPercentage / 100))

					--	Deteremine which +healing buffs will still be active at the
					--	end of the normal time it takes to cast this buff.
					local castTime = spellInfo.castTime
					if casterHasNaturesSwiftness or casterHasFocus or castTime == nil then castTime = 0 end

					if cachedPlusHealingBySpellTime[castTime] == nil then
						switches.temp = { }
						switches.temporaryTotal = 0
						for n in pairs(self.buffCasterPlusHealingEffects) do table.insert(switches.temp, n) end
						for i, n in ipairs(switches.temp) do
							if playerBuffs[n] ~= nil and playerBuffs[n].lifetime > castTime then
								switches.temporaryTotal = switches.temporaryTotal + self.buffCasterPlusHealingEffects[n]
							end
						end
						--	Since Unstable Power varies we need to treat it separately
						if playerBuffs[SMH_BUFF_UNSTABLE_POWER] ~= nil and playerBuffs[SMH_BUFF_UNSTABLE_POWER].lifetime > castTime then
							switches.temporaryTotal = switches.temporaryTotal + playerBuffs[SMH_BUFF_UNSTABLE_POWER][SMH_BUFF_UNSTABLE_POWER]
						end
						self:OutputMessage("DEBUG", "Setting +healing from buffs for casting time " .. castTime .. " to " .. switches.temporaryTotal)
						cachedPlusHealingBySpellTime[castTime] = switches.temporaryTotal
					end

					temporaryExtraHealingAmount = cachedPlusHealingBySpellTime[castTime]
					if temporaryExtraHealingAmount == nil then temporaryExtraHealingAmount = 0 end

					plusHealAmountToUse = self.extraHealingAmount + temporaryExtraHealingAmount + temporaryPlusHealingBySpell[spellName] + self.spiritualGuidanceModification
					self:OutputMessage("DEBUG", spellName.." base: ".. healAmount .." raw +healing: ".. plusHealAmountToUse.." (E:".. self.extraHealingAmount.." T:".. temporaryExtraHealingAmount.." B:".. temporaryPlusHealingBySpell[spellName].." SG:".. self.spiritualGuidanceModification..")")

					-- For Greater Heal we add a little something on the rare chance we are supposed to do so.
					if spellName == SMH_FAKE_SPELL_COMBINED_HEAL and rankIndex[spellName] > 4 then
						if not switches.modifiedDirectGreaterHealAdd then
							switches.directGreaterHealAdd = switches.directGreaterHealAdd + (plusHealAmountToUse * self.plusHealingAllowedPecentages[SMH_SPELL_RENEW][5])
							switches.modifiedDirectGreaterHealAdd = true
						end
						healAmount = healAmount + switches.directGreaterHealAdd
					end

					--	Now modify the base amount by the amount of extra
					--	healing equipment can do.
					if (plusHealAmountToUse > 0) then
						healAmount = healAmount + (self.plusHealingAllowedPecentages[spellName][rankIndex[spellName]] * plusHealAmountToUse)
					end

					if (((comparisonHealingPercentage / 100) * groupInfo.max) - groupInfo.current) < (healAmount * (percentageHealing / 100)) and spellName ~= SMH_SPELL_POWER_WORD_SHIELD then
						self:OutputMessage("DEBUG", spellName .. "(Rank " .. rankIndex[spellName] .. ") heals " .. healAmount .. " (including " .. self.plusHealingAllowedPecentages[spellName][rankIndex[spellName]] * plusHealAmountToUse .. " from a total of " .. plusHealAmountToUse .. " +healing) with efficiency of "..percentageHealing.."%")
						break
					end
					rankIndex[spellName] = rankIndex[spellName] + 1
				else
					rankIndex[spellName] = rankIndex[spellName] - 1
					break
				end
			end

			-- now alter the rank based on overhealing
			if spellName ~= SMH_SPELL_POWER_WORD_SHIELD then
				trulyDesiredRank = rankIndex[spellName]
				switches.amountToAttemptToRaise = currentConfiguration.overhealRanks[spellName]
				if switches.amountToAttemptToRaise > 0 then
					while (self.cachedSpellBookData[spellName][rankIndex[spellName]] and switches.amountToAttemptToRaise > 0) do
						rankIndex[spellName] = rankIndex[spellName] + 1
						switches.amountToAttemptToRaise = switches.amountToAttemptToRaise - 1
					end
					if not self.cachedSpellBookData[spellName][rankIndex[spellName]] and rankIndex[spellName] > 0 then
						rankIndex[spellName] = rankIndex[spellName] - 1
					end
					if trulyDesiredRank ~= rankIndex[spellName] then
						self:OutputMessage("DEBUG", "For "..spellName.." we really wanted rank "..trulyDesiredRank.." but overheal raised that to rank "..rankIndex[spellName])
					end
				end
			end

			-- now we make sure we raise the spell to the minimum rank desired
			if spellName ~= SMH_SPELL_POWER_WORD_SHIELD then
				if rankIndex[spellName] > 0 then
					rankToUse = currentConfiguration.minRaiseHealRanks[spellName]
					if not self.cachedSpellBookData[spellName][rankToUse] and rankToUse > 0 then
						rankToUse = rankToUse - 1
					end
					if rankIndex[spellName] < rankToUse then
						self:OutputMessage("DEBUG", "For "..spellName.." we wanted to use rank "..rankIndex[spellName].." but configuration requires us to use rank ".. rankToUse..".")
						rankIndex[spellName] = rankToUse
					end
				end			
			end

			--	We need to check to ensure we have enough mana to cast the spell.  There
			--	are a few things that make the check unneeded, and if we have free casting
			--	then we can raise the rank to as high as needed.
			trulyDesiredRank = rankIndex[spellName]		--	record what we really want because we may change it...

			if playerBuffs[SMH_SPELL_INNER_FOCUS] ~= nil or playerBuffs[SMH_SPELL_SPIRIT_OF_REDEMPTION] ~= nil then
				switches.needsToCheckMana = false
			end

			--	Clearcasting will be used to raise the rank of the spell as long as the cast time for
			--	the rank is less than the time remaining on the Clearcasting
			if casterHasClearcasting then
				switches.needsToCheckMana = false
				switches.canRaiseToMax = false
				rankIndex[spellName] = self:GetClearcastingRank(spellName, trulyDesiredRank, myMana, playerBuffs[SMH_SPELL_CLEARCASTING])
			end

			-- now check to ensure we have enough mana to cast the desired spell
			if switches.needsToCheckMana then
				while (rankIndex[spellName] > 0) do
					if (myMana >= self.cachedSpellBookData[spellName][rankIndex[spellName]].mana) then break end
					rankIndex[spellName] = rankIndex[spellName] - 1
				end
				if (trulyDesiredRank ~= rankIndex[spellName]) then
					self:OutputMessage("DEBUG", "For "..spellName.." decided we want rank "..trulyDesiredRank.." but mana limits us to rank "..rankIndex[spellName])
				end
			elseif switches.canRaiseToMax then
				while (self.cachedSpellBookData[spellName][rankIndex[spellName]]) do
					rankIndex[spellName] = rankIndex[spellName] + 1
				end
				rankIndex[spellName] = rankIndex[spellName] - 1		-- get back to where we have a spell
				if (trulyDesiredRank ~= rankIndex[spellName]) then
					self:OutputMessage("DEBUG", "For "..spellName.." decided we want rank "..trulyDesiredRank.." but Inner Focus/Spirit of Redemption allows us to use our highest rank "..rankIndex[spellName])
				end
			end

			-- now check to ensure spell can be cast on level of target
			trulyDesiredRank = rankIndex[spellName]
			if (rankIndex[spellName] > 0) then
				while (rankIndex[spellName] > 0) do
					if (targetLevel + 10 >= self.cachedSpellTargetLevels[spellName][rankIndex[spellName]]) then break end
					rankIndex[spellName] = rankIndex[spellName] - 1
				end
				if (trulyDesiredRank ~= rankIndex[spellName]) then
					self:OutputMessage("DEBUG", "For "..spellName.." "..UnitName(groupInfo.id).." is only level "..targetLevel.." so had to reduce rank from "..trulyDesiredRank.." to rank "..rankIndex[spellName])
				end
			end

			-- now we make sure we are not exceeding the maximum rank of spell we are configured to use
			if spellName ~= SMH_SPELL_POWER_WORD_SHIELD then
				trulyDesiredRank = rankIndex[spellName]
				if rankIndex[spellName] > 0 then
					rankToUse = currentConfiguration.maxHealRanks[spellName]
					if rankIndex[spellName] > rankToUse then
						self:OutputMessage("DEBUG", "For "..spellName.." we wanted to use rank "..trulyDesiredRank.." but configuration limits us to use rank ".. rankToUse)
						rankIndex[spellName] = rankToUse
					end
				end
			end

			-- now we make sure we are at least meeting our minimum expectations for rank of this spell
			if spellName ~= SMH_SPELL_POWER_WORD_SHIELD then
				if rankIndex[spellName] > 0 then
					rankToUse = currentConfiguration.minHealRanks[spellName]
					if rankIndex[spellName] < rankToUse then
						self:OutputMessage("DEBUG", "For "..spellName.." we wanted to use rank "..rankIndex[spellName].." but configuration requires us to use rank ".. rankToUse..", therefore will not use this spell.")
						rankIndex[spellName] = 0
					end
				end
			end

			self:OutputMessage("DEBUG", "For "..spellName.." final rank is "..rankIndex[spellName])
		end

		-- eliminate spells in cooldown
		if self.class == SMH_CLASS_ENGLISH_PRIEST then
			if self.slotPowerWordShield ~= nil and not self:ActionNotInCooldown(self.slotPowerWordShield) then
				rankIndex[SMH_SPELL_POWER_WORD_SHIELD] = 0
				self:OutputMessage("DEBUG", "Cannot cast Power Word: Shield because it is still in cooldown.")
			end
			if self.slotDesperatePrayer ~= nil and not self:ActionNotInCooldown(self.slotDesperatePrayer) then
				rankIndex[SMH_SPELL_DESPERATE_PRAYER] = 0
				self:OutputMessage("DEBUG", "Cannot cast Desperate Prayer because it is still in cooldown.")
			end
		end

		-- eliminate spells that are self-only if target is not self
		if groupInfo.id ~= 'player' then
			if self.class == SMH_CLASS_ENGLISH_PRIEST and self.canHaveDesperatePrayer then
				rankIndex[SMH_SPELL_DESPERATE_PRAYER] = 0
				self:OutputMessage("DEBUG", "Cannot cast Desperate Prayer because recipient is not self.")
			end
		end

		-- eliminate spells that can only be cast on self, party members, or raid members
		if self.class == SMH_CLASS_ENGLISH_PRIEST then
			if groupInfo.id ~= 'player' and not self:UnitInGroup(groupInfo.id) then
				rankIndex[SMH_SPELL_POWER_WORD_SHIELD] = 0
				self:OutputMessage("DEBUG", "Cannot cast Power Word: Shield because recipient not part of group.")
			end
		end

		-- eliminate spells that cannot be cast because one is dead
		if playerBuffs[SMH_SPELL_SPIRIT_OF_REDEMPTION] ~= nil then
			rankIndex[SMH_SPELL_POWER_WORD_SHIELD] = 0
			rankIndex[SMH_SPELL_DESPERATE_PRAYER] = 0
			self:OutputMessage("DEBUG", "As a spirit one cannot cast Power Word: Shield or Desperate Prayer.")
		end

		-- eliminate Regrowth if we trust it is being cast on the recipient
		if self.class == SMH_CLASS_ENGLISH_DRUID then
			if currentConfiguration.otherHealerConfidence >= 50 and self.gettingRegrowthSoon[UnitName(groupInfo.id)] then
				rankIndex[SMH_SPELL_REGROWTH] = 0
				self:OutputMessage("DEBUG", "Eliminated Regrowth because we trust someone else is casting it.")
			end
		end

		-- if we are moving and do not have Nature's Swiftness we are limited to instant spells
		if self.isMoving and not casterHasNaturesSwiftness and not casterHasFocus then
			if self.class == SMH_CLASS_ENGLISH_DRUID then
				rankIndex[SMH_SPELL_REGROWTH] = 0
				rankIndex[SMH_SPELL_HEALING_TOUCH] = 0
				self:OutputMessage("DEBUG", "We are moving without Nature's Swiftness/Focus so are limited to Rejuvenation.")
			elseif self.class == SMH_CLASS_ENGLISH_PALADIN then
				rankIndex[SMH_SPELL_HOLY_LIGHT] = 0
				rankIndex[SMH_SPELL_FLASH_OF_LIGHT] = 0
				self:OutputMessage("DEBUG", "We are moving without Focus so cannot heal.")
			elseif self.class == SMH_CLASS_ENGLISH_PRIEST then
				rankIndex[SMH_SPELL_LESSER_HEAL] = 0
				rankIndex[SMH_SPELL_HEAL] = 0
				rankIndex[SMH_SPELL_GREATER_HEAL] = 0
				rankIndex[SMH_FAKE_SPELL_COMBINED_HEAL] = 0
				rankIndex[SMH_SPELL_FLASH_HEAL] = 0
				self:OutputMessage("DEBUG", "We are moving without Focus so are limited to Renew and Power Word: Shield.")
			elseif self.class == SMH_CLASS_ENGLISH_SHAMAN then
				rankIndex[SMH_SPELL_HEALING_WAVE] = 0
				rankIndex[SMH_SPELL_LESSER_HEALING_WAVE] = 0
				self:OutputMessage("DEBUG", "We are moving without Nature's Swiftness/Focus so cannot heal.")
			end
		end

		-- eliminate spells the target already has
		if self.class == SMH_CLASS_ENGLISH_DRUID then
			if targetBuffs[SMH_SPELL_REGROWTH] ~= nil then
				rankIndex[SMH_SPELL_REGROWTH] = 0
				self:OutputMessage("DEBUG", UnitName(groupInfo.id).." already has Regrowth")
			end
			if targetBuffs[SMH_SPELL_REJUVENATION] ~= nil then
				rankIndex[SMH_SPELL_REJUVENATION] = 0
				self:OutputMessage("DEBUG", UnitName(groupInfo.id).." already has Rejuvenation")
			end
		elseif self.class == SMH_CLASS_ENGLISH_PRIEST then
			if targetBuffs[SMH_SPELL_RENEW] ~= nil then
				rankIndex[SMH_SPELL_RENEW] = 0
				self:OutputMessage("DEBUG", UnitName(groupInfo.id).." already has Renew")
			end
			if targetBuffs[SMH_SPELL_WEAKENED_SOUL] ~= nil then
				rankIndex[SMH_SPELL_POWER_WORD_SHIELD] = 0
				self:OutputMessage("DEBUG", UnitName(groupInfo.id).." has Weakened Soul")
			end
			if targetBuffs[SMH_SPELL_POWER_WORD_SHIELD] ~= nil then
				rankIndex[SMH_SPELL_POWER_WORD_SHIELD] = 0
				self:OutputMessage("DEBUG", UnitName(groupInfo.id).." has Power Word: Shield")
			end
		end

		-- limit ourselves to any type of spell we are forcing ourselves to use
		if healingMode > 0 then
			for i = 1, table.getn(self.healingModeConfiguration[healingMode].nuke), 1 do
				rankIndex[self.healingModeConfiguration[healingMode].nuke[i]] = 0
			end
			self:OutputMessage("DEBUG", "We are limiting ourselves to ".. self.healingModeConfiguration[healingMode].desire .. " because of command.")
		end

		-- if under the really bad debuff we eliminate healing spells because they become damaging spells instead
		if playerBuffs[SMH_BUFF_CORRUPTED_HEALING] ~= nil then
			if self.class == SMH_CLASS_ENGLISH_PRIEST then
				self:OutputMessage("DEBUG", "We are under the influence of ".. SMH_BUFF_CORRUPTED_HEALING.." so are eliminating our healing spells.")
				rankIndex[SMH_SPELL_RENEW] = 0
				rankIndex[SMH_SPELL_LESSER_HEAL] = 0
				rankIndex[SMH_SPELL_HEAL] = 0
				rankIndex[SMH_SPELL_GREATER_HEAL] = 0
				rankIndex[SMH_FAKE_SPELL_COMBINED_HEAL] = 0
				rankIndex[SMH_SPELL_FLASH_HEAL] = 0
			end
		end

		-- now we use our algorithm to determine the spell to cast
		switches.temp = { }
		for n in pairs(currentConfiguration.algorithm) do table.insert(switches.temp, n) end
		table.sort(switches.temp, function(a, b) return SMH:CompareGreaterNumeric(a, b) end)
		for i, n in ipairs(switches.temp) do 
			if (groupInfo.percent * 100) > tonumber(n) then
				self:OutputMessage("DEBUG", string.format("the groupinfo percentage is %d and the table shows %s...a match", groupInfo.percent * 100, n))
				if rankIndex[currentConfiguration.algorithm[n]] > 0 then
					spellToUse = currentConfiguration.algorithm[n]
					self:OutputMessage("DEBUG", string.format("we have found the spell to use in table %s %s", n, spellToUse))
					break
				end
				--	Since we have found an entry that matches the % we will break unless it is Desperate Prayer and we are not healing the player.
				--	We now also control whether the break should happen based on the algorithmFallthrough configuration variable.
				if not currentConfiguration.algorithmFallthrough then
					if currentConfiguration.algorithm[n] ~= SMH_SPELL_DESPERATE_PRAYER or groupInfo.id == 'player' then break end
				end
			end
		end

		-- if no spell has been found using the algorithm do into our default spell list
		if (spellToUse == nil) then
			local tableSize = table.getn(currentConfiguration.defaultSpells)
			for i = 1, tableSize do
				if currentConfiguration.defaultSpells[i][2] and rankIndex[currentConfiguration.defaultSpells[i][1]] > 0 then
					spellToUse = currentConfiguration.defaultSpells[i][1]
					break
				end
			end
		end

		if (spellToUse) then
			spellRank = rankIndex[spellToUse]
			self:OutputMessage("DEBUG", "Decided on "..spellToUse.." Rank("..spellRank..")")

			spellInfo = self.cachedSpellBookData[spellToUse][spellRank]
			estimatedHealAmount = (spellInfo.minHeal + ((spellInfo.maxHeal - spellInfo.minHeal) * currentConfiguration.healPercentage / 100))
			if spellToUse == SMH_FAKE_SPELL_COMBINED_HEAL and spellRank > 4 then estimatedHealAmount = estimatedHealAmount + switches.directGreaterHealAdd end
			local castTime = spellInfo.castTime
			if casterHasNaturesSwiftness or casterHasFocus or castTime == nil then castTime = 0 end
			temporaryExtraHealingAmount = cachedPlusHealingBySpellTime[castTime]
			if temporaryExtraHealingAmount == nil then temporaryExtraHealingAmount = 0 end
			plusHealAmountToUse = self.extraHealingAmount + temporaryExtraHealingAmount + temporaryPlusHealingBySpell[spellToUse] + self.spiritualGuidanceModification
			if (plusHealAmountToUse > 0) then estimatedHealAmount = estimatedHealAmount + (self.plusHealingAllowedPecentages[spellToUse][spellRank] * plusHealAmountToUse) end
			estimatedHealAmount = estimatedHealAmount * (percentageHealing / 100)
		else
			self:OutputMessage("DEBUG", "Found no spell to use")
		end

		return spellToUse, spellRank, abortReason, estimatedHealAmount, playerBuffs
	end,

	--	This routine provides the amount of healing done by the specified spellName at the
	--	specified spellRank under the influence of the specified buffs when targeting the
	--	specified unitId.  If the buffs is nil, the current player's buffs are used.  If
	--	the unitId is nil then any generic recipient is assumed to have no (de)buffs.
	EstimatedHealing = function(self, buffs, spellName, spellRank, unitId)
		local retval = 0
		local playerBuffs = buffs or self:UnitBuffs('player')
		

		return retval
	end,

	--	This routine takes a groupInfo table and optional percentage to return
	--	a table of spell information indicating what spells the player should
	--	cast upon the unit specified in the groupinfo to bring it up to the
	--	percentage health.  When no health passed in, the user default is used.
	DetermineSpells = function(self, groupInfo, targetHealthPercentage, buffs)
		local retval = nil
		if groupInfo ~= nil and self:RealTableSize(groupInfo) == 4 then
			local currentConfiguration = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
			local unitClass = UnitClass(groupInfo.id)
			local desiredPercentage = targetHealthPercentage or currentConfiguration.classHealPercents[unitClass]
			if desiredPercentage >= 0 and desiredPercentage <= self.maximumPercentageHealthAllowed then
				local playerBuffs = buffs or self:UnitBuffs('player')
				local casterHasNaturesSwiftness = (playerBuffs[SMH_SPELL_NATURESSWIFTNESS] ~= nil)
				local casterHasFocus = (playerBuffs[SMH_BUFF_FOCUS] ~= nil)
				local targetBuffs
				if (groupInfo.id == 'player') then targetBuffs = playerBuffs else targetBuffs = self:UnitBuffs(groupInfo.id) end
				local percentageHealing = 100	-- this is used to handle buffs that change how effective healing is
				local healAmount
				local spellInfo
				local spellName
				local temporaryExtraHealingAmount = 0	-- used for trinkets
				local plusHealAmountToUse

				retval = { }
				for i = 1, table.getn(self.classSpellsOfInterest[self.class]), 1 do
					retval[self.classSpellsOfInterest[self.class][i]] = { rank = 1, healAmount = 0 }
				end
				local spellsToCheck = self.classSpellsOfInterest[self.class]
				local directGreaterHealAdd = 0
				local modifiedDirectGreaterHealAdd = false
				local temp = { }
				local temporaryTotal = 0
				local temporaryPlusHealingBySpell = { }
				-- Initialize our temporary array to 0 for each spell of interest
				for i = 1, table.getn(spellsToCheck), 1 do
					temporaryPlusHealingBySpell[spellsToCheck[i]] = 0
				end

				--	Determine what buffs on the recipient and what on the caster influence the
				--	ability to heal.  Basically we modify the percentage of healing that can be
				--	done, starting with 100% and modify from there.
				temp = { }
				for n in pairs(self.buffTargetHealingEffects) do table.insert(temp, n) end
				for i, n in ipairs(temp) do
					if targetBuffs[n] ~= nil then percentageHealing = percentageHealing + (self.buffTargetHealingEffects[n] * targetBuffs[n]["count"]) end
				end
				temp = { }
				for n in pairs(self.buffCasterHealingEffects) do table.insert(temp, n) end
				for i, n in ipairs(temp) do
					if playerBuffs[n] ~= nil then percentageHealing = percentageHealing + (self.buffCasterHealingEffects[n] * playerBuffs[n]["count"]) end
				end
				self.healingEfficiency = percentageHealing

				-- If there is no percentage left for healing abaondon ship
				if percentageHealing <= 0 then return nil end

				--	Determine the spell specific +healing modifications and put them into the table.
				local possibleBuff
				if self.class == SMH_CLASS_ENGLISH_DRUID then
					temporaryPlusHealingBySpell[SMH_SPELL_REJUVENATION] = temporaryPlusHealingBySpell[SMH_SPELL_REJUVENATION] + self.hasItemIdolOfRejuvenation
					if self.hasBenefitDreamwalker then
						temporaryPlusHealingBySpell[SMH_SPELL_REGROWTH] = temporaryPlusHealingBySpell[SMH_SPELL_REGROWTH] + 350	-- hopefully this is truly the proper value
					end
				end
				if self.class == SMH_CLASS_ENGLISH_PALADIN then
					possibleBuff= targetBuffs[SMH_SPELL_GREATER_BLESSING_OF_LIGHT]
					if possibleBuff == nil then possibleBuff = targetBuffs[SMH_SPELL_BLESSING_OF_LIGHT] end
					if possibleBuff ~= nil then
						temporaryPlusHealingBySpell[SMH_SPELL_HOLY_LIGHT] = temporaryPlusHealingBySpell[SMH_SPELL_HOLY_LIGHT] + possibleBuff[SMH_SPELL_HOLY_LIGHT]
						temporaryPlusHealingBySpell[SMH_SPELL_FLASH_OF_LIGHT] = temporaryPlusHealingBySpell[SMH_SPELL_FLASH_OF_LIGHT] + possibleBuff[SMH_SPELL_FLASH_OF_LIGHT]
					end
					temporaryPlusHealingBySpell[SMH_SPELL_FLASH_OF_LIGHT] = temporaryPlusHealingBySpell[SMH_SPELL_FLASH_OF_LIGHT] + self.hasItemLibramOfDivinity
					temporaryPlusHealingBySpell[SMH_SPELL_FLASH_OF_LIGHT] = temporaryPlusHealingBySpell[SMH_SPELL_FLASH_OF_LIGHT] + self.hasItemLibramOfLight
				end
				if self.class == SMH_CLASS_ENGLISH_SHAMAN then
					temporaryPlusHealingBySpell[SMH_SPELL_LESSER_HEALING_WAVE] = temporaryPlusHealingBySpell[SMH_SPELL_LESSER_HEALING_WAVE] + self.hasItemTotemOfLife
					temporaryPlusHealingBySpell[SMH_SPELL_LESSER_HEALING_WAVE] = temporaryPlusHealingBySpell[SMH_SPELL_LESSER_HEALING_WAVE] + self.hasItemTotemOfSustaining
				end

				--	The Stormrage set can change the duration of Rejuvenation so we change the time penalty for it
				if self.class == SMH_CLASS_ENGLISH_DRUID then
					if self.hasBenefitStormrage then
						self.plusHealingAllowedPecentages[SMH_SPELL_REJUVENATION] = { .4, .625, .85, 1, 1, 1, 1, 1, 1, 1, 1 }
					else
						self.plusHealingAllowedPecentages[SMH_SPELL_REJUVENATION] = { .2, .425, .65, .8, .8, .8, .8, .8, .8, .8, .8 }
					end
				end

				--	The Transcendence set can add healing value for the Greater Heal
				if self.class == SMH_CLASS_ENGLISH_PRIEST then
					if self.hasBenefitTranscendance then
						if self.cachedSpellBookData[SMH_SPELL_RENEW] then spellInfo = self.cachedSpellBookData[SMH_SPELL_RENEW][5] else spellInfo = nil end
						if spellInfo then
							directGreaterHealAdd = spellInfo.minHeal + ((spellInfo.maxHeal - spellInfo.minHeal) * currentConfiguration.healPercentage / 100)
						end
					end
				end

				local cachedPlusHealingBySpellTime = { }
				modifiedDirectGreaterHealAdd = false
				for i = 1, table.getn(spellsToCheck), 1 do		-- loop through each of spellsToCheck
					spellName = spellsToCheck[i]

					-- first determine the level of spell needed based on healing required
					while (true) do
						spellInfo = self.cachedSpellBookData[spellName][retval[spellName].rank]
						if (spellInfo) then

							--	Determine the base heal amount garnered from the
							--	tooltip for each spell.  This includes modifications
							--	from talents, but not from equipment.  It uses the
							--	technique the user wants for healing to determine
							--	where in the range of healing the target should be.
							healAmount = (spellInfo.minHeal + ((spellInfo.maxHeal - spellInfo.minHeal) * currentConfiguration.healPercentage / 100))

							--	Deteremine which +healing buffs will still be active at the
							--	end of the normal time it takes to cast this buff.
							local castTime = spellInfo.castTime
							if casterHasNaturesSwiftness or casterHasFocus or castTime == nil then castTime = 0 end

							if cachedPlusHealingBySpellTime[castTime] == nil then
								temp = { }
								temporaryTotal = 0
								for n in pairs(self.buffCasterPlusHealingEffects) do table.insert(temp, n) end
								for i, n in ipairs(temp) do
									if playerBuffs[n] ~= nil and playerBuffs[n].lifetime > castTime then
										temporaryTotal = temporaryTotal + self.buffCasterPlusHealingEffects[n]
									end
								end
								--	Since Unstable Power varies we need to treat it separately
								if playerBuffs[SMH_BUFF_UNSTABLE_POWER] ~= nil and playerBuffs[SMH_BUFF_UNSTABLE_POWER].lifetime > castTime then
									temporaryTotal = temporaryTotal + playerBuffs[SMH_BUFF_UNSTABLE_POWER][SMH_BUFF_UNSTABLE_POWER]
								end
								self:OutputMessage("DEBUG", "Setting +healing from buffs for casting time " .. castTime .. " to " .. temporaryTotal)
								cachedPlusHealingBySpellTime[castTime] = temporaryTotal
							end

							temporaryExtraHealingAmount = cachedPlusHealingBySpellTime[castTime]
							if temporaryExtraHealingAmount == nil then temporaryExtraHealingAmount = 0 end

							plusHealAmountToUse = self.extraHealingAmount + temporaryExtraHealingAmount + temporaryPlusHealingBySpell[spellName] + self.spiritualGuidanceModification
							self:OutputMessage("DEBUG", spellName.." base: ".. healAmount .." raw +healing: ".. plusHealAmountToUse.." (E:".. self.extraHealingAmount.." T:".. temporaryExtraHealingAmount.." B:".. temporaryPlusHealingBySpell[spellName].." SG:".. self.spiritualGuidanceModification..")")

							-- For Greater Heal we add a little something on the rare chance we are supposed to do so.
							if spellName == SMH_FAKE_SPELL_COMBINED_HEAL and retval[spellName].rank > 4 then
								if not modifiedDirectGreaterHealAdd then
									directGreaterHealAdd = directGreaterHealAdd + (plusHealAmountToUse * self.plusHealingAllowedPecentages[SMH_SPELL_RENEW][5])
									modifiedDirectGreaterHealAdd = true
								end
								healAmount = healAmount + directGreaterHealAdd
							end

							--	Now modify the base amount by the amount of extra
							--	healing equipment can do.
							if (plusHealAmountToUse > 0) then
								healAmount = healAmount + (self.plusHealingAllowedPecentages[spellName][retval[spellName].rank] * plusHealAmountToUse)
							end
							retval[spellName].healAmount = healAmount * (percentageHealing / 100)
							self:OutputMessage("DEBUG", spellName .. "(Rank " .. retval[spellName].rank .. ") heals " .. healAmount .. " (including " .. self.plusHealingAllowedPecentages[spellName][retval[spellName].rank] * plusHealAmountToUse .. " from a total of " .. plusHealAmountToUse .. " +healing) with efficiency of "..percentageHealing.."%")

							if (((desiredPercentage / 100) * groupInfo.max) - groupInfo.current) < retval[spellName].healAmount and spellName ~= SMH_SPELL_POWER_WORD_SHIELD then
								break
							end
							retval[spellName].rank = retval[spellName].rank + 1
						else
							retval[spellName].rank = retval[spellName].rank - 1
							break
						end
					end
				end

			else
				self:OutputMessage("DEBUG", "Target health percentage of " .. desiredPercentage .. " out of acceptable range 0 - " .. self.maximumPercentageHealthAllowed)
			end
		else
			self:OutputMessage("DEBUG", "Malformed groupInfo structure.")
		end
		return retval
	end,

	--	This convenience routine takes a unitId and optional percentage to return
	--	a table of spell information indicating what spells the player should cast
	--	upon the unitId to bring it up to percentage health.  With no health passed
	--	in, the user default is used instead.
	DetermineSpellsForUnit = function(self, unitId, targetHealthPercentage)
		local retval = nil
		if unitId ~= nil then
			local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
			local unitClass = UnitClass(unitId)
			local desiredPercentage = targetHealthPercentage or currentProfile.classHealPercents[unitClass]
			if desiredPercentage >= 0 and desiredPercentage <= self.maximumPercentageHealthAllowed then
				local targetMaxHealth
				local targetCurrentHealth
				if self:UnitInGroup(unitId) then
					targetMaxHealth = UnitHealthMax(unitId)
					targetCurrentHealth = UnitHealth(unitId)
				else	-- we estimate the health information based on the level and class of the unit
					local slope = (self.maxClassHealth[unitClass] - 30) / 59
					targetMaxHealth = UnitLevel(unitId) * slope + 30
					targetCurrentHealth = targetMaxHealth * (UnitHealth(unitId) / 100)
				end

				-- now we determine if there are other heals that need to be handled when processing this recipient
				local characterName = UnitName(unitId)
				self:ProcessOtherHeals()
				local possibleHealingForUnit = self.currentOtherHealsByCharacter[characterName]
				if possibleHealingForUnit == nil then possibleHealingForUnit = 0 end
				targetCurrentHealth = targetCurrentHealth + possibleHealingForUnit * (currentProfile.otherHealerConfidence / 100)

				retval = self:DetermineSpells({ id = unitId, percent = targetCurrentHealth / targetMaxHealth, current = targetCurrentHealth, max = targetMaxHealth }, desiredPercentage)
			else
				self:OutputMessage("DEBUG", "Target health percentage of " .. desiredPercentage .. " out of acceptable range 0 - " .. self.maximumPercentageHealthAllowed)
			end
		else
			self:OutputMessage("DEBUG", "No unitId specified.")
		end
		return retval
	end,

	FindHealingSlot = function(self)
		self:OutputMessage("DEBUG", "==> Finding healing slot")
		self.slotHealing = nil
		self.slotSwiftNature = nil
		self.slotPowerWordShield = nil
		self.slotDesperatePrayer = nil
		self.slotBuff = nil

		local slotName
		for i = 1, 120 do
			if (HasAction(i)) then
				smhTooltip:SetAction(i)
				slotName = smhTooltipTextLeft1:GetText()

				if (self.class == SMH_CLASS_ENGLISH_DRUID or self.class == SMH_CLASS_ENGLISH_SHAMAN) and slotName == SMH_SPELL_NATURESSWIFTNESS then
					self.slotSwiftNature = i
				elseif self.class == SMH_CLASS_ENGLISH_PRIEST and slotName == SMH_SPELL_POWER_WORD_SHIELD then
					self.slotPowerWordShield = i
				elseif self.class == SMH_CLASS_ENGLISH_PRIEST and self.canHaveDesperatePrayer and slotName == SMH_SPELL_DESPERATE_PRAYER then
					self.slotDesperatePrayer = i
				elseif self.spellsOfInterest[slotName] then
					self.slotHealing = i
				elseif self.buffsOfInterest[slotName] then
					self.slotBuff = i
				end
			end
			if (self.slotHealing ~= nil
				and self.slotBuff ~= nil
				and (self.slotSwiftNature ~= nil or (self.class ~= SMH_CLASS_ENGLISH_DRUID and self.class ~= SMH_CLASS_ENGLISH_SHAMAN))
				and (self.slotPowerWordShield ~= nil or self.class ~= SMH_CLASS_ENGLISH_PRIEST)
				and (self.slotDesperatePrayer ~= nil or self.class ~= SMH_CLASS_ENGLISH_PRIEST)
				) then break end
		end
		if (self.slotHealing ~= nil) then self:OutputMessage("DEBUG", "Healing slot is ".. self.slotHealing) else self:OutputMessage("DEBUG", "!!! Did Not find healing slot!!!") end
		if self.slotBuff ~= nil then self:OutputMessage("DEBUG", "Buff slot is ".. self.slotBuff) else self:OutputMessage("DEBUG", "!!! Did not find buff slot!!!") end
		if self.class == SMH_CLASS_ENGLISH_DRUID or self.class == SMH_CLASS_ENGLISH_SHAMAN then
			if self.slotSwiftNature ~= nil then self:OutputMessage("DEBUG", "Nat. Swift. slot is ".. self.slotSwiftNature) else self:OutputMessage("DEBUG", "!!! Did Not find Nat. Swift. slot!!!") end
		end
		if self.class == SMH_CLASS_ENGLISH_PRIEST then
			if (self.slotPowerWordShield ~= nil) then self:OutputMessage("DEBUG", "Power Word: Shield slot is ".. self.slotPowerWordShield) else self:OutputMessage("DEBUG", "Did not find Power Word: Shield slot!!!") end
			if self.canHaveDesperatePrayer then
				if self.slotDesperatePrayer ~= nil then self:OutputMessage("DEBUG", "Desperate Prayer slot is ".. self.slotDesperatePrayer) else self:OutputMessage("DEBUG", "Did not find Desperate Prayer slot!!!") end
			end
		end
	end,

	Frame_Update = function(self)
		local numberTabs = getn(_smh_optionTabs)
		for i = 1, numberTabs, 1 do
			getglobal("com_mithrandir_smhTab" .. i):Show()
		end
	end,

	GetClearcastingRank = function(self, spellName, desiredRank, myMana, clearcastingBuff)
		local retval = desiredRank

		--	Deteremine whether the spell rank would normally have to be lowered based on mana
		local maxRankManaAllows = desiredRank
		while (maxRankManaAllows > 0) do
			if myMana >= self.cachedSpellBookData[spellName][maxRankManaAllows].mana then break end
			maxRankManaAllows = maxRankManaAllows - 1
		end

		--	Determine the highest rank that can be cast within the time limit of Clearcasting
		local highestTimeBasedRank = 1
		while (self.cachedSpellBookData[spellName][highestTimeBasedRank]) do
			if clearcastingBuff.lifetime < self.cachedSpellBookData[spellName][highestTimeBasedRank].castTime then break end
			highestTimeBasedRank = highestTimeBasedRank + 1
		end
		highestTimeBasedRank = highestTimeBasedRank - 1

		if highestTimeBasedRank > maxRankManaAllows then retval = highestTimeBasedRank else retval = maxRankManaAllows end

		if desiredRank ~= retval then self:OutputMessage("DEBUG", "For " .. spellName .. " decided we want rank " .. desiredRank .. " but Clearcasting (" .. clearcastingBuff.lifetime .. " secs) and mana of " .. myMana .. " changed the rank to " .. retval) end

		return retval
	end,

	HasBuff = function(self, unitName, buffName, checkingDebuff)
		local retval = false
		local texture
		for i=0,16,1 do
			if checkingDebuff then texture = UnitDebuff(unitName, i) else texture = UnitBuff(unitName, i) end
			if texture then
				if checkingDebuff then smhTooltip:SetUnitDebuff(unitName, i) else smhTooltip:SetUnitBuff(unitName, i) end
				if smhTooltipTextLeft1:GetText() == buffName then
					retval = true
					self:OutputMessage("DEBUG", unitName .. " has buff " .. buffName)
					break
				end
			end
		end
		return retval
	end,

	Help = function(self)
		local helpCount = table.getn(SMH_HELP_LINES)
		for i = 1, helpCount, 1 do
			self:OutputMessage("INFO", string.format(SMH_HELP_LINES[i], self.addonMacroCommand))
		end
	end,

	Init = function(self)
		SlashCmdList["SMH"] = function(msg)
			self:SlashCommand(msg)
		end
		SLASH_SMH1 = self.addonMacroCommand

		--	Ensure our tooltip is not messed up.
		if not smhTooltip:IsOwned(UIParent) then
			smhTooltip:SetOwner(UIParent, "ANCHOR_NONE")
		end

		-- TODO:  Think about changing these function definitions into functions like PISecond and then make the calls take this into account if possible
		self.spellParsersMaxHeal = {
			[SMH_CLASS_ENGLISH_DRUID] = { [SMH_SPELL_HEALING_TOUCH] = function(a) return SMH:PISecond(a) end, [SMH_SPELL_REJUVENATION] = function(a) return SMH:PIFirst(a) end, [SMH_SPELL_REGROWTH] = function(a) return SMH:PISecondThird(a) end },
			[SMH_CLASS_ENGLISH_PALADIN] = { [SMH_SPELL_HOLY_LIGHT] = function(a) return SMH:PISecond(a) end, [SMH_SPELL_FLASH_OF_LIGHT] = function(a) return SMH:PISecond(a) end },
			[SMH_CLASS_ENGLISH_PRIEST] = { [SMH_SPELL_LESSER_HEAL] = function(a) return SMH:PISecond(a) end, [SMH_SPELL_HEAL] = function(a) return SMH:PISecond(a) end, [SMH_SPELL_GREATER_HEAL] = function(a) return SMH:PISecond(a) end, [SMH_SPELL_RENEW] = function(a) return SMH:PIFirst(a) end, [SMH_SPELL_FLASH_HEAL] = function(a) return SMH:PISecond(a) end, [SMH_SPELL_DESPERATE_PRAYER] = function(a) return SMH:PISecond(a) end },
			[SMH_CLASS_ENGLISH_SHAMAN] = { [SMH_SPELL_HEALING_WAVE] = function(a) return SMH:PISecond(a) end, [SMH_SPELL_LESSER_HEALING_WAVE] = function(a) return SMH:PISecond(a) end },
			}
		self.spellParsersMinHeal = {
			[SMH_CLASS_ENGLISH_DRUID] = { [SMH_SPELL_HEALING_TOUCH] = function(a) return SMH:PIFirst(a) end, [SMH_SPELL_REJUVENATION] = function(a) return SMH:PIFirst(a) end, [SMH_SPELL_REGROWTH] = function(a) return SMH:PIFirstThird(a) end, },
			[SMH_CLASS_ENGLISH_PALADIN] = { [SMH_SPELL_HOLY_LIGHT] = function(a) return SMH:PIFirst(a) end, [SMH_SPELL_FLASH_OF_LIGHT] = function(a) return SMH:PIFirst(a) end },
			[SMH_CLASS_ENGLISH_PRIEST] = { [SMH_SPELL_LESSER_HEAL] = function(a) return SMH:PIFirst(a) end, [SMH_SPELL_HEAL] = function(a) return SMH:PIFirst(a) end, [SMH_SPELL_GREATER_HEAL] = function(a) return SMH:PIFirst(a) end, [SMH_SPELL_RENEW] = function(a) return SMH:PIFirst(a) end, [SMH_SPELL_FLASH_HEAL] = function(a) return SMH:PIFirst(a) end, [SMH_SPELL_DESPERATE_PRAYER] = function(a) return SMH:PIFirst(a) end },
			[SMH_CLASS_ENGLISH_SHAMAN] = { [SMH_SPELL_HEALING_WAVE] = function(a) return SMH:PIFirst(a) end, [SMH_SPELL_LESSER_HEALING_WAVE] = function(a) return SMH:PIFirst(a) end },
			}

		self.priorityLabels = {
			self.colorRed .. SMH_PRIORITY_LABEL_IGNORED .. self.colorStop,
			self.colorYellow .. SMH_PRIORITY_LABEL_LOW .. self.colorStop,
			self.colorGreen .. SMH_PRIORITY_LABEL_NORMAL .. self.colorStop,
			self.colorBlue .. SMH_PRIORITY_LABEL_HIGH .. self.colorStop,
			}

		self.messageLabels = {
			self.colorRed .. SMH_MESSAGE_LABEL_NONE .. self.colorStop,
			SMH_MESSAGE_LABEL_CHAT,
			SMH_MESSAGE_LABEL_COMBAT,
			SMH_MESSAGE_LABEL_ERROR,
			self.colorBlue .. SMH_MESSAGE_LABEL_PARTY .. self.colorStop,
			}

		self.commandFunctions = {
			[SMH_COMMAND_HELP] = function() SMH:Help() end ,
			[SMH_COMMAND_UI] = function() SMH:Options_ShowHide() end,
			[SMH_COMMAND_TEST] = function() SMH:Test() end,
			[SMH_COMMAND_SELF] = function() SMH:CastHealSelf() end,
			}

		local tableSize = table.getn(self.classBuffsOfInterest[self.class])
		for i = 1, tableSize, 1 do
			self.buffsOfInterest[self.classBuffsOfInterest[self.class][i]] = true
		end

		--	Populate the help system with the class specific lines
		for i = 1, table.getn(SMH_CLASS_HELP_LINES[self.class]), 1 do
			table.insert(SMH_HELP_LINES, i + 1, SMH_CLASS_HELP_LINES[self.class][i])
		end

		--	Here we populate the default configuration information
		--	with data that is class specific.
		if self.class == SMH_CLASS_ENGLISH_DRUID then
			self.configurationDefaults.algorithm = {
				["75"] = SMH_SPELL_REJUVENATION,
				["50"] = SMH_SPELL_REGROWTH,
				["25"] = SMH_SPELL_HEALING_TOUCH,
				["0"] = SMH_SPELL_REGROWTH,
				}
			self.configurationDefaults.defaultSpells = { 
				{ SMH_SPELL_REJUVENATION, true },
				{ SMH_SPELL_REGROWTH, true },
				{ SMH_SPELL_HEALING_TOUCH, true },
				}
			self.configurationDefaults.overhealRanks = {
				[SMH_SPELL_REJUVENATION] = 0,
				[SMH_SPELL_REGROWTH] = 0,
				[SMH_SPELL_HEALING_TOUCH] = 0,
				}
			self.configurationDefaults.maxHealRanks = {
				[SMH_SPELL_REJUVENATION] = table.getn(self.levelLearned[SMH_SPELL_REJUVENATION]),
				[SMH_SPELL_REGROWTH] = table.getn(self.levelLearned[SMH_SPELL_REGROWTH]),
				[SMH_SPELL_HEALING_TOUCH] = table.getn(self.levelLearned[SMH_SPELL_HEALING_TOUCH]),
				}
			self.configurationDefaults.minHealRanks = {
				[SMH_SPELL_REJUVENATION] = 1,
				[SMH_SPELL_REGROWTH] = 1,
				[SMH_SPELL_HEALING_TOUCH] = 1,
				}
			self.configurationDefaults.minRaiseHealRanks = {
				[SMH_SPELL_REJUVENATION] = 1,
				[SMH_SPELL_REGROWTH] = 1,
				[SMH_SPELL_HEALING_TOUCH] = 1,
				}
			self.commandParameters[SMH_COMMAND_NATURE] = "checkingNaturesSwiftness"
			self.commandFunctions[SMH_COMMAND_MOONFIRE] = function() SMH:CastMoonfire() end
			self.commandHeals[SMH_COMMAND_HEALINGTOUCH] = 1
			self.commandHeals[SMH_COMMAND_REGROWTH] = 2
			self.commandHeals[SMH_COMMAND_REJUVENATION] = 3
			self.commandBuffs[SMH_COMMAND_MARKOFTHEWILD] = SMH_SPELL_MARK_OF_THE_WILD
			self.commandBuffs[SMH_COMMAND_THORNS] = SMH_SPELL_THORNS
		elseif self.class == SMH_CLASS_ENGLISH_PALADIN then
			self.configurationDefaults.algorithm = {
				["75"] = SMH_SPELL_HOLY_LIGHT,
				["0"] = SMH_SPELL_FLASH_OF_LIGHT,
				}
			self.configurationDefaults.defaultSpells = { 
				{ SMH_SPELL_FLASH_OF_LIGHT, true },
				{ SMH_SPELL_HOLY_LIGHT, true },
				}
			self.configurationDefaults.overhealRanks = {
				[SMH_SPELL_FLASH_OF_LIGHT] = 0,
				[SMH_SPELL_HOLY_LIGHT] = 0,
				}
			self.configurationDefaults.maxHealRanks = {
				[SMH_SPELL_FLASH_OF_LIGHT] = table.getn(self.levelLearned[SMH_SPELL_FLASH_OF_LIGHT]),
				[SMH_SPELL_HOLY_LIGHT] = table.getn(self.levelLearned[SMH_SPELL_HOLY_LIGHT]),
				}
			self.configurationDefaults.minHealRanks = {
				[SMH_SPELL_FLASH_OF_LIGHT] = 1,
				[SMH_SPELL_HOLY_LIGHT] = 1,
				}
			self.configurationDefaults.minRaiseHealRanks = {
				[SMH_SPELL_FLASH_OF_LIGHT] = 1,
				[SMH_SPELL_HOLY_LIGHT] = 1,
				}
			self.commandHeals[SMH_COMMAND_HOLYLIGHT] = 4
			self.commandHeals[SMH_COMMAND_FLASHOFLIGHT] = 5
			self.commandBuffs[SMH_COMMAND_BLESSINGOFMIGHT] = SMH_SPELL_BLESSING_OF_MIGHT
			self.commandBuffs[SMH_COMMAND_BLESSINGOFPROTECTION] = SMH_SPELL_BLESSING_OF_PROTECTION
			self.commandBuffs[SMH_COMMAND_BLESSINGOFWISDOM] = SMH_SPELL_BLESSING_OF_WISDOM
			self.commandBuffs[SMH_COMMAND_BLESSINGOFLIGHT] = SMH_SPELL_BLESSING_OF_LIGHT
			self.commandBuffs[SMH_COMMAND_BLESSINGOFSACRIFICE] = SMH_SPELL_BLESSING_OF_SACRIFICE
		elseif self.class == SMH_CLASS_ENGLISH_PRIEST then
			self.configurationDefaults.algorithm = {
				["75"] = SMH_SPELL_FLASH_HEAL,
				["0"] = SMH_SPELL_GREATER_HEAL,
				}
			self.configurationDefaults.defaultSpells = {
				{ SMH_FAKE_SPELL_COMBINED_HEAL, true },
				{ SMH_SPELL_LESSER_HEAL, true },
				{ SMH_SPELL_RENEW, true },
				{ SMH_SPELL_FLASH_HEAL, true},
				{ SMH_SPELL_POWER_WORD_SHIELD, true},
				}
			self.configurationDefaults.overhealRanks = {
				[SMH_FAKE_SPELL_COMBINED_HEAL] = 0,
				[SMH_SPELL_LESSER_HEAL] = 0,
				[SMH_SPELL_RENEW] = 0,
				[SMH_SPELL_FLASH_HEAL] = 0,
				}
			self.configurationDefaults.maxHealRanks = {
				[SMH_FAKE_SPELL_COMBINED_HEAL] = table.getn(self.levelLearned[SMH_FAKE_SPELL_COMBINED_HEAL]),
				[SMH_SPELL_LESSER_HEAL] = table.getn(self.levelLearned[SMH_SPELL_LESSER_HEAL]),
				[SMH_SPELL_RENEW] = table.getn(self.levelLearned[SMH_SPELL_RENEW]),
				[SMH_SPELL_FLASH_HEAL] = table.getn(self.levelLearned[SMH_SPELL_FLASH_HEAL]),
				}
			self.configurationDefaults.minHealRanks = {
				[SMH_FAKE_SPELL_COMBINED_HEAL] = 1,
				[SMH_SPELL_LESSER_HEAL] = 1,
				[SMH_SPELL_RENEW] = 1,
				[SMH_SPELL_FLASH_HEAL] = 1,
				}
			self.configurationDefaults.minRaiseHealRanks = {
				[SMH_FAKE_SPELL_COMBINED_HEAL] = 1,
				[SMH_SPELL_LESSER_HEAL] = 1,
				[SMH_SPELL_RENEW] = 1,
				[SMH_SPELL_FLASH_HEAL] = 1,
				}
			self.commandHeals[SMH_COMMAND_LESSERHEAL] = 6
			self.commandHeals[SMH_COMMAND_HEAL] = 7
			self.commandHeals[SMH_COMMAND_DESPERATEPRAYER] = 8
			self.commandHeals[SMH_COMMAND_RENEW] = 9
			self.commandHeals[SMH_COMMAND_FLASHHEAL] = 10
			self.commandHeals[SMH_COMMAND_POWERWORDSHIELD] = 13
			self.commandBuffs[SMH_COMMAND_POWERWORD_SHIELD] = SMH_SPELL_POWER_WORD_SHIELD
			self.commandBuffs[SMH_COMMAND_POWERWORD_FORTITUDE] = SMH_SPELL_POWER_WORD_FORTITUDE
			self.commandBuffs[SMH_COMMAND_DIVINESPIRIT] = SMH_SPELL_DIVINE_SPIRIT
			self.commandBuffs[SMH_COMMAND_SHADOWPROTECTION] = SMH_SPELL_SHADOW_PROTECTION
			if self.canHaveDesperatePrayer then
				self.configurationDefaults.overhealRanks[SMH_SPELL_DESPERATE_PRAYER] = 0
				self.configurationDefaults.maxHealRanks[SMH_SPELL_DESPERATE_PRAYER] = table.getn(self.levelLearned[SMH_SPELL_DESPERATE_PRAYER])
				self.configurationDefaults.minHealRanks[SMH_SPELL_DESPERATE_PRAYER] = 1
				self.configurationDefaults.minRaiseHealRanks[SMH_SPELL_DESPERATE_PRAYER] = 1
				table.insert(self.configurationDefaults.defaultSpells, { SMH_SPELL_DESPERATE_PRAYER, true })
				table.insert(self.classSpellsOfInterest[SMH_CLASS_ENGLISH_PRIEST], SMH_SPELL_DESPERATE_PRAYER)
			end
			table.insert(self.classSpellsOfInterest[SMH_CLASS_ENGLISH_PRIEST], SMH_SPELL_POWER_WORD_SHIELD)
		elseif self.class == SMH_CLASS_ENGLISH_SHAMAN then
			self.configurationDefaults.algorithm = {
				["75"] = SMH_SPELL_LESSER_HEALING_WAVE,
				["0"] = SMH_SPELL_HEALING_WAVE,
				}
			self.configurationDefaults.defaultSpells = { 
				{ SMH_SPELL_HEALING_WAVE, true },
				{ SMH_SPELL_LESSER_HEALING_WAVE, true },
				}
			self.configurationDefaults.overhealRanks = {
				[SMH_SPELL_HEALING_WAVE] = 0,
				[SMH_SPELL_LESSER_HEALING_WAVE] = 0,
				}
			self.configurationDefaults.maxHealRanks = {
				[SMH_SPELL_HEALING_WAVE] = table.getn(self.levelLearned[SMH_SPELL_HEALING_WAVE]),
				[SMH_SPELL_LESSER_HEALING_WAVE] = table.getn(self.levelLearned[SMH_SPELL_LESSER_HEALING_WAVE]),
				}
			self.configurationDefaults.minHealRanks = {
				[SMH_SPELL_HEALING_WAVE] = 1,
				[SMH_SPELL_LESSER_HEALING_WAVE] = 1,
				}
			self.configurationDefaults.minRaiseHealRanks = {
				[SMH_SPELL_HEALING_WAVE] = 1,
				[SMH_SPELL_LESSER_HEALING_WAVE] = 1,
				}
			self.commandHeals[SMH_COMMAND_HEALINGWAVE] = 11
			self.commandHeals[SMH_COMMAND_LESSERHEALINGWAVE] = 12
			self.commandParameters[SMH_COMMAND_NATURE] = "checkingNaturesSwiftness"
		end

		--	Populate the spells of interest convenience table.
		local tableSize = table.getn(self.classSpellsOfInterest[self.class])
		for i = 1, tableSize, 1 do
			self.spellsOfInterest[self.classSpellsOfInterest[self.class][i]] = true
		end

		--	Check to ensure we actually have a saved variable file and if not create
		--	a default one.
		if nil == SMH_Configuration or self:RealTableSize(SMH_Configuration) < 2 then
			SMH_Configuration.currentProfile = SMH_DEFAULT_PROFILE_NAME
			SMH_Configuration.profiles = { }
			SMH_Configuration.profiles[SMH_Configuration.currentProfile] = self:CopyTable(self.configurationDefaults)
		end

		--	In version 0.9.7 we have added profiles and therefore we need to detect whether the
		--	SMH_Configuration that is read in has the proper profiles set up and if not we take
		--	the stored values and convert them to a default profile.
		if nil == SMH_Configuration.currentProfile then
			local temp = { }
			for key in pairs(SMH_Configuration) do
				temp[key] = SMH_Configuration[key]
				SMH_Configuration[key] = nil
			end
			SMH_Configuration.currentProfile = SMH_DEFAULT_PROFILE_NAME
			SMH_Configuration.profiles = { }
			SMH_Configuration.profiles[SMH_Configuration.currentProfile] = temp
		end

		--	In version 0.9.9.1 we have switched control over where messages are sent to sliders
		--	for the different types of messages.  Therefore, we need to set the default values
		--	for each of the saved profiles for these message places based on the switch settings.
		local temp = { }
		local messageLocation
		for n in pairs(SMH_Configuration.profiles) do table.insert(temp, n) end
		for i, n in ipairs(temp) do
			if nil ~= SMH_Configuration.profiles[n].messagesParty or nil ~= SMH_Configuration.profiles[n].debug or SMH_Configuration.profiles[n].messagesChat or SMH_Configuration.profiles[n].combatViceChat then
				--	first create the basic structure
				SMH_Configuration.profiles[n].messagePlaces = { }
				for key in pairs(self.configurationDefaults.messagePlaces) do SMH_Configuration.profiles[n].messagePlaces[key] = self.configurationDefaults.messagePlaces[key] end
				--	then configure it based on the profile's settings
				messageLocation = 0
				if SMH_Configuration.profiles[n].messagesChat then messageLocation = 1 end
				if SMH_Configuration.profiles[n].combatViceChat then messageLocation = 2 end
				if SMH_Configuration.profiles[n].debug then
					local debugLocation = messageLocation
					if debugLocation == 0 then debugLocation = 1 end
					SMH_Configuration.profiles[n].messagePlaces["DEBUG"] = debugLocation
				end
				if not SMH_Configuration.profiles[n].messagesParty then
					SMH_Configuration.profiles[n].messagePlaces["CAST"] = messageLocation
				end
				SMH_Configuration.profiles[n].messagePlaces["INFO"] = messageLocation
				SMH_Configuration.profiles[n].messagePlaces["ERROR"] = messageLocation
				SMH_Configuration.profiles[n].messagePlaces["CASTNOPARTY"] = messageLocation
			end

			--	In version 0.9.9.2 we have added the capability to ignore default spells so
			--	we must make sure all previous versions have their data structures include
			--	the required information.
			if type(SMH_Configuration.profiles[n].defaultSpells[1]) ~= 'table' then
				local newTable = { }
				for j = 1, table.getn(SMH_Configuration.profiles[n].defaultSpells), 1 do
					newTable[j] = { SMH_Configuration.profiles[n].defaultSpells[j], true }
				end
				SMH_Configuration.profiles[n].defaultSpells = newTable
			end

			--	In version 0.9.9.2 we have detected an error that was put in place in 0.9.8
			--	where Priests were given Desperate Prayer in their default spells when they
			--	should not have it.  Therefore, we will remove it here.
			if self.class == SMH_CLASS_ENGLISH_PRIEST and not self.canHaveDesperatePrayer then
				local newTable = { }
				local newIndex = 1
				for j = 1, table.getn(SMH_Configuration.profiles[n].defaultSpells), 1 do
					if SMH_Configuration.profiles[n].defaultSpells[j][1] ~= SMH_SPELL_DESPERATE_PRAYER then
						newTable[newIndex] = SMH_Configuration.profiles[n].defaultSpells[j]
						newIndex = newIndex + 1
					end
				end
				SMH_Configuration.profiles[n].defaultSpells = newTable
			end

		end

		self:Defaults_Update(false)

		--	If the current profile does not actually exist in the set of profiles
		--	we set the current profile to something that does exist.
		if nil == SMH_Configuration.profiles[SMH_Configuration.currentProfile] then
			self:Profile_SetName(self:Profile_First())
		end

		--	In version 0.9.8 we have combined Greater Heal and Heal into one fake spell so this
		--	means all earlier profiles will need to be adjusted to ensure the old spells are removed
		--	and replaced properly with the new fake spell.  This includes defaultSpells, algorithm
		--	and overhealRanks.
		if self.class == SMH_CLASS_ENGLISH_PRIEST then
			local temp = { }

			for n in pairs(SMH_Configuration.profiles) do table.insert(temp, n) end
			for i, n in ipairs(temp) do

				--	Ensure overhealRanks are updated.
				if nil ~= SMH_Configuration.profiles[n].overhealRanks[SMH_SPELL_HEAL] then
					SMH_Configuration.profiles[n].overhealRanks[SMH_SPELL_HEAL] = nil
					SMH_Configuration.profiles[n].overhealRanks[SMH_FAKE_SPELL_COMBINED_HEAL] = SMH_Configuration.profiles[n].overhealRanks[SMH_SPELL_GREATER_HEAL]
					SMH_Configuration.profiles[n].overhealRanks[SMH_SPELL_GREATER_HEAL] = nil
					SMH_Configuration.profiles[n].overhealRanks[SMH_SPELL_DESPERATE_PRAYER] = 0
				end

				--	Ensure defaultSpells are updated.
				local temp2 = { }
				local foundPowerWordShield = false
				local foundDesperatePrayer = false
				local healLocation = nil
			for nn in pairs(SMH_Configuration.profiles[n].defaultSpells) do table.insert(temp2, nn) end
				for ii, nn in ipairs(temp2) do
					local spellName = SMH_Configuration.profiles[n].defaultSpells[nn][1]
					if spellName == SMH_SPELL_POWER_WORD_SHIELD then
						foundPowerWordShield = true
					elseif spellName == SMH_SPELL_DESPERATE_PRAYER then
						foundDesperatePrayer = true
					elseif spellName == SMH_SPELL_GREATER_HEAL then
						SMH_Configuration.profiles[n].defaultSpells[nn][1] = SMH_FAKE_SPELL_COMBINED_HEAL
					elseif spellName == SMH_SPELL_HEAL then
						healLocation = nn
					end
				end
				if nil ~= healLocation then
					for i = healLocation, table.getn(temp2) - 1, 1 do
						SMH_Configuration.profiles[n].defaultSpells[i] = SMH_Configuration.profiles[n].defaultSpells[i + 1]
					end
					SMH_Configuration.profiles[n].defaultSpells[table.getn(temp2)] = nil
				end
				--	The following is done because in 0.9.7 Power Word: Shield was added and any
				--	older profiles will need to have this added.
				if not foundPowerWordShield then
					table.insert(SMH_Configuration.profiles[n].defaultSpells, { SMH_SPELL_POWER_WORD_SHIELD, true })
				end
				--	Desperate Prayer was added in 0.9.8
				if not foundDesperatePrayer and self.canHaveDesperatePrayer then
					table.insert(SMH_Configuration.profiles[n].defaultSpells, { SMH_SPELL_DESPERATE_PRAYER, true })
				end

				--	Ensure algorithm is updated.
				local temp2 = { }
				for nn in pairs(SMH_Configuration.profiles[n].algorithm) do table.insert(temp2, nn) end
				for ii, nn in ipairs(temp2) do
					local spellName = SMH_Configuration.profiles[n].algorithm[nn]
					if spellName == SMH_SPELL_HEAL or spellName == SMH_SPELL_GREATER_HEAL then
						SMH_Configuration.profiles[n].algorithm[nn] = SMH_FAKE_SPELL_COMBINED_HEAL
					end
				end

			end
		end

		self.addonVersionString = self.addonName .. " " .. self.addonVersion
		self:OutputMessage("INFO", string.format(SMH_IntroductionTextFormat, self.addonVersionString, self.addonMacroCommand))

		self:MinimapButton_Create()
		self:MiniMapButton_UpdatePosition()

		self:MiniProfile_Create()

		com_mithrandir_smhOptionsTitle:SetText("SMH " .. self.addonVersion .. " Options")

		self:Profile_NameUpdate()

		self:SpellButtons_Update()

		self:MiniProfile_Update()

		-- Now to set up the dialog frames
		local frame
		frame = self:ConfirmationDialog_Template("com_mithrandir_smhAlgorithmAccept", this, function() self:Algorithm_Add() end, SMH_ALGORITHM_ADD, SMH_ALGORITHM_CANCEL, SMH_ALGORITHM_TITLE, SMH_ALGORITHM_INSTRUCTIONS, true)
		frame = self:ConfirmationDialog_Template("com_mithrandir_smhResetAccept", this, function() self:Defaults_Update(true); self:Tab_Set(1) end, SMH_RESET_CONFIRM, SMH_RESET_CANCEL, SMH_RESET_TITLE, SMH_RESET_INSTRUCTIONS, false)
		frame = self:ConfirmationDialog_Template("com_mithrandir_smhProfileAccept", this, function() self:Profile_New() end, SMH_PROFILE_NEW_ADD, SMH_PROFILE_NEW_CANCEL, SMH_PROFILE_NEW_TITLE, SMH_PROFILE_NEW_INSTRUCTIONS, true)
		frame = self:ConfirmationDialog_Template("com_mithrandir_smhProfileDelete", this, function() self:Profile_Delete() end, SMH_PROFILE_DELETE_ADD, SMH_PROFILE_DELETE_CANCEL, SMH_PROFILE_DELETE_TITLE, SMH_PROFILE_DELETE_INSTRUCTIONS, false)
		frame = self:ConfirmationDialog_Template("com_mithrandir_smhProfileRename", this, function() self:Profile_Rename() end, SMH_PROFILE_RENAME_ADD, SMH_PROFILE_RENAME_CANCEL, SMH_PROFILE_RENAME_TITLE, SMH_PROFILE_RENAME_INSTRUCTIONS, true)

		this:RegisterEvent("PLAYER_ENTERING_WORLD")
		this:RegisterEvent("PLAYER_LEAVING_WORLD")
	end,

	IsGhostWolf = function(self, buffs)
		local retval = false
		local playerBuffs = buffs or self:UnitBuffs('player')
		if playerBuffs[SMH_BUFF_GHOST_WOLF] ~= nil then retval = true end
		return retval
	end,

	IsMounted = function(self, buffs)
		local retval = false
		local playerBuffs = buffs or self:UnitBuffs('player')
		for n in pairs(playerBuffs) do if playerBuffs[n]["mounted"] then retval = true; break end end
		return retval
	end,

	IsShapeshifted = function(self, buffs)
		local retval = false
		local playerBuffs = buffs or self:UnitBuffs('player')
		for n in pairs(playerBuffs) do if self.shapeshiftBuffs[n] then retval = true; break end end
		return retval
	end,

	IsShadowform = function(self, buffs)
		local retval = false
		local playerBuffs = buffs or self:UnitBuffs('player')
		if playerBuffs[SMH_BUFF_SHADOWFORM] ~= nil then retval = true end
		return retval
	end,

	LookupOrderedProfileName = function(self, whichOne)
		local retval = nil
		local temp = { }

		for n in pairs(SMH_Configuration.profiles) do table.insert(temp, n) end
		table.sort(temp, function(a, b) return SMH:CompareLesser(a, b) end)
		retval = temp[whichOne]
		return retval
	end,

	MainFrame_OnEvent = function(self)
		if self.eventDispatch[event] then
			self.eventDispatch[event](self, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
		end
	end,

	MainFrame_OnLoad = function(self)
		_, self.class = UnitClass('player')
		self.name = UnitName('player')
		if self.classesPermittedToUseAddon[self.class] then
			if self.class == SMH_CLASS_ENGLISH_PRIEST then
				local _, race = UnitRace('player')
				if race == self.raceEnglishHuman or race == self.raceEnglishDwarf then
					self.canHaveDesperatePrayer = true
				end
			end
			this:SetScript("OnEvent", function() self:MainFrame_OnEvent() end)
			this:RegisterEvent("VARIABLES_LOADED")
		end
	end,

	MainFrame_OnUpdate = function(self)
		local positionX, positionY = GetPlayerMapPosition('player')
		if positionX ~= self.lastX or positionY ~= self.lastY then self.isMoving = true else self.isMoving = false end
		self.lastX = positionX
		self.lastY = positionY
	end,

	MiniCheckButton_OnClick = function(self)
		SMH_Configuration.profiles[SMH_Configuration.currentProfile].defaultSpells[this:GetID()][2] = (this:GetChecked() == 1)
	end,

	MiniCheckButton_OnShow = function(self)
		if SMH_Configuration.profiles[SMH_Configuration.currentProfile].defaultSpells[this:GetID()][2] then
			this:SetChecked(1)
		else
			this:SetChecked(0)
		end
	end,

	MinimapButton_Create = function(self)
		local frameName = "com_mithrandir_smhMiniButton"
		local frame = CreateFrame("Button", frameName, Minimap)
		frame:SetWidth(32)
		frame:SetHeight(32)
		frame:SetFrameStrata("MEDIUM")
		frame:SetPoint("TOPLEFT", Minimap, "TOPLEFT")
		frame:RegisterForClicks("LeftButtonUp", "RightButtonUp")
		frame:SetScript("OnClick", function() self:MiniMapButton_OnClick() end)
		frame:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight")
		local texture = frame:CreateTexture(frameName.."Texture", "ARTWORK")
		texture:SetTexture("Interface\\AddOns\\SMH\\smhMiniButton")
		texture:SetWidth(32)
		texture:SetHeight(32)
		texture:SetPoint("TOPLEFT", frame, "TOPLEFT")
		local overlay = frame:CreateTexture(frameName.."Overlay", "OVERLAY")
		overlay:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
		overlay:SetWidth(53)
		overlay:SetHeight(53)
		overlay:SetPoint("TOPLEFT", frame, "TOPLEFT")
	end,

	MiniMapButton_OnClick = function(self)
		self:Options_ShowHide()
	end,

	MiniMapButton_UpdatePosition = function(self)
		local angle = SMH_Configuration.profiles[SMH_Configuration.currentProfile].minimapButtonAngle
		com_mithrandir_smhMiniButton:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 52 - (80 * cos(angle)), (80 * sin(angle)) - 52)
	end,

	MiniProfile_Create = function(self)
		local frameName = "com_mithrandir_smhMiniProfiles"
		local frame = CreateFrame("Frame", frameName, UIParent)
		frame:SetWidth(180)
		frame:SetHeight(30)
		frame:SetFrameStrata("LOW")
		frame:SetToplevel(1)
		frame:EnableMouse(1)
		frame:SetMovable(1)
		frame:SetPoint("TOP", 0, -50)
		local region = frame:CreateTitleRegion()
		region:SetAllPoints(frame)
		frame:SetBackdrop({ bgFile = "Interface/DialogFrame/UI-DialogBox-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, edgeSize = 16, tileSize = 16, insets = { left = 5, right = 5, top = 5, bottom = 5 } })
		local string = frame:CreateFontString(frameName .. "Text", "OVERLAY", "GameFontNormal")
		string:SetPoint("TOP", frame, "TOP", 0, -7)
		string:SetText(SMH_PROFILE_MINI_TITLE)
		local button = self:TemplateButton_Profile(frameName .. "ListItem1", frame)
		button:SetPoint("TOPLEFT", frame, "BOTTOMLEFT", 5, 0)
		button:SetID(1)
		for i = 2, 10 do
			local newButton = self:TemplateButton_Profile(frameName .. "ListItem" .. i, frame)
			newButton:SetPoint("TOPLEFT", button, "BOTTOMLEFT", 0, 1)
			newButton:SetID(i)
			button = newButton
		end
	end,

	MiniProfile_NameInDisplayPosition = function(self, whichOne)
		local temp = { }

		for n in pairs(SMH_Configuration.profiles) do
			if SMH_Configuration.profiles[n]["shouldDisplayProfile"] then
				table.insert(temp, n)
			end
		end
		table.sort(temp, function(a, b) return SMH:CompareLesser(a, b) end)
		return temp[whichOne]
	end,

	MiniProfile_Set = function(self)
		local profileName = self:MiniProfile_NameInDisplayPosition(this:GetID())
		self:Profile_SetName(profileName)
		self:MiniProfile_Update()
		if com_mithrandir_smhOptions:IsVisible() then
			self:Tab_Set(SMH.currentTab)
		end
	end,

	MiniProfile_Update = function(self)
		local temp = { }
		local count = 0

		for n in pairs(SMH_Configuration.profiles) do table.insert(temp, n) end
		table.sort(temp, function(a, b) return SMH:CompareLesser(a, b) end)
		for i, n in ipairs(temp) do
			if SMH_Configuration.profiles[n]["shouldDisplayProfile"] then
				count = count + 1
				if SMH_Configuration.currentProfile == n then
					getglobal("com_mithrandir_smhMiniProfilesListItem"..count):SetText(self.colorGreen .. n .. self.colorStop)
				else
					getglobal("com_mithrandir_smhMiniProfilesListItem"..count):SetText(n)
				end
				getglobal("com_mithrandir_smhMiniProfilesListItem"..count):Show()
			end
		end
		for i = count + 1, self.maxNumberInProColumn, 1 do
			getglobal("com_mithrandir_smhMiniProfilesListItem"..i):Hide()
		end
		if count > 1 then com_mithrandir_smhMiniProfiles:Show()	else com_mithrandir_smhMiniProfiles:Hide() end
	end,

	NumberFromTooltipLine = function(self, desiredLineNumber)
		local retval = 0
		local theLine = getglobal("smhTooltipTextLeft" .. desiredLineNumber)

		if theLine then
			local theText = theLine:GetText()
			if theText then
				retval = self:PIFirst(theText)
			end
		end
		return retval
	end,

	Options_OnLoad = function(self)
		if self.classesPermittedToUseAddon[SMH.class] then
			-- Currently we set up the uiElements by hand because they are not
			-- loaded until just before we get this call.
			self.uiElements = {
				{ com_mithrandir_smhTargetRecipient, 1 },
				{ com_mithrandir_smhUsesTarget, 2 },
				{ com_mithrandir_smhHealsParty, 2 },
				{ com_mithrandir_smhHealsPets, 2 },
				{ com_mithrandir_smhHealingRaid, 2 },
				{ com_mithrandir_smhHealingRaidPets, 2 },
				{ com_mithrandir_smhPartyPriority, 2 },
				{ com_mithrandir_smhDamageThreshold, 2 },
				{ com_mithrandir_smhPetDamageThreshold, 2 },
				{ com_mithrandir_smhSelfDamageThreshold, 2 },
				{ com_mithrandir_smhHealPercentage, 2 },
				{ com_mithrandir_smhIgnoreLevel, 2 },
				{ com_mithrandir_smhConfidence, 2 },
				{ com_mithrandir_smhMiniButtonAngle, 1 },
				{ com_mithrandir_smhReset, 1 },
				{ com_mithrandir_smhRaidInstruct, 5 },
				{ com_mithrandir_smhPriRaid1, 5 },
				{ com_mithrandir_smhPriRaid2, 5 },
				{ com_mithrandir_smhPriRaid3, 5 },
				{ com_mithrandir_smhPriRaid4, 5 },
				{ com_mithrandir_smhPriRaid5, 5 },
				{ com_mithrandir_smhPriRaid6, 5 },
				{ com_mithrandir_smhPriRaid7, 5 },
				{ com_mithrandir_smhPriRaid8, 5 },
				{ com_mithrandir_smhPriRaidPets, 2 },
				{ com_mithrandir_smhDefaultInstruct, 3 },
				{ com_mithrandir_smhPriorityDesc, 9 },
				{ com_mithrandir_smhClassPriority, 5 },
				{ com_mithrandir_smhClassHighPriority, 2 },
				{ com_mithrandir_smhOverhealing, 6 },
				{ com_mithrandir_smhClassOverhealing, 6 },
				{ com_mithrandir_smhPriorityDruid, 5 },
				{ com_mithrandir_smhPriorityHunter, 5 },
				{ com_mithrandir_smhPriorityMage, 5 },
				{ com_mithrandir_smhPriorityPaladin, 5 },
				{ com_mithrandir_smhPriorityPriest, 5 },
				{ com_mithrandir_smhPriorityRogue, 5 },
				{ com_mithrandir_smhPriorityShaman, 5 },
				{ com_mithrandir_smhPriorityWarlock, 5 },
				{ com_mithrandir_smhPriorityWarrior, 5 },
				{ com_mithrandir_smhOverheal1, 6 },
				{ com_mithrandir_smhOverheal2, 6 },
				{ com_mithrandir_smhHealsText, 2 },
				{ com_mithrandir_smhPrioritiesText, 2 },
				{ com_mithrandir_smhPriorityText, 4 },
				{ com_mithrandir_smhCharacterPriorityLow, 4 },
				{ com_mithrandir_smhCharacterPriorityHigh, 4 },
				{ com_mithrandir_smhCharacterPriorityIgnored, 4 },
				{ com_mithrandir_smhAlgControl1, 3 },
				{ com_mithrandir_smhAlgControl2, 3 },
				{ com_mithrandir_smhUseAlg1, 3 },
				{ com_mithrandir_smhUseAlg2, 3 },
				{ com_mithrandir_smhDefaultLeft2, 3 },
				{ com_mithrandir_smhAlgorithm, 3 },
				{ com_mithrandir_smhAlgorithmCast, 3 },
				{ com_mithrandir_smhProfile, 7 },
				{ com_mithrandir_smhNewProfile, 7 },
				{ com_mithrandir_smhDeleteProfile, 7 },
				{ com_mithrandir_smhRenameProfile, 7 },
				{ com_mithrandir_smhHealsTargetsTarget, 2 },
				{ com_mithrandir_smhHealsOutOfGroup, 4 },
				{ com_mithrandir_smhMaxHealing, 8 },
				{ com_mithrandir_smhMaxHeal1, 8 },
				{ com_mithrandir_smhMaxHeal2, 8 },
				{ com_mithrandir_smhMinHealing, 8 },
				{ com_mithrandir_smhMinRaiseHealing, 8 },
				{ com_mithrandir_smhMinHeal1, 8 },
				{ com_mithrandir_smhMinHeal2, 8 },
				{ com_mithrandir_smhMinRaiseHeal1, 8 },
				{ com_mithrandir_smhMinRaiseHeal2, 8 },
				{ com_mithrandir_smhClassOverheal1, 6 },
				{ com_mithrandir_smhClassOverheal2, 6 },
				{ com_mithrandir_smhClassOverheal3, 6 },
				{ com_mithrandir_smhClassOverheal4, 6 },
				{ com_mithrandir_smhClassOverheal5, 6 },
				{ com_mithrandir_smhClassOverheal6, 6 },
				{ com_mithrandir_smhClassOverheal7, 6 },
				{ com_mithrandir_smhClassOverheal8, 6 },
				{ com_mithrandir_smhClassOverheal9, 6 },
				{ com_mithrandir_smhAlgorithmFallthrough, 3 },
				{ com_mithrandir_smhMessageText, 1 },
				{ com_mithrandir_smhMessageCast, 1 },
				{ com_mithrandir_smhMessageCastNoParty, 1 },
				{ com_mithrandir_smhMessageInfo, 1 },
				{ com_mithrandir_smhMessageError, 1 },
				{ com_mithrandir_smhMessageTier, 1 },
				{ com_mithrandir_smhMessageDebug, 1 },
				}

			if self.class == SMH_CLASS_ENGLISH_DRUID then
				table.insert(self.uiElements, { com_mithrandir_smhNaturesSwiftness, 1 })
				table.insert(self.uiElements, { com_mithrandir_smhOverheal3, 6 })
				table.insert(self.uiElements, { com_mithrandir_smhAlgControl3, 3 })
				table.insert(self.uiElements, { com_mithrandir_smhUseAlg3, 3 })
				table.insert(self.uiElements, { com_mithrandir_smhDefaultLeft3, 3 })
				table.insert(self.uiElements, { com_mithrandir_smhMaxHeal3, 8 })
				table.insert(self.uiElements, { com_mithrandir_smhMinHeal3, 8 })
				table.insert(self.uiElements, { com_mithrandir_smhMinRaiseHeal3, 8 })
			elseif self.class == SMH_CLASS_ENGLISH_PRIEST then
				table.insert(self.uiElements, { com_mithrandir_smhOverheal3, 6 })
				table.insert(self.uiElements, { com_mithrandir_smhOverheal4, 6 })
				table.insert(self.uiElements, { com_mithrandir_smhAlgControl3, 3 })
				table.insert(self.uiElements, { com_mithrandir_smhAlgControl4, 3 })
				table.insert(self.uiElements, { com_mithrandir_smhAlgControl5, 3 })
				table.insert(self.uiElements, { com_mithrandir_smhUseAlg3, 3 })
				table.insert(self.uiElements, { com_mithrandir_smhUseAlg4, 3 })
				table.insert(self.uiElements, { com_mithrandir_smhUseAlg5, 3 })
				table.insert(self.uiElements, { com_mithrandir_smhDefaultLeft3, 3 })
				table.insert(self.uiElements, { com_mithrandir_smhDefaultLeft4, 3 })
				table.insert(self.uiElements, { com_mithrandir_smhDefaultLeft5, 3 })
				table.insert(self.uiElements, { com_mithrandir_smhMaxHeal3, 8 })
				table.insert(self.uiElements, { com_mithrandir_smhMaxHeal4, 8 })
				table.insert(self.uiElements, { com_mithrandir_smhMinHeal3, 8 })
				table.insert(self.uiElements, { com_mithrandir_smhMinHeal4, 8 })
				table.insert(self.uiElements, { com_mithrandir_smhMinRaiseHeal3, 8 })
				table.insert(self.uiElements, { com_mithrandir_smhMinRaiseHeal4, 8 })
				if self.canHaveDesperatePrayer then
					table.insert(self.uiElements, { com_mithrandir_smhOverheal5, 6 })
					table.insert(self.uiElements, { com_mithrandir_smhAlgControl6, 3 })
					table.insert(self.uiElements, { com_mithrandir_smhUseAlg6, 3 })
					table.insert(self.uiElements, { com_mithrandir_smhDefaultLeft6, 3 })
					table.insert(self.uiElements, { com_mithrandir_smhMaxHeal5, 8 })
					table.insert(self.uiElements, { com_mithrandir_smhMinHeal5, 8 })
					table.insert(self.uiElements, { com_mithrandir_smhMinRaiseHeal5, 8 })
				end
			elseif self.class == SMH_CLASS_ENGLISH_SHAMAN then
				table.insert(self.uiElements, { com_mithrandir_smhNaturesSwiftness, 1 })
			end

			if self.class ~= SMH_CLASS_ENGLISH_SHAMAN then
				table.insert(self.uiElements, { com_mithrandir_smhBuffsText, 1 })
				table.insert(self.uiElements, { com_mithrandir_smhBuffsTarget, 1 })
				table.insert(self.uiElements, { com_mithrandir_smhBuffsParty, 1 })
				table.insert(self.uiElements, { com_mithrandir_smhBuffsPets, 1 })
				table.insert(self.uiElements, { com_mithrandir_smhBuffsRaid, 1 })
				table.insert(self.uiElements, { com_mithrandir_smhBuffsRaidPets, 1 })
				table.insert(self.uiElements, { com_mithrandir_smhBuffsFailLowMana, 1 })
			end

			self:Tab_Set(1)
			com_mithrandir_smhTab1:SetChecked(1)
			local numberTabs = getn(_smh_optionTabs)
			for i = 1, numberTabs, 1 do
				getglobal("com_mithrandir_smhTab" .. i).tooltiptext = _smh_optionTabs[i][1]
				getglobal("com_mithrandir_smhTab" .. i):SetNormalTexture(_smh_optionTabs[i][2])
				getglobal("com_mithrandir_smhTabButton" .. i).tooltiptext = _smh_optionTabs[i][1]
			end

			self:Frame_Update()
		end
	end,

	Options_ShowHide = function(self)
		if (com_mithrandir_smhOptions:IsVisible()) then com_mithrandir_smhOptions:Hide() else com_mithrandir_smhOptions:Show() end
	end,

	OrderedHealableUnits = function(self, healingSelf)
		local groupStatus = { }		-- the real results
		local tableSize
		local tableBase
		local classModifier
		-- Note that we consider priority[8] higher than priority[1]
		local priority = { }		-- a table of tables
		local numberPriorities = 8
		local characterName
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
		local characterLevel

		-- initialize our priority tables to empty
		for i = 1, numberPriorities, 1 do
			priority[i] = { }
		end

		self:OutputMessage("TIER", "SMH Information Dump:")
		self:OutputMessage("TIER", com_mithrandir_smhPriorityDesc:GetText())
		-- We now consider ourselves (as part of our own party)
		classModifier = currentProfile.classPriorities[UnitClass("player")]
		if classModifier ~= 0 then
			tableBase = self:WhichPriorityLevel(classModifier, true)
			self:TryToInsertUnitForHealing(priority[tableBase], "player", "threshold", nil)
		end

		if currentProfile.healsParty then
			for i in self.playerIds do
				if self:UnitIsHealable(i) then
					classModifier = currentProfile.classPriorities[UnitClass(i)]
					characterName = UnitName(i)
					characterLevel = UnitLevel(i)
					if classModifier ~= 0 and not currentProfile.charactersPriorityIgnored[characterName] and characterLevel >= currentProfile.doNotHealBelowLevel then
						if currentProfile.charactersPriorityHigh[characterName] then tableBase = 8
						elseif currentProfile.charactersPriorityLow[characterName] then tableBase = 1
						else tableBase = self:WhichPriorityLevel(classModifier, true)
						end
						self:TryToInsertUnitForHealing(priority[tableBase], i, "threshold", nil)
					end
				end
			end
		elseif currentProfile.outOfGroup then	-- just check to see if any of the high priority names are here
			for i in self.playerIds do
				if self:UnitIsHealable(i) then
					characterName = UnitName(i)
					if currentProfile.charactersPriorityHigh[characterName] then
						self:TryToInsertUnitForHealing(priority[8], i, "threshold", nil)
					end
				end
			end
		end

		if currentProfile.healingPets then
			for i in self.petIds do
				if self:UnitIsHealable(i) then
					characterName = UnitName(i)
					characterLevel = UnitLevel(i)
					if not currentProfile.charactersPriorityIgnored[characterName] and characterLevel >= currentProfile.doNotHealBelowLevel then
						if currentProfile.charactersPriorityHigh[characterName] then tableBase = 8
						elseif currentProfile.charactersPriorityLow[characterName] then tableBase = 1
						elseif currentProfile.partyOverRaid then tableBase = 6 else tableBase = 3 end
						self:TryToInsertUnitForHealing(priority[tableBase], i, "petThreshold", nil)
					end
				end
			end
		elseif currentProfile.outOfGroup then	-- just check to see if any of the high priority names are here
			for i in self.petIds do
				if self:UnitIsHealable(i) then
					characterName = UnitName(i)
					if currentProfile.charactersPriorityHigh[characterName] then
						self:TryToInsertUnitForHealing(priority[8], i, "petThreshold", nil)
					end
				end
			end
		end

		-- Determine if any of the raid subgroups have priority
		local priorityRaid = false
		for i = 1, 8, 1 do
			if currentProfile["priorityRaidGroup"..i] then priorityRaid = true end
		end

		-- Only process the raid code if we need to do so.
		-- Note that since we do not know what subgroup the player is in we
		-- first record each of the damaged ones into subgroups because we
		-- will ignore the player's subgroup if we can.
		if currentProfile.healingRaid or currentProfile.healingRaidPets or priorityRaid or (currentProfile.outOfGroup and self:RealTableSize(currentProfile.charactersPriorityHigh) > 0) then
			local numberInRaid = GetNumRaidMembers()
			if (numberInRaid > 0) then
				local myRaidGroup = nil
				local statuses = { }
				local petStatuses = { }
				local key
				local targetTable

				-- initialize the arrays to empty
				for i = 1, 8, 1 do
					key = "priorityRaidGroup"..i
					statuses[key] = { }
					petStatuses[key] = { }
				end

				-- go through the entire raid to get the appropriate healees
				for i = 1, numberInRaid do
					local raidName, _, raidGroup = GetRaidRosterInfo(i)
					local unitName

					key = "priorityRaidGroup"..raidGroup

					if (raidName == self.name) then
						myRaidGroup = raidGroup
					end

					if currentProfile.healingRaid or currentProfile[key] or (currentProfile.outOfGroup and currentProfile.charactersPriorityHigh[raidName]) then
						unitName = "raid"..i
						if self:UnitIsHealable(unitName) then
							self:TryToInsertUnitForHealing(statuses[key], unitName, "threshold", nil)
						end
					end
					if currentProfile.healingRaidPets or (currentProfile[key] and currentProfile.priorityRaidPets) or (currentProfile.outOfGroup and currentProfile.charactersPriorityHigh[UnitName("raidpet"..i)]) then
						unitName = "raidpet"..i
						if self:UnitIsHealable(unitName) then
							self:TryToInsertUnitForHealing(petStatuses[key], unitName, "petThreshold", nil)
						end
					end
				end

				for i = 1, 8, 1 do
					local shouldProcess = true
					key = "priorityRaidGroup"..i

					if i == myRaidGroup then
						if not currentProfile[key] then shouldProcess = false end
					end
					if shouldProcess then
						tableSize = table.getn(statuses[key])
						for i = 1, tableSize do
							classModifier = currentProfile.classPriorities[UnitClass(statuses[key][i].id)]
							characterName = UnitName(statuses[key][i].id)
							characterLevel = UnitLevel(statuses[key][i].id)
							if (classModifier ~= 0 and not currentProfile.charactersPriorityIgnored[characterName] and characterLevel >= currentProfile.doNotHealBelowLevel) or (currentProfile.outOfGroup and currentProfile.charactersPriorityHigh[characterName]) then
								if currentProfile.charactersPriorityHigh[characterName] then tableBase = 8
								elseif currentProfile.charactersPriorityLow[characterName] then tableBase = 1
								elseif currentProfile[key] then tableBase = 4 else tableBase = self:WhichPriorityLevel(classModifier, false) end
								table.insert(priority[tableBase], 1, statuses[key][i])
							end
						end

						if currentProfile[key] and currentProfile.priorityRaidPets then tableBase = 4 else tableBase = 3 end
						tableSize = table.getn(petStatuses[key])
						for i = 1, tableSize do
							characterName = UnitName(petStatuses[key][i].id)
							characterLevel = UnitLevel(petStatuses[key][i].id)
							if not currentProfile.charactersPriorityIgnored[characterName] and characterLevel >= currentProfile.doNotHealBelowLevel then
								if currentProfile.charactersPriorityHigh[characterName] then tableBase = 8
								elseif currentProfile.charactersPriorityLow[characterName] then tableBase = 1
								end
								table.insert(priority[tableBase], 1, petStatuses[key][i])
							end
						end
					end
				end
			end
		end

		-- sort each of the priority tables individually to maintain order within priority
		for i = 1, numberPriorities, 1 do
			if table.getn(priority[i]) > 0 then
				table.sort(priority[i], function(a, b) return SMH:CompareHealth(a, b) end)
				self:OutputMessage("TIER", "Priority table "..i.." has ".. table.getn(priority[i]).." healees in it.")
				for j = 1, table.getn(priority[i]), 1 do
					self:OutputMessage("TIER", "Priority "..i.." order "..j.." is "..UnitName(priority[i][j].id).." "..UnitClass(priority[i][j].id).." percent "..priority[i][j].percent * 100)
				end
			end
		end

		-- and then add them to the overall table
		for i = 1, numberPriorities, 1 do
			tableSize = table.getn(priority[i])
			if tableSize > 0 then
				for j = 1, tableSize, 1 do table.insert(groupStatus, j, priority[i][j]) end
			end
		end

		--	Put the target's target in the list
		if currentProfile.healsTargetsTarget and self:UnitIsHealable('targettarget') then
			self:DealWithUnsureRecipient(groupStatus, 'targettarget')
		end

		--	Put myself at front of list if my health is less than 40%
		self:TryToInsertUnitForHealing(groupStatus, 'player', "selfThreshold", "Player put at head of heal list")

		--	Put the target at the front of the list if it is healable and damaged
		if currentProfile.targetPriority and self:UnitIsHealable('target') then
			self:DealWithUnsureRecipient(groupStatus, 'target')
		end

		--	If ALT is used, the player is put at the front of the list
		if (IsAltKeyDown() == 1) or healingSelf then
			self:TryToInsertUnitForHealing(groupStatus, 'player', "threshold", "Player put at front of heal list because of ALT or explicit self command")
		end

		return groupStatus
	end,

	OutputChannelMessage = function(self, addonName, spellName, spellRank, recipientName, estimatedHealAmount, spellCastTime)
		if recipientName == nil or estimatedHealAmount < 0 then return end
		local addonNameToUse = addonName or "SMH"
		local spellNameToUse = spellName or "NONE"
		local spellRankToUse = spellRank or 0
		local spellCastTimeToUse = spellCastTime or 0
		self.oneUpNumber = self.oneUpNumber + 1
		local message = "SMH:" .. self.oneUpNumber .. ":" .. spellNameToUse .. ":" .. spellRankToUse .. ":" .. recipientName .. ":" .. floor(estimatedHealAmount) .. ":" .. spellCastTimeToUse
		SendAddonMessage(addonNameToUse, message, "RAID")	-- Note that sending to RAID is fine because if not in a raid, but in a party it sends to party, and if not in a party nothing sent.
	end,

	OutputChannelMessageStop = function(self, addonName, how)
		local addonNameToUse = addonName or "SMH"
		local message = "SMH:" .. self.oneUpNumber .. ":Done"
		SendAddonMessage(addonNameToUse, message, "RAID")	-- Note that sending to RAID is fine because if not in a raid, but in a party it sends to party, and if not in a party nothing sent.
	end,

	--	The messageType indicates the "class" of message that we are sending.  This allows
	--	the various configuration options to control where the message should go.  The possible
	--	messageType values are DEBUG, TIER, ERROR, INFO and CAST.  A special value is used
	--	to determine what happens when an attempt at party is made but not in a party.
	--	The places to which a message can be sent are:
	--		0 -- no message sent, 1 -- chat log, 2 -- combat log, 3 -- error log, 4 -- party
	OutputMessage = function(self, messageType, message)
		local messagePlace = SMH_Configuration.profiles[SMH_Configuration.currentProfile].messagePlaces[messageType]

		if messagePlace == 4 and not UnitInParty('party1') then
			messagePlace = SMH_Configuration.profiles[SMH_Configuration.currentProfile].messagePlaces["CASTNOPARTY"]
		end

		if messagePlace == 1 and DEFAULT_CHAT_FRAME then
			DEFAULT_CHAT_FRAME:AddMessage(message)
		elseif messagePlace == 2 and ChatFrame2 then
			ChatFrame2:AddMessage(message)
		elseif messagePlace == 3 and UIErrorsFrame then
			UIErrorsFrame:AddMessage(message, 1.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME)
		elseif messagePlace == 4 then
			SendChatMessage(message, "PARTY")
		end
	end,

	ParseInteger = function(self, text, index)	-- taken from Healomatic
		local i = 1
		for integer in string.gfind(text, '%d+') do
			if i == index then
				return tonumber(integer)
			end
			i = i + 1
		end
		return 0
	end,

	PIFirst = function(self, text)	return self:ParseInteger(text, 1)	end,

	PIFirstThird = function(self, text)	return self:ParseInteger(text, 1) + self:ParseInteger(text, 3)	end,

	PISecond = function(self, text)	return self:ParseInteger(text, 2)	end,

	PISecondThird = function(self, text)	return self:ParseInteger(text, 2) + self:ParseInteger(text, 3)	end,

	PriorityString = function(self)
		local retval = SMH_TIER_TITLE
		local order = 2
		local wordsToAdd
		local tableSize
		local priority = { [0] = { }, [1] = { }, [2] = { }, [3] = { } }
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]

		-- We now take each of the class priorities and put them into the priority table.
		local temp = { }
		for n in pairs(currentProfile.classPriorities) do table.insert(temp, n) end
		table.sort(temp, function(a, b) return SMH:CompareGreater(a, b) end)
		for i, n in ipairs(temp) do
			table.insert(priority[currentProfile.classPriorities[n]], n)
		end

		if currentProfile.targetPriority then
			retval = retval.."   "..order.. SMH_TIER_TARGET
			order = order + 1
		end

		retval = retval.."   "..order.. SMH_TIER_PLAYER1 .. currentProfile.selfThreshold.. SMH_TIER_PLAYER2
		order = order + 1

		if currentProfile.healsTargetsTarget then
			retval = retval.."   "..order.. SMH_TIER_TARGETS_TARGET
			order = order + 1
		end

		if currentProfile.healsParty or currentProfile.healingRaid or currentProfile.outOfGroup then
			temp = { }
			for n in pairs(currentProfile.charactersPriorityHigh) do table.insert(temp, n) end
			if table.getn(temp) > 0 then
				retval = retval .. "   " .. order .. ". "
				table.sort(temp, function(a, b) return SMH:CompareLesser(a, b) end)
				for i, n in ipairs(temp) do
					if i ~= 1 then retval = retval .. ", " end
					retval = retval .. n
				end
				retval = retval .. "\n"
				order = order + 1
			end
		end

		if currentProfile.classPriorityOverParty and table.getn(priority[3]) > 0 then
			retval = retval .. "   " .. order .. ". "
			for i = 1, table.getn(priority[3]), 1 do
				if i ~= 1 then
					retval = retval .. "/"
				end
				retval = retval .. priority[3][i]
			end
			retval = retval .. "\n"
			order = order + 1
		end

		if currentProfile.partyOverRaid then
			wordsToAdd = { SMH_TIER_PLAYER }
			if currentProfile.healsParty then
				table.insert(wordsToAdd, SMH_TIER_PARTY)
			end
			if currentProfile.healingPets then
				table.insert(wordsToAdd, SMH_TIER_PARTYPETS)
			end
			tableSize = table.getn(wordsToAdd)
			if tableSize > 0 then
				retval = retval.."   "..order..". "
				for i = 1, tableSize, 1 do
					if (i ~= 1) then
						retval = retval.."/"
					end
					retval = retval..wordsToAdd[i]
				end
				retval = retval.."\n"
				order = order + 1
			end
		end

		if not currentProfile.classPriorityOverParty and table.getn(priority[3]) > 0 then
			local code = ""
			if currentProfile.partyOverRaid then code = SMH_TIER_RAIDCODE end
			retval = retval .. "   " .. order .. ". "
			for i = 1, table.getn(priority[3]), 1 do
				if i ~= 1 then
					retval = retval .. "/"
				end
				retval = retval .. priority[3][i] .. code
			end
			retval = retval .. "\n"
			order = order + 1
		end

		wordsToAdd = { }
		for i = 1, 8, 1 do
			local key = "priorityRaidGroup"..i
			if currentProfile[key] then
				table.insert(wordsToAdd, SMH_TIER_RAIDGROUP..i)
				if currentProfile.priorityRaidPets then
					table.insert(wordsToAdd, SMH_TIER_RAIDGROUP..i.. SMH_TIER_RAIDGROUPPETS)
				end
			end
		end
		tableSize = table.getn(wordsToAdd)
		if tableSize > 0 then
			retval = retval.."   "..order..". "
			for i = 1, tableSize, 1 do
				if (i ~= 1) then
					retval = retval.."/"
				end
				retval = retval..wordsToAdd[i]
			end
			retval = retval.."\n"
			order = order + 1
		end

		wordsToAdd = { }
		if currentProfile.healingRaid then
			table.insert(wordsToAdd, SMH_TIER_RAID)
		end
		if currentProfile.healingRaidPets then
			table.insert(wordsToAdd, SMH_TIER_RAIDPETS)
		end
		if not currentProfile.partyOverRaid then
			table.insert(wordsToAdd, SMH_TIER_PLAYER)
			if currentProfile.healsParty then
				table.insert(wordsToAdd, SMH_TIER_PARTY)
			end
			if currentProfile.healingPets then
				table.insert(wordsToAdd, SMH_TIER_PARTYPETS)
			end
		end
		tableSize = table.getn(wordsToAdd)
		if tableSize > 0 then
			retval = retval.."   "..order..". "
			for i = 1, tableSize, 1 do
				if (i ~= 1) then
					retval = retval.."/"
				end
				retval = retval..wordsToAdd[i]
			end
			retval = retval.."\n"
			order = order + 1
		end

		if table.getn(priority[1]) > 0 then
			retval = retval .. "   " .. order .. ". "
			for i = 1, table.getn(priority[1]), 1 do
				if i ~= 1 then
					retval = retval .. "/"
				end
				retval = retval .. priority[1][i]
			end
			retval = retval .. "\n"
			order = order + 1
		end

		temp = { }
		for n in pairs(currentProfile.charactersPriorityLow) do table.insert(temp, n) end
		if table.getn(temp) > 0 then
			retval = retval .. "   " .. order .. ". "
			table.sort(temp, function(a, b) return SMH:CompareLesser(a, b) end)
			for i, n in ipairs(temp) do
				if i ~= 1 then retval = retval .. ", " end
				retval = retval .. n
			end
			retval = retval .. "\n"
			order = order + 1
		end

		if table.getn(priority[0]) > 0 then
			retval = retval .. SMH_TIER_IGNORED_CLASSES
			for i = 1, table.getn(priority[0]), 1 do
				if i ~= 1 then
					retval = retval .. ", "
				end
				retval = retval .. priority[0][i]
			end
			retval = retval .. "\n"
		end

		temp = { }
		for n in pairs(currentProfile.charactersPriorityIgnored) do table.insert(temp, n) end
		if table.getn(temp) > 0 then
			retval = retval .. SMH_TIER_IGNORED_CHARACTERS
			table.sort(temp, function(a, b) return SMH:CompareLesser(a, b) end)
			for i, n in ipairs(temp) do
				if i ~= 1 then retval = retval .. ", " end
				retval = retval .. n
			end
		end

		com_mithrandir_smhPriorityDesc:SetText(retval)
	end,

	--	This returns nil if there is no problem detected casting
	--	otherwise it returns the string indicating the problem.
	ProblemCasting = function(self, playerBuffs)
		if UnitOnTaxi('player') == 1 then return SMH_ABORT_MESSAGE_ON_TAXI end
		if UnitIsDead('player') then return SMH_ABORT_MESSAGE_DEAD end
		local buffs = playerBuffs or self:UnitBuffs('player')
		if self.class == SMH_CLASS_ENGLISH_DRUID and self:IsShapeshifted(buffs) then return SMH_ABORT_MESSAGE_SHAPESHIFTED end
		if self.class == SMH_CLASS_ENGLISH_PRIEST and self:IsShadowform(buffs) then return SMH_ABORT_MESSAGE_SHAPESHIFTED end
		if self.class == SMH_CLASS_ENGLISH_SHAMAN and self:IsGhostWolf(buffs) then return SMH_ABORT_MESSAGE_SHAPESHIFTED end
		if self:IsMounted(buffs) then return SMH_ABORT_MESSAGE_MOUNTED end
		local aCastStoppingBuff = self:CastStoppingBuff(buffs)
		if aCastStoppingBuff then return string.format(SMH_ABORT_MESSAGE_BAD_BUFF, aCastStoppingBuff) end
		return nil
	end,

	--	This routine goes through currentOtherHeals and maps valid entries
	--	into currentOtherHealsByCharacter so they can be easily accessed.
	--	Those entries older than 30 seconds are discarded.
	ProcessOtherHeals = function(self)
		local expired = { }
		local currentTime = GetTime()
		local temp
		local recipient
		local expiredCount

		self.gettingRegrowthSoon = { }
		self.currentOtherHealsByCharacter = { }
		for n in pairs(self.currentOtherHeals) do
			if currentTime - self.currentOtherHeals[n].registered > 30 then
				table.insert(expired, n)
			else
				recipient = self.currentOtherHeals[n].recipient
				temp = self.currentOtherHealsByCharacter[recipient]
				if temp == nil then temp = 0 end
				self.currentOtherHealsByCharacter[recipient] = temp + self.currentOtherHeals[n].potentialHeal
				if self.currentOtherHeals[n].spellName == SMH_SPELL_REGROWTH then
					self.gettingRegrowthSoon[recipient] = true
				end
				self:OutputMessage("DEBUG", n .. " indicates " .. recipient .. " should be getting " .. self.currentOtherHeals[n].potentialHeal .. " health")
			end
		end
		expiredCount = table.getn(expired)
		for n = 1, expiredCount, 1 do
			self.currentOtherHeals[expired[n]] = nil
		end
	end,

	--	This function looks for specific talents for whatever reasons we need.
	ProcessTalents = function(self)
		local numberTalentTabs = GetNumTalentTabs()
		self.spritualGuidanceTalentRank = 0
		for i = 1, numberTalentTabs do
			local numberTalents = GetNumTalents(i)
			for j = 1, numberTalents do
				local name, iconTexture, tier, column, rank, maxRank = GetTalentInfo(i, j)
				if name == SMH_TALENT_SPIRITUAL_GUIDANCE and rank > 0 then
					self.spritualGuidanceTalentRank = rank
				end
			end
		end
	end,

	Profile_CreateNewFromCurrent = function(self, newProfileName)
		SMH_Configuration.profiles[newProfileName] = self:CopyTable(SMH_Configuration.profiles[SMH_Configuration.currentProfile])
	end,

	Profile_Delete = function(self)
		local existing, count = self:Profile_Named(string.lower(SMH_Configuration.currentProfile))

		if existing and count > 1 then
			SMH_Configuration.profiles[SMH_Configuration.currentProfile] = nil
			self:Profile_SetName(self:Profile_First())
			self:ProfileButtons_Show()
			self:MiniProfile_Update()
		end
	end,

	Profile_First = function(self)
		local retval = nil

		for n in pairs(SMH_Configuration.profiles) do
			if retval == nil then retval = n end
		end
		return retval
	end,

	Profile_Named = function(self, aLowercaseName)
		local retval = nil
		local count = 0

		for n in pairs(SMH_Configuration.profiles) do
			if (string.lower(n) == aLowercaseName) then
				retval = SMH_Configuration.profiles[n]
			end
			count = count + 1
		end
		return retval, count
	end,

	Profile_NameUpdate = function(self)
		com_mithrandir_smhProfileName:SetText(string.format(SMH_PROFILE_TEXT_FORMAT, SMH_Configuration.currentProfile))
	end,

	Profile_New = function(self)
		local newProfileName = com_mithrandir_smhProfileAcceptField:GetText()

		if newProfileName ~= '' then
			local existing, count = self:Profile_Named(string.lower(newProfileName))
			if existing == nil and count < self.maxNumberInProColumn then
				self:Profile_CreateNewFromCurrent(newProfileName)
				self:Profile_SetName(newProfileName)
				self:ProfileButtons_Show()
				self:MiniProfile_Update()
			end
		end
	end,

	Profile_Rename = function(self)
		local newProfileName = com_mithrandir_smhProfileRenameField:GetText()

		if newProfileName ~= '' then
			local existing, count = self:Profile_Named(string.lower(newProfileName))
			if existing == nil then
				self:Profile_CreateNewFromCurrent(newProfileName)
				SMH_Configuration.profiles[SMH_Configuration.currentProfile] = nil
				self:Profile_SetName(newProfileName)
				self:ProfileButtons_Show()
				self:MiniProfile_Update()
			end
		end
	end,

	Profile_Set = function(self)
		self:Profile_SetName(this:GetText())
		self:MiniProfile_Update()
	end,

	Profile_SetName = function(self, profileName)
		SMH_Configuration.currentProfile = profileName
		self:Profile_NameUpdate()
		self:MiniMapButton_UpdatePosition()
	end,

	ProfileButtons_Hide = function(self)
		for i = 1, self.maxNumberInProColumn, 1 do
			getglobal("com_mithrandir_smhProfile"..i):Hide()
			getglobal("com_mithrandir_smhProfileAppear"..i):Hide()
		end
	end,

	ProfileButtons_Show = function(self)
		local temp = { }

		for n in pairs(SMH_Configuration.profiles) do table.insert(temp, n) end
		table.sort(temp, function(a, b) return SMH:CompareLesser(a, b) end)
		for i, n in ipairs(temp) do
			getglobal("com_mithrandir_smhProfile"..i):SetText(n)
			getglobal("com_mithrandir_smhProfile"..i):Show()
			getglobal("com_mithrandir_smhProfileAppear"..i):Show()
		end
		for i = table.getn(temp) + 1, self.maxNumberInProColumn, 1 do
			getglobal("com_mithrandir_smhProfile"..i):Hide()
			getglobal("com_mithrandir_smhProfileAppear"..i):Hide()
		end
	end,

	ProfileCheck_OnClick = function(self)
		local profileName = self:LookupOrderedProfileName(this:GetID())
		SMH_Configuration.profiles[profileName]["shouldDisplayProfile"] = (this:GetChecked() == 1)
		self:MiniProfile_Update()
	end,

	ProfileCheck_OnLoad = function(self)
		getglobal(this:GetName().."Text"):SetText(SMH_PROFILE_CHECKBUTTON_TITLE)
	end,

	ProfileCheck_OnShow = function(self)
		local profileName = self:LookupOrderedProfileName(this:GetID())
		if SMH_Configuration.profiles[profileName]["shouldDisplayProfile"] then
			this:SetChecked(1)
		else
			this:SetChecked(0)
		end
	end,

	--	This function is used because there are times when I cannot
	--	call table.getn() on a table.  For example, if a table has
	--	got entries whose keys are the names of interest and the
	--	values are all true.  In this case table.getn() of that
	--	table returns 0.
	RealTableSize = function(self, someTable)
		local temp = { }

		for n in pairs(someTable) do table.insert(temp, n) end
		return table.getn(temp)
	end,

	SetBoolean = function(self, parameterName, yn)
		SMH_Configuration.profiles[SMH_Configuration.currentProfile][parameterName] = yn
		self:OutputMessage("INFO", string.format("<%s>: %s %s", self.addonVersionString, self.outputSettingMessages[parameterName], self.outputBooleanMappings[yn]))
	end,

	SlashCommand = function(self, msg)		-- all the parameters will be passed in the msg...therefore, we will need to split some out
		if (msg == nil or msg == "") then
			self:CastHealNormal()
		else
			msg = string.lower(msg)
			-- hopefully this means we will have command and options filled in such as:
			-- /smh msg => command="msg" options=nil
			-- /smh msg on => command="msg" options="on"
			local _, _, command, options = string.find(msg, "^%s*([%a:]+)%s*(%a*)")
			if (command ~= nil) then
				if self.commandHeals[command] then
					local selfHealing = false
					if options == SMH_COMMAND_SELF then selfHealing = true end
					self:CastHeal(self.commandHeals[command], selfHealing)
				elseif self.commandBuffs[command] then
					local selfHealing = false
					if options == SMH_COMMAND_SELF then selfHealing = true end
					self:CastBuff(self.commandBuffs[command], selfHealing)
				elseif self.commandFunctions[command] then
					self.commandFunctions[command]()
				else
					if self.commandParameters[command] then
						local booleanValue
						if (options == SMH_COMMAND_OPTION_ON) then booleanValue = true
						elseif (options == SMH_COMMAND_OPTION_OFF) then booleanValue = false
						else booleanValue = not SMH_Configuration.profiles[SMH_Configuration.currentProfile][self.commandParameters[command]]
						end
						self:SetBoolean(self.commandParameters[command], booleanValue)
					end
				end
			end
		end
	end,

	Slider_OnShow = function(self)
		local id = this:GetID()
		local name = this:GetName()
		local profile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
		local normalId = id
		while (normalId > 100) do normalId = normalId - 100 end
		local spellName = nil
		if id > 100 and id < 500 then
			spellName = self.classSpellsOfInterest[self.class][normalId]
		end

		getglobal(name .. "High"):SetText()
		getglobal(name .. "Low"):SetText()
		self:Slider_SetTitle(this)
		this:SetValueStep(1)

		if id < 100 then
			local min = 1
			local max = 100
			if id == 5 then min = 0; max = 359
			elseif id == 6 then max = 60
			elseif id == 7 then min = 0
			end
			this:SetMinMaxValues(min, max)
			this:SetValue(profile[_smh_sliderTitleFormats[id][1]])
		elseif id > 100 and id < 200 then
			this:SetMinMaxValues(0, table.getn(self.levelLearned[spellName]) - 1)
			this:SetValue(profile.overhealRanks[spellName])
		elseif id > 200 and id < 300 then
			this:SetMinMaxValues(1, table.getn(self.levelLearned[spellName]))
			this:SetValue(profile.maxHealRanks[spellName])
		elseif id > 300 and id < 400 then
			this:SetMinMaxValues(1, table.getn(self.levelLearned[spellName]))
			this:SetValue(profile.minHealRanks[spellName])
		elseif id > 400 and id < 500 then
			this:SetMinMaxValues(1, table.getn(self.levelLearned[spellName]))
			this:SetValue(profile.minRaiseHealRanks[spellName])
		elseif id > 500 and id < 600 then
			this:SetMinMaxValues(0, 3)
			this:SetValue(profile.classPriorities[self.allClasses[normalId]])
		elseif id > 600 and id < 700 then
			local max = 3
			if normalId == 1 then max = 4 elseif normalId == 4 or normalId == 5 then max = 2 end
			this:SetMinMaxValues(0, max)
			this:SetValue(profile.messagePlaces[self.messageTypes[normalId]])
		elseif id > 700 and id < 800 then
			this:SetMinMaxValues(50, 150)
			this:SetValue(profile.classHealPercents[self.allClasses[normalId]])
		end

	end,

	Slider_OnValueChanged = function(self)
		local id = this:GetID()
		local profile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
		local value = this:GetValue()
		local normalId = id
		while (normalId > 100) do normalId = normalId - 100 end
		local spellName = nil
		if id > 100 and id < 500 then
			spellName = self.classSpellsOfInterest[self.class][normalId]
		end

		if id < 100 then
			profile[_smh_sliderTitleFormats[id][1]] = value
			if id == 5 then self:MiniMapButton_UpdatePosition() end
		elseif id > 100 and id < 200 then
			profile.overhealRanks[spellName] = value
		elseif id > 200 and id < 300 then
			profile.maxHealRanks[spellName] = value
		elseif id > 300 and id < 400 then
			profile.minHealRanks[spellName] = value
		elseif id > 400 and id < 500 then
			profile.minRaiseHealRanks[spellName] = value
		elseif id > 500 and id < 600 then
			profile.classPriorities[self.allClasses[normalId]] = value
		elseif id > 600 and id < 700 then
			profile.messagePlaces[self.messageTypes[normalId]] = value
		elseif id > 700 and id < 800 then
			profile.classHealPercents[self.allClasses[normalId]] = value
		end

		self:Slider_SetTitle(this)
	end,

	Slider_SetTitle = function(self, this)
		local id = this:GetID()
		local name = this:GetName()
		local profile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
		local normalId = id
		while (normalId > 100) do normalId = normalId - 100 end
		local spellName = nil
		if id > 100 and id < 500 then
			spellName = self.classSpellsOfInterest[self.class][normalId]
		end
		local theTitle = getglobal(name .. "Text")

		local outputString
		if id < 100 then
			local format = _smh_sliderTitleFormats[id][2]
			outputString = string.format(format, profile[_smh_sliderTitleFormats[id][1]])
		elseif id > 100 and id < 200 and spellName then
			outputString = string.format("%s: %s", spellName, profile.overhealRanks[spellName])
		elseif id > 200 and id < 300 and spellName then
			outputString = string.format("%s: %s", spellName, profile.maxHealRanks[spellName])
		elseif id > 300 and id < 400 and spellName then
			outputString = string.format("%s: %s", spellName, profile.minHealRanks[spellName])
		elseif id > 400 and id < 500 and spellName then
			outputString = string.format("%s: %s", spellName, profile.minRaiseHealRanks[spellName])
		elseif id > 500 and id < 600 then
			local className = self.allClasses[normalId]
			outputString = string.format("%s: %s", className, self.priorityLabels[profile.classPriorities[className] + 1])
		elseif id > 600 and id < 700 then
			local titleName = self.messageTitles[normalId]
			outputString = string.format("%s: %s", titleName, self.messageLabels[profile.messagePlaces[self.messageTypes[normalId]] + 1])
		elseif id > 700 and id < 800 then
			local className = self.allClasses[normalId]
			outputString = string.format("%s: %d%%", className, profile.classHealPercents[className])
		end
		if outputString then theTitle:SetText(outputString) end
	end,

	SpellButtons_Update = function(self)
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
		for i = 1, table.getn(currentProfile.defaultSpells), 1 do
			getglobal("com_mithrandir_smhAlgControl"..i).tooltiptext = currentProfile.defaultSpells[i][1]
			getglobal("com_mithrandir_smhAlgControl"..i):SetNormalTexture(self.defaultSpellIcons[currentProfile.defaultSpells[i][1]])
			getglobal("com_mithrandir_smhUseAlg"..i):SetChecked(currentProfile.defaultSpells[i][2])
		end
	end,

	SwapDefaultSpells = function(self, left, right)
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
		local temp = currentProfile.defaultSpells[left]
		currentProfile.defaultSpells[left] = currentProfile.defaultSpells[right]
		currentProfile.defaultSpells[right] = temp
		self:SpellButtons_Update()
	end,

	Tab_OnClick = function(self, tabId)
		if not tabId then tabId = this:GetID() end
		self:Tab_Set(tabId)
		local numberTabs = getn(_smh_optionTabs)
		for i = 1, numberTabs, 1 do
			if (i ~= tabId) then
				getglobal("com_mithrandir_smhTab" .. i):SetChecked(nil)
			else
				getglobal("com_mithrandir_smhTab" .. i):SetChecked(1)
			end
		end
		self:Frame_Update()
	end,

	Tab_Set = function(self, tabId)
		local reshowing = false
		if tabId == self.currentTab then reshowing = true end
		self.currentTab = tabId
		if (tabId == 9) then
			self:PriorityString()
		end
		if (tabId == 4) then
			self:CharacterPriorityButtons_Show()
		else
			self:CharacterPriorityButtons_Hide()
		end
		if (tabId == 3) then
			self:AlgorithmButtons_Show()
			self:SpellButtons_Update()
		else
			self:AlgorithmButtons_Hide()
		end
		if (tabId == 7) then
			self:ProfileButtons_Show()
		else
			self:ProfileButtons_Hide()
		end
		local numberUIElements = getn(self.uiElements)
		for i = 1, numberUIElements, 1 do
			if tabId == self.uiElements[i][2] then
				if reshowing then self.uiElements[i][1]:Hide() end
				self.uiElements[i][1]:Show()
			else
				self.uiElements[i][1]:Hide()
			end
		end
	end,

	TemplateButton_Profile = function(self, name, parent)
		local frame = CreateFrame("Button", name, parent, "GameMenuButtonTemplate")
		frame:SetWidth(170)
		frame:SetHeight(17)
		frame:SetScript("OnClick", function() self:MiniProfile_Set() end)
		frame:Hide()
		return frame
	end,

	--	This routine is only used for testing different things
	--	out and has no real purpose other than allowing me to
	--	have a test harness available relatively easily.
	Test = function(self)
	end,

	--	This routine casts the indicated spell at the highest
	--	level that mana permits and within the limits of the
	--	recipient's level.  It uses the rules set up in the 
	--	configuration preferences.
	TryBuffCast = function(self, spellName, who)
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
		local playerBuffs = self:UnitBuffs('player')
		local casterHasClearcasting = (playerBuffs[SMH_SPELL_CLEARCASTING] ~= nil)
		local casterHasInnerFocus = (playerBuffs[SMH_SPELL_INNER_FOCUS] ~= nil)
		local targetBuffs
		if (who == 'player') then targetBuffs = playerBuffs else targetBuffs = self:UnitBuffs(who) end
		local rankIndex = 1
		local trulyDesiredRank
		local myMana = UnitMana('player')
		if (nil == myMana) then myMana = 0 end
		local spellAttempted = false

		--	Find out what highest rank of spell we can cast
		while (true) do
			local spellInfo = self.cachedSpellBookData[spellName][rankIndex]
			if spellInfo then rankIndex = rankIndex + 1 else rankIndex = rankIndex - 1; break end
		end
		self:OutputMessage("DEBUG", "Highest rank ".. spellName .." known is "..rankIndex)
		if rankIndex < 1 then
			self:OutputMessage("INFO", string.format(SMH_INFORMATIVE_MESSAGE_SPELL_NONEXISTANTFORMAT, spellName))
			return true	-- this will short circuit any further attempts to cast this
		end

		--	Ensure we can cast this rank on the recipient
		trulyDesiredRank = rankIndex
		if (rankIndex > 0) then
			local targetLevel = UnitLevel(who)
			while (rankIndex > 0) do
				if (targetLevel + 10 >= self.cachedSpellTargetLevels[spellName][rankIndex]) then break end
				rankIndex = rankIndex - 1
			end
			if (trulyDesiredRank ~= rankIndex) then
				self:OutputMessage("DEBUG", "For "..spellName.." "..UnitName(who).." is only level "..targetLevel.." so had to reduce rank from "..trulyDesiredRank.." to rank "..rankIndex)
			end
		end

		--	Check to ensure we have enough mana to cast
		trulyDesiredRank = rankIndex
		if not casterHasClearcasting and not casterHasInnerFocus then
			while (rankIndex > 0) do
				if myMana >= self.cachedSpellBookData[spellName][rankIndex].mana then break end
				rankIndex = rankIndex - 1
			end
			if trulyDesiredRank ~= rankIndex then
				self:OutputMessage("DEBUG", "Wanted "..spellName.." rank "..trulyDesiredRank.." but mana limits us to rank "..rankIndex)
			end
		end

		if (not currentProfile.buffFailOnLowMana or rankIndex == trulyDesiredRank) and rankIndex > 0 then
			local spellId = self.cachedSpellBookData[spellName][rankIndex].id
			if (spellId ~= nil) then

				--	First we make sure the target does not have any of the (de)buffs
				--	that would disallow casting of this buff.
				local disallowers = self.buffCancels[spellName]
				local permitted = true
				if nil ~= disallowers then
					local tableSize = table.getn(disallowers)
					for i = 1, tableSize, 1 do
						if targetBuffs[disallowers[i]] ~= nil then permitted = false; break end
					end
				end

				--	Now we make sure the spell is not in cooldown
				if spellName == SMH_SPELL_POWER_WORD_SHIELD then
					if self.slotPowerWordShield ~= nil and not self:ActionNotInCooldown(self.slotPowerWordShield) then
						self:OutputMessage("INFO", string.format(SMH_INFORMATIVE_MESSAGE_COOLDOWNFORMAT, spellName))
						permitted = false
						return true	--	short circuits any other try to cast this
					end
				end

				--	Now we make sure the spell can be cast on "who"
				if spellName == SMH_SPELL_POWER_WORD_SHIELD then
					if who ~= 'player' and not self:UnitInGroup(who) then
						self:OutputMessage("DEBUG", "Cannot cast Power Word: Shield on "..UnitName(who).." because not in group.")
						permitted = false
					end
				end

				if permitted then
					if SpellIsTargeting() then SpellStopTargeting() end
					if who == 'player' then
						--	Note that when we self cast we do not check whether the buff is already present,
						--	just that any disallowing buffs (debuffs) are present.
						local targetName = nil

						if UnitExists('target') then
							if UnitIsFriend('target', 'player') then targetName = UnitName('target') end
						end
						self:OutputMessage("CAST", string.format(SMH_INFORMATIVE_MESSAGE_HEALINGFORMAT, spellName, rankIndex, UnitName('player')))
						if targetName ~= nil then TargetUnit('player') end
						CastSpell(spellId, SpellBookFrame.bookType)
						SpellTargetUnit('player')
						if not currentProfile.targetRecipient and targetName ~= nil then TargetByName(targetName) end
						spellAttempted = true
					else
						if targetBuffs[spellName] == nil then
							if UnitIsVisible(who) then
								local possibleStealthAllowed = true
								if not self:UnitInParty(who) then
									if targetBuffs[SMH_SPELL_PROWL] ~= nil or targetBuffs[SMH_SPELL_STEALTH] ~= nil or targetBuffs[SMH_SPELL_SHADOWMELD] ~= nil then
										possibleStealthAllowed = false
									end
								end
								if possibleStealthAllowed and targetBuffs[SMH_SPELL_DIVINE_INTERVENTION] == nil and targetBuffs[SMH_SPELL_PETRIFICATION] == nil and targetBuffs[SMH_SPELL_SPIRIT_OF_REDEMPTION] == nil and targetBuffs[SMH_SPELL_PHASE_SHIFT] == nil then

									-- Since we want to find the range we will set the target to the
									-- one we want to heal.  Therefore, we need to know whether we
									-- already had a target.
									local hadTarget = false
									local targetName = nil
									if (UnitExists('target')) then
										hadTarget = true
										if (UnitIsFriend('target', 'player')) then targetName = UnitName('target') end
									end
									TargetUnit(who)

									if (UnitIsUnit('target', who)) then
										local slotOfInterest = self.slotBuff
										if spellName == SMH_SPELL_POWER_WORD_SHIELD then slotOfInterest = self.slotPowerWordShield end
										if (slotOfInterest == nil or IsActionInRange(slotOfInterest) == 1) then
											self:OutputMessage("CAST", string.format(SMH_INFORMATIVE_MESSAGE_HEALINGFORMAT, spellName, rankIndex, UnitName(who)))
											CastSpell(spellId, SpellBookFrame.bookType)
											spellAttempted = true
										else
											self:OutputMessage("INFO", string.format(SMH_INFORMATIVE_MESSAGE_OORFORMAT, UnitName(who)))
										end
									else
										self:OutputMessage("INFO", string.format(SMH_INFORMATIVE_MESSAGE_CANNOT_TARGETFORMAT, UnitName(who)))
									end

									-- Since we actually set the target to the one we wanted to heal
									-- to be able to determine whether they are in range of our spell
									-- we have to reset the target to what it was before.  Note that
									-- the following line does not work.
									-- if (hadTarget) then TargetLastTarget() else ClearTarget() end
									if not currentProfile.targetRecipient then
										if (hadTarget) then
											if (targetName ~= nil) then TargetByName(targetName) else TargetLastEnemy() end
										else
											ClearTarget()
										end
									end
								else
									self:OutputMessage("INFO", string.format(SMH_INFORMATIVE_MESSAGE_STEALTHFORMAT, UnitName(who)))
								end
							else
								self:OutputMessage("INFO", string.format(SMH_INFORMATIVE_MESSAGE_INVISIBLEFORMAT, UnitName(who)))
							end
						else
							self:OutputMessage("DEBUG", UnitName(who).." already has "..spellName.." active.")
						end
					end
					if SpellIsTargeting() then SpellStopTargeting() end
				else
					self:OutputMessage("DEBUG", UnitName(who).." has a (de)buff that does not permit "..spellName.." to be cast.")
				end
			end
		end
		return spellAttempted
	end,

	TryToInsertUnitForHealing = function(self, tableName, unitName, parameterName, debugMessage)
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]
		local characterName = UnitName(unitName)
		self:ProcessOtherHeals()
		local possibleHealingForUnit = self.currentOtherHealsByCharacter[characterName]
		if possibleHealingForUnit == nil then possibleHealingForUnit = 0 end
		local currentHealth = UnitHealth(unitName) + possibleHealingForUnit * (currentProfile.otherHealerConfidence / 100)
		local maxHealth = UnitHealthMax(unitName)
		local percentHealth = currentHealth / maxHealth
		-- Only put damaged units that meet the damage threshold into the table.
		if (currentHealth < maxHealth and percentHealth < (currentProfile[parameterName] / 100.0)) then
			table.insert(tableName, 1, { id = unitName, percent = percentHealth, current = currentHealth, max = maxHealth })
			if (debugMessage ~= nil) then self:OutputMessage("DEBUG", debugMessage) end
		end
	end,

	--	This returns a table containing keys of the buff names.
	UnitBuffs = function(self, unitName)
		local retval = { }
		local texture, appliedCount, buffname
		for i = 0, 16, 1 do
			texture, appliedCount = UnitBuff(unitName, i)
			if texture then
				local realAppliedCount = tonumber(appliedCount)
				if realAppliedCount == 0 then realAppliedCount = 1 end	-- handles case when the buff is not stackable
				smhTooltip:SetUnitBuff(unitName, i)
				buffName = smhTooltipTextLeft1:GetText()
				if buffName then
					retval[buffName] = { ["count"] = realAppliedCount, ["lifetime"] = 0 }
					if buffName == SMH_SPELL_GREATER_BLESSING_OF_LIGHT or buffName == SMH_SPELL_BLESSING_OF_LIGHT then
						local description = smhTooltipTextLeft2:GetText()
						local one = self:PIFirst(description)
						local two = self:PISecond(description)
						if one and two then
							retval[buffName][SMH_SPELL_HOLY_LIGHT] = one
							retval[buffName][SMH_SPELL_FLASH_OF_LIGHT] = two
						end
					end
					if buffName == SMH_BUFF_UNSTABLE_POWER then
						local description = smhTooltipTextLeft2:GetText()
						local two = self:PISecond(description)
						if two then
							retval[buffName][SMH_BUFF_UNSTABLE_POWER] = two
						end
					end

					--	Now we record whether any of these buffs are ones indicating being mounted
					local description = smhTooltipTextLeft2:GetText()
					if description then
						local match, _, amount = string.find(description, _smh_MountPattern)
						if match ~= nil then
							retval[buffName]["mounted"] = true
						end
					end

					--	Now we determine whether any of these buffs disable casting
					if self.buffsCancellingCasting[buffName] then
						retval[buffName]["castStopping"] = true
					end
				end

			end
			texture, appliedCount = UnitDebuff(unitName, i)
			if texture then
				smhTooltip:SetUnitDebuff(unitName, i)
				local debuffName = smhTooltipTextLeft1:GetText()
				if debuffName then
					local realAppliedCount = tonumber(appliedCount)
					if realAppliedCount == 0 then realAppliedCount = 1 end
					retval[debuffName] = { ["count"] = realAppliedCount, ["lifetime"] = 0 }

					if self.debuffsCancellingCasting[debuffName] then
						retval[debuffName]["castStopping"] = true
					else
						--	Now check to see whether any of these are considered castStopping
						local lineCount = smhTooltip:NumLines()
						for j = 1, lineCount, 1 do
							local text = getglobal("smhTooltipTextLeft"..j)
							if text then
								local line = text:GetText()

								if line then
									for k, pattern in _smh_castDisablingPatterns do
										local match, _ = string.find(line, pattern)
										if (match ~= nil) then
											retval[debuffName]["castStopping"] = true
											break
										end
									end
								end
							end
						end
					end
				end
			end
		end

		--	Get the time left remaining for each of the (de)buffs
		if unitName == 'player' then
			local buffIndex
			local timeRemaining
			local buffName

			for i = 0, 32, 1 do
				buffIndex = GetPlayerBuff(i, "HELPFUL|HARMFUL|PASSIVE")
				if buffIndex >= 0 then
					smhTooltip:SetPlayerBuff(buffIndex)
					buffName = smhTooltipTextLeft1:GetText()
					if buffName and retval[buffName] then
						timeRemaining = GetPlayerBuffTimeLeft(buffIndex)
						retval[buffName]["lifetime"] = timeRemaining
					end
				end
			end
		end

		return retval
	end,

	--	This routine returns if the unitId is associated with the
	--	caster in a group (party or raid).
	UnitInGroup = function(self, unitId)
		local retval = (unitId == 'player' or unitId == 'pet')
		if not retval then retval = self:UnitInParty(unitId) end
		if not retval then retval = self:UnitInRaid(unitId) end
		return retval
	end,

	--	Note that UnitInParty will not return 1 if the unitId is
	--	a pet.  However, we want it to do so.  And now it appears
	--	as of patch 1.11.2 'player' is not considered part of the
	--	party either.  Starting in 1.12 we have new API to use.
	UnitInParty = function(self, unitId)
		return UnitPlayerOrPetInParty(unitId)
	end,

	--	Note that UnitInRaid will not return 1 if the unitId is
	--	a pet.  However, we want it to do so.
	UnitInRaid = function(self, unitId)
		return UnitPlayerOrPetInRaid(unitId)
	end,

	UnitIsHealable = function(self, unit)
		if not UnitExists(unit) then return false end
		if not UnitIsFriend('player', unit) then return false end
		if     UnitIsEnemy(unit, 'player') then return false end
		if     UnitCanAttack(unit, 'player') then return false end
		if     UnitCanAttack('player', unit) then return false end
		if     unit ~= 'player' and not UnitCanCooperate('player', unit) then return false end
		if not UnitIsConnected(unit) then return false end
		if     UnitIsDead(unit) then return false end
		if     UnitIsGhost(unit) then return false end
		return true
	end,

	UpdateSpiritualGuidanceData = function(self)
		local base, current, posBuff, negBuff = UnitStat('player', 5)
		self.spiritualGuidanceModification = current * self.spritualGuidanceTalentRank / 20
		self:UpdateTotalPlusHealingText()
	end,

	UpdateTotalPlusHealingText = function(self)
		local outputString = nil
		local outputColor = self.colorGreen
		if self.hasBrokenPlusHealingItems then outputColor = self.colorRed end

		outputString = string.format(SMH_TOTAL_EXTRA_HEALING_FORMAT, outputColor, self.extraHealingAmount, self.colorStop)
		if self.spritualGuidanceTalentRank > 0 then
			outputString = outputString .. string.format(SMH_SG_HEALING_FORMAT, self.spiritualGuidanceModification)
		end

		com_mithrandir_smhEquipmentHealing:SetText(outputString)
	end,

	WhichPriorityLevel = function(self, classModifier, isParty)
		local retval = classModifier + 1
		local currentProfile = SMH_Configuration.profiles[SMH_Configuration.currentProfile]

		if isParty then
			if classModifier == 3 then
				if currentProfile.classPriorityOverParty then
					retval = 7
				elseif currentProfile.partyOverRaid then
					retval = 6
				else
					retval = 5
				end
			elseif classModifier == 2 then
				if currentProfile.partyOverRaid then
					retval = 6
				end
			end
		else
			if classModifier == 3 then
				if currentProfile.classPriorityOverParty then retval = 7 else retval = 5 end
			end
		end
		return retval
	end,

	}
end
